#include "items\items.h"

object randItemModels[MAX_LOADED_RANDITEMS];
object itemModels[MAX_ITEMS];
object buttonModels[MAX_BUTTONS];

aref useLocators[MAX_BUTTONS];
aref useAttrs[MAX_BUTTONS];
int  useLocatorsCount=0;

float SPAWN_TIME = 168.0; //hours = 168.0

void Items_LoadModel (ref _itemModel, ref _item)
{
	if (!IsEntity(_itemModel))
	{
		string itemFolder = "items";
		CreateEntity(&_itemModel, "MODELR");
		if (CheckAttribute(_item, "folder"))
			itemFolder = _item.folder;
		SendMessage(&_itemModel, "ls", MSG_MODEL_SET_DIRPATH, itemFolder+"\\"); // qf)")
		SendMessage(&_itemModel, "ls", MSG_MODEL_LOAD_GEO, itemFolder + "\\" + _item.model);
		SendMessage(&_itemModel, "ls", MSG_MODEL_SET_DIRPATH,"");
		// NK set blades diff -->
		// 05-07-13 do for pistols as well
		if(HasSubStr(_item.model, "blade") || HasSubStr(_item.model, "pistol")) SendMessage(&_itemModel, "ls", MSG_MODEL_SET_TECHNIQUE, "BladeItem");
		else SendMessage(&_itemModel, "ls", MSG_MODEL_SET_TECHNIQUE, "RandItem");
		// NK <--
		LayerAddObject("execute", &_itemModel, ITEMS_LAYER);
		LayerAddObject("realize", &_itemModel, ITEMS_LAYER);

		Trace("ItemLogic: Loaded model "+itemFolder+"\\"+_item.model);
	}
}

void Item_OnLoadLocation(string currentLocation)
{
	Trace("ItemLogic: On load location "+currentLocation);
	// boal cabin -->
	if (bCabinStarted) return;
	// boal cabin <--

	// precache active locators in current location
	aref   activeLocation;
	ref chr = GetMainCharacter();
	int currentLocationIndex = FindLocation(currentLocation);
	chr.itemLocationIndex = currentLocationIndex;
	aref aloc, an, al;
	useLocatorsCount = 0;
	makearef(activeLocation, Locations[currentLocationIndex]);
	makearef (aloc, activeLocation.items);
	for (int i=0; i<GetAttributesNum(aloc); i++)
	{
		an = GetAttributeN(aloc, i);
		if (!CheckAttribute(an,"locator"))
			continue;
		if (!FindLocator(activeLocation.id, an.locator, &al, true))
			continue;

		useLocators[useLocatorsCount] = al;
		useAttrs[useLocatorsCount] = an;
		useLocatorsCount++;
	}

	// load buttons & items
	Items_ShowButtons(currentLocation);

	// PB: Treasure Quests -->
	if(!CheckAttribute(activeLocation, "locators.box.treasure_box"))
		RandItems_OnLoadLocation(activeLocation);
	// PB: Treasure Quests <--
	Box_OnLoadLocation(activeLocation);

	for (int itemN=0; itemN<ITEMS_QUANTITY; itemN++)
	{
		if (!CheckAttribute(Items[itemN], "startLocator"))
			continue;
		if (!CheckAttribute(Items[itemN], "startLocation"))
			continue;
		if (!CheckAttribute(Items[itemN], "shown"))
			continue;
		if (Items[itemN].shown == "1")
		{
		if (Items[itemN].startLocation == currentLocation)
		{
			Items_ShowItem(itemN);
		}}
	}
}

void Item_OnUnLoadLocation()
{
	Trace("ItemLogic: On unload location");
	for (int itemN=0; itemN<ITEMS_QUANTITY; itemN++)
	{
		if (IsEntity(&itemModels[itemN]))
			DeleteClass(&itemModels[itemN]);
	}
	for (int buttonN=0; buttonN<MAX_BUTTONS; buttonN++)
	{
		if (IsEntity(&buttonModels[buttonN]))
			DeleteClass(&itemModels[buttonN]);
	}

	RandItems_OnUnloadLocation();

	ref chr = GetMainCharacter();
	chr.itemLocationIndex = -1;
}

void Item_OnEnterLocator(aref _location, string _locator)
{
	ref chr = GetMainCharacter();
	int itemN;
	if (HasSubStr(_locator, "button"))
	{ // use item
		if(HasSubStr(_locator, "666") || HasSubStr(_locator, "999") || HasSubStr(_locator, "777"))
		{//MAXIMUS: by this way we can use any action
			chr.activeItem = -1;
			chr.activeLocator = _locator;
			chr.activeRandItem = false;
			chr.activeItem.pick = false;
			chr.activeItem.Action = "Action";
			chr.activeItem.Action.label = "alarm_bell";
			if(!HasSubStr(_locator, "999") && !HasSubStr(_locator, "777")) { Log_SetActiveAction(chr.activeItem.Action); }
			else
			{
				if(HasSubStr(_locator, "777"))
				{
					chr.activeItem.Action.label = "hidden_treasure";
					if(!CheckAttribute(chr,"location.first") && !bSeaActive) Log_SetActiveAction(chr.activeItem.Action);
				}
				if(HasSubStr(_locator, "666"))
				{
					chr.activeItem.Action.label = "steering_wheel";
					if(!CheckAttribute(chr,"location.first") && !bSeaActive) Log_SetActiveAction(chr.activeItem.Action);
				}
			}
		}
		else { traceif("ItemLogic: Entered locator "+_locator);
		for (itemN=0; itemN<ITEMS_QUANTITY; itemN++)
		{
			if (!CheckAttribute(Items[itemN], "useLocator"))
				continue;
			if (!CheckAttribute(Items[itemN], "useLocation"))
				continue;
			if (!CheckAttribute(Items[itemN], "shown"))
				continue;
			if (Items[itemN].shown == "0")
			{
			if (Items[itemN].useLocation == _location.id)
			{
			if (Items[itemN].useLocator == _locator)
			{
// KK -->
				if (_location.id == "Labirint_3" && CheckAttribute(_location, "filespath.models") == true && HasSubStr(_location.filespath.models, "Incas Temple\Labirint") == true && _locator == "button01")
					chr.activeItem.Action = "Idol";
				else
					chr.activeItem.Action = "Action";
// <-- KK
				Log_SetActiveAction(chr.activeItem.Action);
				chr.activeItem = itemN;
				chr.activeLocator = _locator;
				chr.activeRandItem = false;
				chr.activeItem.pick = false;
			}}}
		}}
	}
	else
	{traceif("ItemLogic: Entered locator "+_locator);
		for (itemN=0; itemN<ITEMS_QUANTITY; itemN++)
		{
			if (!CheckAttribute(Items[itemN], "startLocator"))
				continue;
			if (!CheckAttribute(Items[itemN], "startLocation"))
				continue;
			if (!CheckAttribute(Items[itemN], "shown"))
				continue;
			if (Items[itemN].startLocator == _locator)
			{
			if (Items[itemN].shown == "1")
			{
			if (Items[itemN].startLocation == _location.id)
			{
				chr.activeItem.Action = "Pick";
				Log_SetActiveAction(chr.activeItem.Action);
				chr.activeItem = itemN;
				chr.activeLocator = _locator;
				chr.activeRandItem = false;
				chr.activeItem.pick = true;
			}}}
		}
	}
	BLI_RefreshCommandMenu();
}

void Item_OnExitLocator()//MAXIMUS: was (aref _location, string _locator) - for what?
{
	Log_SetActiveAction("Nothing");
	//Characters[GetMainCharacterIndex()].activeItem = "";
	if(CheckAttribute(GetMainCharacter(),"activeItem.update")) DeleteAttribute(GetMainCharacter(),"activeItem.update");
	if(CheckAttribute(GetMainCharacter(),"activeItem")) DeleteAttribute(GetMainCharacter(),"activeItem");
	BLI_RefreshCommandMenu();
}

void Item_OnPickItem()
{
	aref activeLocation;
	ref chr = GetMainCharacter();
	if ( !CheckAttribute(chr,"itemLocationIndex") || sti(chr.itemLocationIndex) < 0 ) return;// TIH runtime error fix - do nothing if item picked up didnt exist (happens in cabins for some reason) Jul22'06
	/*makearef(activeLocation, Locations[sti(chr.itemLocationIndex)]);

	string displayItemName, youvegotString;
	youvegotString = TranslateString("", "you've_got");

	int activeItem = -1; // KK
	if (sti(chr.activeRandItem) == true) {
		string activeRandItemAttribute = "RandItemType"+sti(chr.activeItem);
		if (CheckAttribute(activeLocation, activeRandItemAttribute)) {
			activeItem = sti(activeLocation.(activeRandItemAttribute)); // KK
			displayItemName = TranslateString("", Items[activeItem].name);
		}
	} else {
		activeItem = sti(chr.activeItem);
		displayItemName = TranslateString("", Items[activeItem].name);
	}
	if (CheckAttribute(&Items[activeItem], "QualityName")) displayItemName = TranslateString("", Items[activeItem].QualityName) + " " + displayItemName; // KK
	chr.activeItem.label = youvegotString+" "+displayItemName+"!";*/

//JRH -->
	if(GetStoryline(FindCurrentStoryline()) == "WoodesRogers" || GetStoryline(FindCurrentStoryline()) == "Bartolomeu")
   	{
		Log_SetActiveAction("Nothing");
		makearef(activeLocation, Locations[sti(chr.itemLocationIndex)]);

		string displayItemName, youvegotString;
		youvegotString = TranslateString("", "you've_got");

		if (chr.activeRandItem == true)
		{
			string activeRandItemAttribute = "RandItemType"+sti(chr.activeItem);
			if (CheckAttribute(activeLocation, activeRandItemAttribute))
			{
	//------------------------------------------------------------------------------------------------------------
				if(Items[sti(activeLocation.(activeRandItemAttribute))].id == "koster1"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "koster3"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "koster4")
				{
					if(CheckCharacterItem(chr,"pistollog"))
					{
						Logit(TranslateString("","They are really heavy - one is enough!"));
						PlaySound("AMBIENT\JAIL\sigh.wav");
						PlaySound("AMBIENT\JAIL\sigh.wav");
						return;
					}
				}
	//------------------------------------------------------------------------------------------------------------
				SendMessage(&randItemModels[sti(chr.activeItem)], "lslff", MSG_MODEL_BLEND, "blenditemlit", 1000, 1.0, 0.0);
				GiveItem2Character(GetMainCharacter(), Items[sti(activeLocation.(activeRandItemAttribute))].id);

				displayItemName = TranslateString("", Items[sti(activeLocation.(activeRandItemAttribute))].name);

				if(Items[sti(activeLocation.(activeRandItemAttribute))].id == "barrel_big" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "sack"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "brF13" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "toolchest1"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "brF14R" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "basket"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "brF4R" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "brderrick"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "koster1" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "koster3"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "koster4" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "cannonball_box2"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "cannonball_box" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "hatch2"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "plank3" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "mdchest"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "surgery_kit" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "cauldron1"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "temp_plank0" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "plank1_long"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "plank2_long" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "chestmap1"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "dummy_belt" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "lockpick_JRH"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "megaphone" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "boathook"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "musket_item" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "spyglass5"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "mtoon_item" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "pillow"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "fire_irons_item" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "lever_item"
				|| Items[sti(activeLocation.(activeRandItemAttribute))].id == "cannonball2" || Items[sti(activeLocation.(activeRandItemAttribute))].id == "clockkey")
				{

				}
				else Log_SetStringToLog(youvegotString+" "+displayItemName+"!");

				activeLocation.(activeRandItemAttribute) = -1;
			}
		}
		else
		{
			int activeItem = sti(chr.activeItem);
			Trace("ItemLogic: picking item "+Items[activeItem].id);
			Items[activeItem].shown = false;
			SendMessage(&itemModels[activeItem], "lslff", MSG_MODEL_BLEND, "blenditemlit", 1000, 1.0, 0.0);
			GiveItem2Character(GetMainCharacter(), Items[activeItem].id);

			displayItemName = TranslateString("", Items[activeItem].name);
		 	Log_SetStringToLog(youvegotString+" "+displayItemName+"!");
		}

		DeleteAttribute(chr,"activeItem");
//<-- JRH
   	}
    	else LaunchInfoScreen();
}

void DoAction()
{
	string snd = GetEventData();
	DelEventHandler("bAction","DoAction");

	switch(snd)
	{
		case "AMBIENT\TOWN\Alarm.wav":
		break;

		case "NATURE\windmill.wav":
		break;

		case "AMBIENT\SHIP\parusa_hlp_002.wav":
			LaunchInfoScreen();
		break;
	}
}

void Item_OnUseItem()
{
	aref aloc, an, al;

	aref activeLocation;
	ref chr = GetMainCharacter();
	int activeItem = sti(chr.activeItem);
	if(activeItem==-1)
	{
		SetEventHandler("bAction","DoAction",1);
		string snd = "";
		float up = 0.0;
		if(HasSubStr(chr.activeLocator,"666")) { up = 1.8; snd = "AMBIENT\TOWN\Alarm.wav"; PostEvent("bAction",3000,"s",snd); }//MAXIMUS: IDEA!!! During mutiny-fight, for example, player can call his loyal crew for help
		if(HasSubStr(chr.activeLocator,"999")) { up = 1.3; snd = "NATURE\windmill.wav"; PostEvent("bAction",3000,"s",snd); }//MAXIMUS: Here we can make SeaLoad
		if(HasSubStr(chr.activeLocator,"777")) { up = 2.0; snd = "AMBIENT\SHIP\parusa_hlp_002.wav"; PostEvent("bAction",200,"s",snd); }
		PlayLocatorSound(&Locations[sti(chr.itemLocationIndex)], "item", chr.activeLocator, snd, up);
		return;
	}
	makearef(activeLocation, Locations[sti(chr.itemLocationIndex)]);

	makearef (aloc, activeLocation.items);
	Log_SetActiveAction("Nothing");
	Log_SetStringToLog(XI_ConvertString("Using") + " " + XI_ConvertString(Items[activeItem].id));
	Trace("ItemLogic: using item "+Items[activeItem].id);
	Items[activeItem].shown = true;
	Items_LoadModel(&itemModels[activeItem], &Items[activeItem]);

	for (int i=0; i<GetAttributesNum(aloc); i++)
	{
		an = GetAttributeN(aloc, i);
		if (an.locator == chr.activeLocator)
			break;
	}

	FindLocator(activeLocation.id, chr.activeLocator, &al, true);
	SendMessage(&itemModels[activeItem], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y)+makefloat(an.itemDeltaY), makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));
	SendMessage(&itemModels[activeItem], "lslff", MSG_MODEL_BLEND, "blenditem", 1000, 0.0, 1.0);

	SetEventHandler("frame", "Item_OnUseFrame", 0);
	TakeItemFromCharacter(GetMainCharacter(), Items[activeItem].id);
	Items[activeItem].startLocator = "";
	an.trigged = true;
	al.active = true;
	al.timePassed = 0;

	DeleteAttribute(chr,"activeItem");

	CompleteQuestName("OnUse_"+Items[activeItem].id);
}

void Item_OnUseFrame()
{
	aref aloc, an, al;
	aref activeLocation;
	ref chr = GetMainCharacter();
	makearef(activeLocation, Locations[sti(chr.itemLocationIndex)]);

	makearef (aloc, activeLocation.items);
	bool usedOnFrame=false;
	for (int i=0; i<useLocatorsCount; i++)
	{
		an = useAttrs[i];
		al = useLocators[i];
		if (!CheckAttribute(al, "active"))
			continue;
		if (al.active != "1")
			continue;
		int timePassed = sti(al.timePassed) + GetDeltaTime();
		al.timePassed = timePassed;
		if (timePassed > BUTTON_ACTIVATION_TIME)
		{
			al.active = false;
			continue;
		}

		usedOnFrame = true;
		float timeK = makefloat(timePassed) / makefloat(BUTTON_ACTIVATION_TIME);
		float deltaY = makefloat(an.deltaY) * timeK;

		SendMessage(&buttonModels[i], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y)+deltaY, makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));

		for (int j=0; j<ITEMS_QUANTITY; j++)
		{
			if (Items[j].useLocator == an.locator)
			{
				SendMessage(&itemModels[j], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y)+makeFloat(an.itemDeltaY)+deltaY, makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));
				break;
			}
		}
	}

	if (!usedOnFrame)
		DelEventHandler("frame", "Item_OnUseFrame");
}

void Items_ShowButtons(string _locationName)
{
	aref al;
	Trace("ItemLogic: found "+useLocatorsCount+" buttons");
	for (int i=0; i<useLocatorsCount; i++)
	{
		Items_LoadModel(&buttonModels[i], &useAttrs[i]);
		al = useLocators[i];
		if (useAttrs[i].trigged != "1")
			SendMessage(&buttonModels[i], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y), makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));
		else
			SendMessage(&buttonModels[i], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y)+makefloat(useAttrs[i].deltaY), makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));
	}
}

void Items_ShowItem(int _itemN)
{
	aref al;
	aref activeLocation;
	ref chr = GetMainCharacter();
	makearef(activeLocation, Locations[sti(chr.itemLocationIndex)]);

	if (Items[_itemN].model == "")
	{
		Trace("ItemLogic: no model for item "+activeLocation.id+"."+Items[_itemN].id);
		return;
	}

	if (Items[_itemN].startLocator != "")
	{ //unused
		Items_LoadModel(&itemModels[_itemN], &Items[_itemN]);

		if (!FindLocator(Items[_itemN].startLocation, Items[_itemN].startLocator, &al, true))
			Trace("ItemLogic: locator for item "+_itemN+" not found! ["+Items[_itemN].startLocation+">>"+Items[_itemN].startLocator);
		Trace ("ItemLogic: showing item at "+al.x+", "+al.y+", "+al.z);
		SendMessage(&itemModels[_itemN], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y), makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));
	}
	else
	{ //used
		if (Items[_itemN].useLocation != activeLocation.id)
			return;

		Items_LoadModel(&itemModels[_itemN], &Items[_itemN]);

		for (int i=0; i<useLocatorsCount; i++)
		{
			al = useLocators[i];
			if (useAttrs[i].locator == Items[_itemN].useLocator)
			{
				SendMessage(&itemModels[i], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y)+makeFloat(useAttrs[i].itemDeltaY)+makeFloat(useAttrs[i].deltaY), makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));
				return;
			}
		}
	}
}

void Items_HideItem(int itemN)
{
}

int Items_FindItem(string itemID, ref itemARef)
{
	// NK -->
	// 04-09-08 let's try again. :)
	/*aref curItem;
	for(int i=0; i<ITEMS_QUANTITY; i++)
	{
		makearef(curItem,Items[i]);
		if( curItem.id == itemID )
		{
			itemARef = curItem;
			return i;
		}
	}*/
	int i = GetItemIndex(itemID);
	//trace("Finding item " + itemID + ", has index " + i);
	if(i >= 0 && i < ITEMS_QUANTITY) //{ itemARef = &Items[i]; return i; //}
	{ makearef(itemARef, Items[i]); return i; }
	// NK <--
	return -1;
}

// NK 04-09-08 added general GetItemIndex() using NativeFindCharacter()
int GetItemIndex(string id)
{
	int i = NativeFindCharacter(&Items, id);
	if(i >= 0 && i < ITEMS_QUANTITY) { return i; }
	//trace("GetItemIndex: item " + id + " not found!");
	return -1;
}
// NK <--
// ************** RANDOM ITEMS *****************
void RandItems_OnLoadLocation(ref _location)
{
	string locatorName;
	aref randItemLocator;
	for (int i=1; i<MAX_LOADED_RANDITEMS; i++)
	{
		string lastSpawnTimeString = "LastSpawnTime"+i;
		string randItemTypeString = "RandItemType"+i;
		locatorName = "randitem"+i;
		if (!FindLocator(_location.id, locatorName, &randItemLocator, true))
			break;

		// randitem locator found
		if (CheckAttribute(_location, lastSpawnTimeString))
		{ // already spawned?
			if (CheckAttribute(_location, randItemTypeString))
			{
				if (sti(_location.(randItemTypeString)) != -1)
				{
					RandItems_DrawRandItem(i, _location, randItemLocator);
				}
				else
				{ //already picked up, try to respawn
					if ((stf(_location.(lastSpawnTimeString))+SPAWN_TIME) < Items_MakeTime(GetTime(), GetDataDay(), GetDataMonth(), GetDataYear()))
					{
						RandItems_SpawnRandItem(i, _location, randItemLocator);
					}
				}
			}
			else
			{ // nothing here
				if ((stf(_location.(lastSpawnTimeString))+SPAWN_TIME) < Items_MakeTime(GetTime(), GetDataDay(), GetDataMonth(), GetDataYear()))
				{
					RandItems_SpawnRandItem(i, _location, randItemLocator);
				}
			}
		}
		else
		{
			RandItems_SpawnRandItem(i, _location, randItemLocator);
		}
	}
}

void RandItems_OnUnloadLocation()
{
	for (int itemN=0; itemN<MAX_LOADED_RANDITEMS; itemN++)
	{
		if (IsEntity(&randItemModels[itemN]))
			DeleteClass(&randItemModels[itemN]);
	}
}

float Items_MakeTime (float _h, float _d, float _m, float _y)
{
	return (_h+24.0*(_d + 30.0*(_m + 12.0*_y)));
}

void RandItems_SpawnRandItem(int _index, aref _location, aref al)
{
	aref randItem;
	string lastSpawnTimeString;
	int n = -1; // TIH initialize Aug24'06

	string alName = GetAttributeName(al);
	string alNameAttribute = "items."+alName;
	// NK temporarily locations with named rand items will ignore the name. BUT if ID == blade1, will still gen that.
	// NK 05-03-25 fix this so it checks location's randitemsstay attribute.
	bool generate = true;// TIH name change for clarity
	if (CheckAttribute(_location, alNameAttribute))
	{
		// TIH --> logic fix
		bool locSetItem = false;
		if ( RANDOM_DUNGEON_BLADES == 0 ) { locSetItem = true; }
		if ( CheckAttribute(_location,"randitemsstay") && sti(_location.randitemsstay) ) { locSetItem = true; }
		if ( locSetItem )
		{
			generate = false;
			n = Items_FindItem(_location.items.(alName), &randItem);
			if (n == -1) return;
			lastSpawnTimeString = "LastSpawnTime"+_index;
			_location.(lastSpawnTimeString) = Items_MakeTime(0, 15, 1, 2003);
		}
		// TIH <--
	}
	// else
	if(generate)
	{
		// NK <--
		// TIH --> rpg_style only
		// use 'rare' in the formula for spawning a random item (adjusted scale)
		// also will try at least RARE_RAND_RETRIES times to find an item (instead of just once)
		// Nov21'06 fix: 'n' has now been set to -1 when it fails a check, so that the prior value of 'n' doesn't
		// simply carry through to the end of the function, thus spawning an item that failed the checks!
		if ( IT_RPG_STYLE ) {
			int 	nn;
			float 	itemProb
			bool 	itmSelected = false;
			int		levelCut = makeint(RARE_MAXLEVEL_ABOVE + GetLevel(GetMainCharacter()) + makeint(GetCharacterSkill(GetMainCharacter(),SKILL_SNEAK) / 2));
			for ( nn = 0; nn < RARE_RAND_RETRIES; nn++) {
				n = Items_FindItem(RandItems[rand(RANDITEMS_QUANTITY-1)].id, &randItem);
				if ( n == -1 ) continue;
				if ( CheckAttribute(randItem, "model") && randItem.model == "" ) {n = -1;continue;} // Nov21'06 // cant use items without models
				if ( RARE_MAXLEVEL_ABOVE > 0 && sti(randItem.minlevel) > levelCut ) {n = -1;continue;} // Nov21'06 // cant use item if too much higher than player
				if ( CheckAttribute(randItem, "rare") )
				{
					// TIH locator items are rare to begin with, so we beef the probability with pure luck:
					itemProb = stf(randItem.rare) * makefloat(GetCharacterSkill(GetMainCharacter(),SKILL_SNEAK));
					if ( rand(1000) > (itemProb*1000) ) {n = -1;continue;} // Nov21'06 // its 1000 for a reason
				}
				if ( n >= 0 ) break; // Nov21'06 // if we get this far, then we have a candidate!
			}
			// TIH --> last ditch effort to give them SOMETHING Aug24'06
			if ( n == -1 && frnd() > 0.5 )
			{
				switch ( rand(6) )
				{
					case 0: n = Items_FindItem("100gp", &randItem); break;
					case 1: n = Items_FindItem("250gp", &randItem); break;
					case 2: n = Items_FindItem("potion1", &randItem); break;
					case 3: n = Items_FindItem("potion3", &randItem); break;
					case 4: n = Items_FindItem("indian4", &randItem); break;
					case 5: n = Items_FindItem("indian3", &randItem); break;
					case 6: n = Items_FindItem("pistolrock", &randItem); break;
				}
			}
			// TIH <--
			if (n == -1) return; // TIH die on failed find Nov21'06
		} else {
			// prior basic method
			n = Items_FindItem(RandItems[rand(RANDITEMS_QUANTITY-1)].id, &randItem);
			if (n == -1) return; // TIH die on failed find Nov21'06
		}
		// TIH <--

		lastSpawnTimeString = "LastSpawnTime"+_index;
		_location.(lastSpawnTimeString) = Items_MakeTime(GetTime(), GetDataDay(), GetDataMonth(), GetDataYear());
	}

	if (!CheckAttribute(randItem, "model")) // Sulan: bugfix
	{
		Trace("ItemLogic -> randItem spawn: no model for item "+_location.id+"."+randItem.id);
		return;
	}

	Items_LoadModel(&randItemModels[_index],  randItem);
	SendMessage(&randItemModels[_index], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y), makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));

	lastSpawnTimeString = "RandItemType"+_index;
	_location.(lastSpawnTimeString) = n;
}

void RandItems_DrawRandItem(int _index, aref _location, aref al)
{
	string randItemTypeString = "RandItemType"+_index;
// KK -->
	if (!CheckAttribute(_location, randItemTypeString)) {
		trace("ItemLogic -> randItem draw: missing attribute " + randItemTypeString + " in location " + _location.id);
		return;
	}
// <-- KK
	int n = sti(_location.(randItemTypeString));
	if (n < 0) return; // KK

	if (Items[n].model == "")
	{
		Trace("ItemLogic -> randItem draw: no model for item "+_location.id+"."+Items[n].id);
		return;
	}

	Items_LoadModel(&randItemModels[_index],  &Items[n]);
	SendMessage(&randItemModels[_index], "lffffffffffff", MSG_MODEL_SET_POSITION, makeFloat(al.x), makeFloat(al.y), makeFloat(al.z), makeFloat(al.vx.x), makeFloat(al.vx.y), -makeFloat(al.vx.z), makeFloat(al.vy.x), makeFloat(al.vy.y), -makeFloat(al.vy.z), makeFloat(al.vz.x), makeFloat(al.vz.y), -makeFloat(al.vz.z));
}

void RandItem_OnEnterLocator(aref _location, string _locator)
{
	int randIndex = sti(strcut(_locator, 8, strlen(_locator)-1));
	string randItemAttribute = "RandItemType"+randIndex;
	ref chr = GetMainCharacter();
	if (CheckAttribute(_location, randItemAttribute))
	{
		int currentType = sti(_location.(RandItemAttribute));
		if (currentType != -1)
		{
			chr.activeItem.Action = "Pick";
			Log_SetActiveAction(chr.activeItem.Action);
			Log_SetActionLabel(TranslateString("", "Item"));
			chr.activeItem = randIndex;
			chr.activeLocator = _locator;
			chr.activeRandItem = true;
			chr.activeItem.pick = true;
			BLI_RefreshCommandMenu();
		}
	}
}

// ****************** BOXES ********************
void Box_EnterToLocator(aref loc, string locName)
{
	if(!bCabinStarted && !CheckAttribute(loc,locName)) return; // KK
	if (HasSubStr(locName, "private"))
	{ // check if private box opened
		if (!CheckAttribute(loc, locName+".opened")) return;
		if (sti(loc.(locName).opened) != true) return; // KK
	}

	ref chr = GetMainCharacter();
	chr.boxname = locName;

	//MAXIMUS: moved here for preventing wrong action showing -->
	Log_SetActiveAction("OpenBox");
	//MAXIMUS: moved here for preventing wrong action showing <--

	if (ENABLE_AMMOMOD) {// TIH --> mod toggle 7-7-06
// added by MAXIMUS [for gunpowder barrels] -->
		string locType = strcut(locName, 0, strlen(locName)-3);
		string locCur = Locations[FindLocation(chr.location)].filespath.models;
		string locBoard = strcut(locCur, 0, strlen(locCur)-2);
// KK -->
		string barrel = "Carefully! It's a very dangerous barrel!!!";
		string storage = "GUNPOWDER STORAGE. Be careful with opened fire!";
// added by MAXIMUS [for gunpowder barrels] <--

		if (HasSubStr(locName, "box")) {
			Log_SetActiveAction("OpenBox");
			if (ownDeckStarted()) {
				chr.boxname.boxlabel = "SeaBox";
			} else {
				if (LAi_IsBoardingProcess() && !IsFort && !IsTown)
					chr.boxname.boxlabel = "SeaBox";
				else
				{
					if(GetStoryline(FindCurrentStoryline()) == "WoodesRogers")
   					{
						chr.boxname.boxlabel = "";//JRH skip text Chest on "boxes"
					}
					else
					{
						if(GetStoryline(FindCurrentStoryline()) == "Bartolomeu")
						{
							if(chr.location == "Admiral_Office" || chr.location == "Governor_Daughter_House")
							{
								chr.boxname.boxlabel = "";//JRH skip text Chest on "boxes"
							}
							else chr.boxname.boxlabel = "ItemsBox";
						}
					}
					else chr.boxname.boxlabel = "ItemsBox";
				}
			}
			if (!CheckAttribute(chr,"BoxName.update")) Event("procChrOpenBox", "s", chr.boxname.boxlabel);
		}
		if (locName == "weaponslocker")
		{
			Log_SetActiveAction("OpenWeaponsLocker");
			chr.boxname.boxlabel = locName;
			if(!CheckAttribute(chr,"BoxName.update")) Event("procChrOpenBox", "s", locName);
		}
		if (locType == "gunpowder") {
			if (locName == "gunpowder_1") {
				if (LAi_IsBoardingProcess()) {
					if (HasSubStr(chr.location, "BOARDING_")) { // KK
						//Log_SetStringToLog(storage);
						Log_SetActiveAction("OpenBarrel");
						if(!CheckAttribute(chr,"BoxName.update")) Event("procChrOpenBox", "s", storage);
					} else {
						CheckReloadAction(chr, "");//MAXIMUS
						if(HasSubStr(locBoard,"locations\decks\udec")) {
							//Log_SetStringToLog(barrel);
							Log_SetActiveAction("OpenBarrel");
							if(!CheckAttribute(chr,"BoxName.update")) Event("procChrOpenBox", "s", barrel);
						}
					}
				} else {
					if (bDeckStarted) {
						if (HasSubStr(locBoard, "locations\decks\udec")) {
							//Log_SetStringToLog(barrel);
							Log_SetActiveAction("OpenBarrel");
							if(!CheckAttribute(chr,"BoxName.update")) Event("procChrOpenBox", "s", barrel);
						} else {
							//Log_SetStringToLog(storage);
							Log_SetActiveAction("OpenBarrel");
							if(!CheckAttribute(chr, "BoxName.update")) Event("procChrOpenBox", "s", storage);
						}
					}
				}
			} else {
				if (HasSubStr(locBoard, "locations\decks\udec")) {
					//Log_SetStringToLog(barrel);
					Log_SetActiveAction("OpenBarrel");
					if(!CheckAttribute(chr, "BoxName.update")) Event("procChrOpenBox", "s", barrel);
				} else {
					Log_SetActiveAction("Nothing");
				}
			}
		}
	} else {
		Log_SetActiveAction("Action");
	}// TIH <-- mod toggle
// <-- KK
	BLI_RefreshCommandMenu();

	// ccc Nov05 Greater Oxbay
	if(loc.id=="Greenford_M_crypt") // PB
	{
		PlaySound("people\step_sand.wav");
		Logit(TranslateString("","Looks like someone has been digging here.."));
		if(GetCharacterEquipByGroup(chr,BLADE_ITEM_TYPE) == "Minersspade" && CheckCharacterItem(chr, "Minersspade"))
			Logit(TranslateString("","Do you want to dig as well? With your ") + " " + GetItemNameByID(chr.equip.blade) + "???"));
		else
			LogIt(TranslateString("","What am I going to dig with? My HANDS? I need a spade!"));
	}
}

void Box_ExitFromLocator();//MAXIMUS: was (aref loc, string locName) - for what?
{
	if(CheckAttribute(GetMainCharacter(),"boxname.boxlabel")) DeleteAttribute(GetMainCharacter(),"boxname.boxlabel");
	if(CheckAttribute(GetMainCharacter(),"boxname")) DeleteAttribute(GetMainCharacter(),"boxname");
	Log_SetActiveAction("Nothing");
	BLI_RefreshCommandMenu();
}

void OpenBoxProcedure()
{
	ref chr = GetMainCharacter();
	if( !CheckAttribute(chr,"boxname") ) return;
	int locidx = FindLoadedLocation();
	if(locidx<0) return;
	string atrName = chr.boxname;
	aref ar;
	if(!HasSubStr(chr.boxname,"corpse")){//MAXIMUS: makes box from corpse with hand-icon in the top-left corner -->
		makearef(ar,Locations[locidx].(atrName));
		if(GetAttributesNum(ar)==0)
		{
			Locations[locidx].(atrName).Money = 0;
			makearef(ar,Locations[locidx].(atrName));
		}

    // JRH -->
//-----------------------------------------------------------------------------------------------------------------
	int lock;	//moved up here - why did I that?
	int gp;
	int pb;
	int pg;
	int mb
	//note in INTERFACE\itemsbox search JRH: normal box sounds avoided when not wanted

    //Cartagena puzzle -->

	if(Locations[locidx].id=="Governor_Daughter_House")
	{
		switch(chr.boxname)
		{
			case "box1":
				LaunchItemsBox(&ar);
			break;

			case "box2":
				if(CheckAttribute(chr,"quest.daughter_fireplace") && chr.quest.daughter_fireplace == "no_key")
				{
					//do nothing

				}
				else
				{
					if(CheckAttribute(chr,"quest.daughter_fireplace") && chr.quest.daughter_fireplace == "key_on_floor")
					{
					

					}
				}
				else
				{
					if(CheckCharacterItem(chr,"bladefire_irons"))
					{
						if(!IsEquipCharacterByItem(chr, "bladefire_irons"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladefire_irons");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("use_fire_irons", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
						Logit(TranslateString("","There's something in the fire."));
					}
				}
			break;
		}

		return;
	}

	if(Locations[locidx].id=="Admiral_Office")
	{
		switch(chr.boxname)
		{
			case "box1":
				//go to chair OR place cannonball

				if(CheckAttribute(chr,"quest.admiral_cannonball") && chr.quest.admiral_cannonball == "placed")
				{
					//do nothing
				}
				else
				{
					if(CheckCharacterItem(chr,"bladecannon_ball"))
					{
						if(!IsEquipCharacterByItem(chr, "bladecannon_ball"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladecannon_ball");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("place_admiral_cannonball", 1.0);
					}
					else
					{
						ChangeCharacterAddressGroup(chr, "Admiral_Office", "goto", "sit1");
						chr.quest.admiral_steplock = "way_in";

						LAi_QuestDelay("enter_admiral_steplock", 1.0);
					}
				}
			break;

			case "box2":
				//at chair

				if(CheckAttribute(chr,"quest.admiral_steplock") && chr.quest.admiral_steplock == "way_out")
				{
					LAi_SetPlayerType(chr);
					PlaySound("INTERFACE\step_path.wav");
					Locations[FindLocation("Admiral_Office")].models.always.l1 = "bars_down";

					LAi_QuestDelay("leave_admiral_steplock", 0.3);
				}
			break;

			case "box3":
				//clock

				if(CheckAttribute(chr,"quest.admiral_clock") && chr.quest.admiral_clock == "off")
				{
					chr.quest.admiral_clock = "on";
					LAi_SetStayType(chr);
					PlaySound("INTERFACE\clock_wind_up.wav");

					LAi_QuestDelay("admiral_wind_up_clock", 2.2);
				}
				else
				{
					if(CheckAttribute(chr,"quest.admiral_clock") && chr.quest.admiral_clock == "on")
					{
						//do nothing
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"bladeclockkey"))
					{
						if(!IsEquipCharacterByItem(chr, "bladeclockkey"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladeclockkey");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("place_admiral_clockkey", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
						Logit(TranslateString("","It has stopped."));
					}
				}
			break;
	
			case "box4":
				//lever
				
				if(CheckAttribute(chr,"quest.admiral_lever") && chr.quest.admiral_lever == "down")
				{
					PlaySound("INTERFACE\lever_stuck.wav");
				}
				else
				{
					if(CheckAttribute(chr,"quest.admiral_lever") && chr.quest.admiral_lever == "up")
					{
						chr.quest.admiral_lever = "down";
						PlaySound("INTERFACE\lever_down.wav");
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_BoP2";
						Locations[FindLocation("Admiral_Office")].models.always.l2 = "Adm_lever_down";

						LAi_QuestDelay("admiral_lever_down", 1.0);
					}
				}
				else
				{
					//lever is missing
					if(CheckCharacterItem(chr,"bladelever"))
					{
						if(!IsEquipCharacterByItem(chr, "bladelever"))
						{
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								EquipCharacterByItem(chr, "bladelever");
						}

						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("place_admiral_lever", 1.0);
					}
					else PlaySound("VOICE\ENGLISH\blaze_huh.wav");
				}				
			break;

			case "box5":
				//at door to tunnel instead of reload1

				PlaySound("INTERFACE\locked_window.wav");	
			break;
		}

		return;
	}

    //<-- Cartagena puzzle

	if(Locations[locidx].id=="Shipyard_docks")
	{
		switch(chr.boxname)
		{
			case "box1":
				//PlaySound("PEOPLE\counter_openclose.wav");
				ChangeCharacterAddressGroup(chr, "Shipyard_docks", "reload", "reload5");
			break;

			case "box2":
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "Shipyard_docks", "goto", "goto9");
			break;
		}

		return;
	}

	if(Locations[locidx].id=="Redmond_shore_02")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("PEOPLE\Run_stone.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_shore_02", "box", "box2");
			break;

			case "box2":
				PlaySound("PEOPLE\Run_stone.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_shore_02", "box", "box3");
			break;

			case "box3":
				PlaySound("PEOPLE\Run_stone.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_shore_02", "goto", "goto9");
			break;

			case "box4":
				PlaySound("PEOPLE\Run_stone.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_shore_02", "box", "box5");
			break;

			case "box5":
				PlaySound("PEOPLE\Run_stone.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_shore_02", "box", "box6");
			break;

			case "box6":
				PlaySound("PEOPLE\Run_stone.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_shore_02", "reload", "reload4D");
			break;
		}

		return;
	}

	if(Locations[locidx].id=="Redmond_tavern")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("PEOPLE\counter_openclose.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_tavern", "box", "box2");
			break;

			case "box2":
				PlaySound("PEOPLE\counter_openclose.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_tavern", "box", "box1");
			break;
		}

		return;
	}

	if(Locations[locidx].id=="mutiny_deck")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("PEOPLE\step_stairway1.wav");
				ChangeCharacterAddressGroup(chr, "mutiny_deck", "box", "box2");
			break;

			case "box2":
				if(CheckAttribute(chr, "quest.mutineer_boat") && chr.quest.mutineer_boat == "ready")
				{
					DoQuestReloadToLocation("Swamp_island1", "goto", "at_sea1", "_");
				}
			break;
		}

		return;
	}

	if(Locations[locidx].id=="Swamp_island1")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("PEOPLE\step_water.wav");
				LAi_SetActorType(chr);
				LAi_ActorTurnToLocator(chr, "goto", "goto1");

				LAi_QuestDelay("swamp1_pos1_move_to_land", 1.0);
			break;

			case "box2":
			//split this one, box2 is the standard case just look
				PlaySound("PEOPLE\step_water.wav");
				LAi_SetActorType(chr);
				LAi_ActorTurnToLocator(chr, "goto", "goto2");

				LAi_QuestDelay("swamp1_pos2_move_to_land", 1.0);
			break;

			case "box3":
				PlaySound("PEOPLE\step_water.wav");
				LAi_SetActorType(chr);
				LAi_ActorTurnToLocator(chr, "goto", "goto3");

				LAi_QuestDelay("swamp1_pos3_move_to_land", 1.0);
			break;

			case "box4":
				PlaySound("PEOPLE\step_water2.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island1", "goto", "at_sea1");

				LAi_QuestDelay("swamp1_pos1_turn_sea", 0.01);
			break;

			case "box5":
				PlaySound("PEOPLE\step_water2.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island1", "goto", "at_sea2");

				LAi_QuestDelay("swamp1_pos2_turn_sea", 0.01);
			break;

			case "box6":
				PlaySound("PEOPLE\step_water2.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island1", "goto", "at_sea3");

				LAi_QuestDelay("swamp1_pos3_turn_sea", 0.01);
			break;

			case "box7":
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				chr.quest.fallen_tree = "pos_2";
				Locations[FindLocation(chr.location)].models.always.locators = "Jungle2_locators_JRH2";

				LAi_QuestDelay("push_tree1", 0.5);
			break;

			case "box8":
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				chr.quest.fallen_tree = "pos_3";
				Locations[FindLocation(chr.location)].models.always.locators = "Jungle2_locators_JRH3";

				LAi_QuestDelay("push_tree2", 0.5);
			break;

			case "box9":
				if(CheckAttribute(chr, "quest.tree_boat") && chr.quest.tree_boat == "ready")
				{
					DoQuestReloadToLocation("Swamp_island2", "goto", "arrive", "_");
				}
			break;

			case "box10":
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				chr.quest.fallen_tree = "pos_4";
				Locations[FindLocation(chr.location)].models.always.locators = "Jungle2_locators_JRH4";
			
				LAi_QuestDelay("push_tree3", 0.5);
			break;

			case "box11":
			//split this one, box2 is the standard case just look

				PlaySound("PEOPLE\step_stairway1.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island1", "goto", "leave");

				LAi_QuestDelay("swamp1_pos2_turn_sea_last_time", 0.01);
			break;

			case "box12":
				PlaySound("VOICE\ENGLISH\blaze_mhm.wav");
				Logit(TranslateString("","Hmm, this tree is floating, how can I get it to sea?"));

				return;
			break;
		}

		return;
	}

	if(Locations[locidx].id=="Swamp_island2")
	{
		switch(chr.boxname)
		{

			case "box1":
				PlaySound("PEOPLE\run_wood.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto2");
				return;
			break;

			case "box2":
				PlaySound("PEOPLE\run_wood.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto3");
				return;
			break;

			case "box3":
				PlaySound("PEOPLE\run_wood.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto4");

				LAi_QuestDelay("swamp_wreck1", 1.0);
			break;

			case "box4":
				if(CheckAttribute(chr,"quest.raft_ropes") && chr.quest.raft_ropes == "picked_up")
				{
					PlaySound("PEOPLE\run_wood.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "reload", "reload7");
					chr.quest.mast_climb = "way_up";
				}
				else
				{
					if(CheckAttribute(chr,"quest.mast_climb") && chr.quest.mast_climb == "way_down")
					{
						PlaySound("PEOPLE\run_wood.wav");
						ChangeCharacterAddressGroup(chr, "Swamp_island2", "reload", "reload7");
						chr.quest.mast_climb = "way_up";
					}
					else
					{
						PlaySound("PEOPLE\creak2.wav");
						ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto5");

						LAi_QuestDelay("swamp_wreck2", 0.5);
					}
				}
			break;

			case "box5":
				if(CheckAttribute(chr,"quest.mast_climb") && chr.quest.mast_climb == "way_down")
				{
					PlaySound("PEOPLE\jump.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto4");

					LAi_QuestDelay("swamp_wreck1", 1.0);
				}
				else
				{
					PlaySound("PEOPLE\creak2.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto6");
				}
			break;

			case "box6":
				if(CheckAttribute(chr,"quest.mast_climb") && chr.quest.mast_climb == "way_down")
				{
					PlaySound("PEOPLE\creak2.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto5");

					LAi_QuestDelay("swamp_wreck2", 0.5);
				}
				else
				{
					PlaySound("PEOPLE\recoil.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "goto", "goto7");
					chr.quest.mast_climb = "way_down";
				}
			break;

			case "box7":
				//building a raft on the shore - starts with box16 just looking
				if(Locations[FindLocation(chr.location)].models.always.locators == "TownExitW_locators_JRH8_raft_ropes")
				{
					//move raft to the water here
					PlaySound("OBJECTS\DUEL\man_attack1.wav");

					LAi_QuestDelay("launch_raft", 1.0);
				}
				else
				{
					if(Locations[FindLocation(chr.location)].models.always.locators == "TownExitW_locators_JRH8_raft_ropes")
					{
						//move raft to the water here

					}
					else
					{
						if(Locations[FindLocation(chr.location)].models.always.locators == "TownExitW_locators_JRH8_raft_logs")
						{
							if(CheckCharacterItem(chr,"raft_ropes"))
							{
								//take ropes, switch to ...JRH8_raft_ropes
								PlaySound("VOICE\ENGLISH\blaze_mhm.wav");
								Logit(TranslateString("","I'll use the rope to assemble the raft!"));
								LAi_SetSitType(chr);

								LAi_QuestDelay("build_raft", 1.0);
							}
							else
							{
								PlaySound("VOICE\ENGLISH\blaze_huh.wav");
								Logit(TranslateString("","Enough with logs - how do I assemble the raft?"));
							}
						}
					}
					else
					{
						if(Locations[FindLocation(chr.location)].models.always.locators == "TownExitW_locators_JRH8")
						{
							PlaySound("OBJECTS\DUEL\man_hit1.wav");
							Logit(TranslateString("","Hmm, let's arrange them in some order..."));
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("arrange_raft_logs", 1.0);
						}
					}
					else
					{
						if(CheckCharacterItem(chr,"pistollog"))
						{
							if(!IsEquipCharacterByItem(chr, "pistollog"))
							{
								RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
								EquipCharacterByItem(chr, "pistollog");
							}

							PlaySound("PEOPLE\wood2.wav");
							RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
							TakeItemFromCharacter(chr, "pistollog");

							gp = GetCharacterItem(chr, "gunpowder");
							pb = GetCharacterItem(chr, "pistolbullets");
						//	LogIt("gp start = " + gp);
						//	LogIt("pb start = " + pb);

							chr.quest.gunpowder = sti(GetCharacterItem(chr, "gunpowder"));
							chr.quest.pistolbullets = sti(GetCharacterItem(chr, "pistolbullets"));

						//	LogIt("Pchar.quest.gunpowder = " + chr.quest.gunpowder);
						//	LogIt("Pchar.quest.pistolbullets = " + chr.quest.pistolbullets);

							LAi_QuestDelay("collect_raft_logs", 1.0);
						}
					}
					else
					{
						Logit(TranslateString("","I still need more logs to build a raft."));
						//PlaySound("VOICE\ENGLISH\blaze_sigh.wav");
						PlaySound("VOICE\ENGLISH\blaze_mhm.wav");
					}
				}
			break;

			case "box8":
				//koster in stone (ri 15)
					if(IsEquipCharacterByItem(chr, "Minerspick"))
					{
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("use_Minerspick_on_stone", 1.0);
					}
					else
					{
						if(IsEquipCharacterByItem(chr, "MinersSpade"))
						{
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("wrong_use_MinersSpade_on_stone", 1.0);
						}
					}
					else
					{
						PlaySound("OBJECTS\DUEL\man_attack1.wav");
						Logit(TranslateString("","No, I can't move it!"));
					}
			break;

			case "box9":
				//koster in mud (ri 20)
					if(IsEquipCharacterByItem(chr, "Minerspick"))
					{
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("use_Minerspick_on_mud", 1.0);
					}
					else
					{
						if(IsEquipCharacterByItem(chr, "MinersSpade"))
						{
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("wrong_use_MinersSpade_on_mud", 1.0);
						}
					}
					else
					{
						PlaySound("OBJECTS\DUEL\man_attack1.wav");
						Logit(TranslateString("","No, I can't move it!"));
					}
			break;

			case "box10":
				//raft_ropes in mast top (ri 7)
					if(IsEquipCharacterByItem(chr, "BarmansKnife"))
					{
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("use_BarmansKnife_on_rope", 1.0);
					}
					else
					{
						PlaySound("OBJECTS\DUEL\man_attack5.wav");
						Logit(TranslateString("","No, this rope is tied too hard!"));

						LAi_QuestDelay("raft_ropes1", 1.0);
					}
			break;

			case "box11":
					//to loghouse entre
					PlaySound("PEOPLE\step_water1.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "reload", "reload5");
			break;

			case "box12":
					//start to grot
					PlaySound("PEOPLE\step_water1.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "box", "box15");
			break;

			case "box13":
					//start back from grot
					PlaySound("PEOPLE\step_water1.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "box", "box14");
			break;

			case "box14":
					//half way back from grot
					PlaySound("PEOPLE\step_water1.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "reload", "reload1");
			break;

			case "box15":
					//half way to grot
					PlaySound("PEOPLE\step_water1.wav");
					ChangeCharacterAddressGroup(chr, "Swamp_island2", "reload", "reload8");
			break;

			case "box16":
				//getting the idea of building a raft on the shore

				PlaySound("VOICE\ENGLISH\blaze_hah.wav");
				Logit(TranslateString("","Hmm, with some more logs maybe I could build a raft here."));
			break;

			case "box17":
				//push raft to shore
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_QuestDelay("push_raft", 1.0);
			break;

			case "box18":
				//enter raft at shore
				PlaySound("PEOPLE\step_water1.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_island2", "box", "box19");
				LAi_SetPoorType(chr);

				LAi_QuestDelay("enter_raft", 0.001);
			break;

			case "box19":
				//leave shipwreck island into the fog
				if(CheckAttribute(chr, "quest.raft_boat") && chr.quest.raft_boat == "ready")
				{
					DoQuestReloadToLocation("at_sea_in_fog", "goto", "fog_at_sea", "_");
				}
			break;

		}

		return;
	}

	if(Locations[locidx].id=="Swamp_wreck_inside")
	{
		switch(chr.boxname)
		{
			case "box1":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box2":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box3":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box4":
				PlaySound("PEOPLE\Jump.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_wreck_inside", "goto", "goto10");
				return;
			break;

			case "box5":
				//PlaySound("PEOPLE\recoil.wav");
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "Swamp_wreck_inside", "goto", "goto9");
				return;
			break;
		}

		return;
	}

	if(Locations[locidx].id=="Loghouse")
	{
		LaunchItemsBox(&ar);
		return;
	}

	if(Locations[locidx].id=="Swamp_grot")
	{
		if(CheckAttribute(chr, "quest.buried_skeleton") && chr.quest.buried_skeleton == "visible")
		{
			PlaySound("OBJECTS\VOICES\skeleton_body3.wav");
			LaunchItemsBox(&ar);
			return;
		}
		else
		{
			if(IsEquipCharacterByItem(chr, "MinersSpade"))
			{
				LAi_SetFightMode(chr, true);

				LAi_QuestDelay("use_MinersSpade_on_grave", 1.0);
			}
			else
			{
				if(IsEquipCharacterByItem(chr, "MinersPick"))
				{
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("wrong_use_MinersPick_on_grave", 1.0);
				}
			}
			else
			{
				PlaySound("VOICE\ENGLISH\blaze_mhm.wav");
				Logit(TranslateString("","Looks like someone has been digging here.."));
			}
		}

		return;
	}

	if(Locations[locidx].id=="QC_town")
	{
		switch(chr.boxname)
		{
			case "box1":
				ChangeCharacterAddressGroup(chr, "QC_town", "goto", "goto108w");

				LAi_QuestDelay("Blaze_walk_0", 0.01);
			break;

			case "box2":
				ChangeCharacterAddressGroup(chr, "QC_town", "goto", "goto113w");

				LAi_QuestDelay("Blaze_walk_1", 0.01);
			break;

			case "box3":
				ChangeCharacterAddressGroup(chr, "QC_town", "goto", "goto115w");

				LAi_QuestDelay("Blaze_walk_2", 0.01);
			break;

			case "box4":
				ChangeCharacterAddressGroup(chr, "QC_town", "goto", "goto117w");

				LAi_QuestDelay("Blaze_walk_3", 0.01);
			break;

			case "box5":
				ChangeCharacterAddressGroup(chr, "QC_town", "goto", "roof6");

				LAi_QuestDelay("afraid_to_jump_3", 0.01);
			break;

			case "box6":
				ChangeCharacterAddressGroup(chr, "QC_town", "box", "box7");//reload never got visible

				LAi_QuestDelay("store_upperdoor_2", 0.01);
			break;

			case "box7":
				PlaySound("INTERFACE\creak.wav");

				LAi_QuestDelay("arrive_store_upstairs", 1.5);
			break;

			case "box8":
				ChangeCharacterAddressGroup(chr, "QC_town", "reload", "reload25");

				LAi_QuestDelay("run_and_jump_1", 0.01);
			break;
		}

		return;
	}

	if(Locations[locidx].id=="wr_sacristy")
	{
		switch(chr.boxname)
		{
			case "box1":
				//scales
				if(CheckCharacterItem(chr,"coin4"))
				{
					PlaySound("INTERFACE\coin_drop.wav");

					LAi_QuestDelay("sacristy_scales_coin4", 2.0);
				}
				else
				{
					if(CheckCharacterItem(chr,"coin4_bad"))
					{
						Logit(TranslateString("","The pieces-of-eight vary too much in weight to be of any use!"));
						PlaySound("INTERFACE\coin_drop.wav");
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"coin1") || CheckCharacterItem(chr,"coin2") || CheckCharacterItem(chr,"coin3")
					|| CheckCharacterItem(chr,"coin5") || CheckCharacterItem(chr,"coin6") || CheckCharacterItem(chr,"coin7")
					|| CheckCharacterItem(chr,"coin8") || CheckCharacterItem(chr,"coin9") || CheckCharacterItem(chr,"coin10")
					|| CheckCharacterItem(chr,"coin11") || CheckCharacterItem(chr,"coin12") || CheckCharacterItem(chr,"coin13")
					|| CheckCharacterItem(chr,"coin14") || CheckCharacterItem(chr,"coin15") || CheckCharacterItem(chr,"coin16"))
					{
						PlaySound("INTERFACE\coin_drop.wav");

						LAi_QuestDelay("sacristy_scales_other_coin", 2.0);
					}
				}
				else
				{
					Logit(TranslateString("","Scales hmm...?"));
					PlaySound("VOICE\ENGLISH\blaze_huh.wav");
				}
			break;

			case "box2":
				if(CheckAttribute(chr, "quest.votiv_lever") && chr.quest.votiv_lever == "F")
				{
					ChangeCharacterAddressGroup(chr, "wr_sacristy", "reload", "reload4");
					PlaySound("PEOPLE\recoil.wav");
				}
				else PlaySound("INTERFACE\knock.wav");
			break;
		}

		return;
	}

	if(Locations[locidx].id=="stonehouse_inside")
	{
		LaunchItemsBox(&ar);
		return;
	}

	if(Locations[locidx].id=="wr_booty")
	{
		switch(chr.boxname)
		{
			case "box4":
				if(CheckAttribute(chr, "quest.Friday_room") && chr.quest.Friday_room == "open")
				{
					ChangeCharacterAddressGroup(chr, "wr_booty", "reload", "reload4");
					PlaySound("PEOPLE\creak2.wav");
				}
				else PlaySound("INTERFACE\knock.wav");
			break;

			case "box5":
				ChangeCharacterAddressGroup(chr, "wr_booty", "goto", "reload3");
				PlaySound("PEOPLE\creak2.wav");
			break;

			//default
			PlaySound("INTERFACE\locked_window.wav");
			return;
		}

		return;
	}

	if(Locations[locidx].id=="ck_drawing_room")
	{
		PlaySound("INTERFACE\locked_window.wav");
		return;
	}

	if(Locations[locidx].id=="JRH_tavern_upstairs")
	{
		switch(chr.boxname)
		{
			case "box1":
				//standard chest, in this case 'stuck'
				PlaySound("AMBIENT\JAIL\jail_door1.wav");
				Log_SetStringToLog(TranslateString("","You try to pick the lock with your knife... in vain!"));
				return;
			break;

			case "box2":
				//remove hatch
				LAi_SetFightMode(chr, true);
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				Locations[FindLocation(chr.location)].models.always.locators = "LH_F2_l_JRH_open";
				Locations[FindLocation("JRH_tavern_upstairs")].image = "";

				LAi_QuestDelay("open_tavern_upstairs_hatch", 1.0);
			break;

			case "box3":
				//put back hatch
				LAi_SetFightMode(chr, true);
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				Locations[FindLocation(chr.location)].models.always.locators = "LH_F2_l_JRH_closed";
				Locations[FindLocation("JRH_tavern_upstairs")].image = "";

				LAi_QuestDelay("close_tavern_upstairs_hatch", 1.0);
			break;
		}

		return;
	}

	if(Locations[locidx].id=="wr_wood_tower2")
	{
		switch(chr.boxname)
		{
			case "box1":
				//store04_locators_JRH6, small cannon pointing out

				if(CheckAttribute(chr, "quest.swivelgun") && chr.quest.swivelgun == "charged")
				{
					if(CheckAttribute(chr, "quest.wet_gp") && chr.quest.wet_gp == "yes")
					{
						PlaySound("OBJECTS\duel\wet_gunpowder.wav");
						CreateParticleSystem("gunfire_black" , 5.3, 4.45, 3.0, 5.3, 7.0, 3.0, sti(20) );
						CreateParticleSystem("gunfire_black" , 5.3, 4.45, 2.2, 5.3, 7.0, 2.2, sti(20) );
						chr.quest.swivelgun = "not_charged";

						LAi_QuestDelay("swivelgun_longer_black_smoke", 2.0);
					}
					else
					{
						PlaySound("OBJECTS\SHIPCHARGE\CR24C.wav");
						CreateParticleSystem("smoke_short" , 5.3, 4.45, 3.0, 5.3, 7.0, 3.0, sti(20) );
						CreateParticleSystem("smoke_short" , 5.3, 4.45, 2.2, 5.3, 7.0, 2.2, sti(20) );
						chr.quest.swivelgun = "not_charged";

						if(CheckAttribute(chr, "quest.spriggs") && chr.quest.spriggs == "in_wood_tower")
						{
							chr.quest.spriggs = "on_shore";
							LAi_QuestDelay("spriggs_arrives", 3.0);
						}

						LAi_QuestDelay("swivelgun_longer_smoke", 5.0);
					}
				}
				else
				{
					PlaySound("PEOPLE\creak2.wav");

					LAi_QuestDelay("swivelgun_turn", 1.5);
				}
			break;

			case "box2":
				//store04_locators_JRH7, small cannon pointing in

				if(CheckAttribute(chr, "quest.swivelgun") && chr.quest.swivelgun == "charged")
				{
					PlaySound("PEOPLE\creak2.wav");

					LAi_QuestDelay("swivelgun_turn", 1.5);
				}
				else
				{
					gp = GetCharacterItem(chr, "gunpowder");

					if(gp >=6)
					{
						PlaySound("PEOPLE\powderhorn.wav");
						chr.quest.swivelgun = "charged";
						TakeNItems(chr, "gunpowder", -6);
					}
					else
					{
						Logit(TranslateString("","There is not enough Gunpowder"));
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
					}
				}
			break;

			case "box3":
				//flagchest
				if(CheckCharacterItem(chr,"key19"))
				{
					PlaySound("INTERFACE\key_lock.wav");
					chr.quest.flagchest = "open";
					TakeItemFromCharacter(chr, "key19");

					LAi_QuestDelay("pick_up_pirate_flag", 0.5);
				}
				else
				{
					if(CheckAttribute(chr, "quest.flagchest") && chr.quest.flagchest == "open")
					{
						LaunchItemsBox(&ar);
					}
					else PlaySound("INTERFACE\locked_window.wav");
				}
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_wood_tower3")
	{
		switch(chr.boxname)
		{
			case "box1":
				//pull down ladder

				if(IsEquipCharacterByItem(chr, "bladeboathook_1"))
				{
					RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
					TakeItemFromCharacter(chr, "bladeboathook_1");
					GiveItem2Character(chr, "bladeboathook_2");
					EquipCharacterByItem(chr, "bladeboathook_2");
					LAi_LocationFightDisable(&Locations[FindLocation("wr_wood_tower3")], false);
					LAi_SetPlayerType(chr);
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("prepare_pull_down_ladder", 1.0);
				}
				else
				{
					Logit(TranslateString("","Hmm, that hatch is too high up."));
					PlaySound("AMBIENT\JAIL\sigh.wav");

					if(CheckAttribute(chr,"quest.wt3_musket") && chr.quest.wt3_musket == "picked_up")
					{
						return;
					}
					else
					{
						if(CheckAttribute(chr,"quest.wt3_notice_musket") && chr.quest.wt3_notice_musket == "yes")
						{
							return;
						}
						else
						{
							LAi_SetStayType(chr);
							chr.quest.wt3_notice_musket = "yes";

							LAi_QuestDelay("notice_wt3_musket", 1.5);
						}
					}
				}
			break;

			case "box2":
				ChangeCharacterAddressGroup(chr, "wr_wood_tower3", "goto", "wall0");
				PlaySound("PEOPLE\run_wood.wav");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_cave_shore")
	{
		switch(chr.boxname)
		{
			case "box1":
				chr.quest.wood_tower_route = "way_down";		//all cases

				//NO FLAG
				if(Locations[FindLocation(chr.location)].models.always.locators == "Shore04_l_JRH3"
				|| Locations[FindLocation(chr.location)].models.always.locators == "Shore04_l_JRH4")
				{
					if(CheckAttribute(chr, "quest.flag_pole") && chr.quest.flag_pole == "locked") return;

					chr.quest.flag_pole = "locked";

					if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladeflag_pir")
					{

						if(chr.equip.blade == "bladeflag_pir")
						{
							locations[locidx].townsack = "Grand Turk";
							chr.quest.equip_flag = "pirate";
							chr.quest.hoist_flag = "pirate";
						}

						LAi_SetPlayerType(chr);
						LAi_SetFightMode(chr, true);

						if(Locations[FindLocation(chr.location)].models.always.locators == "Shore04_l_JRH3")
						Locations[FindLocation(chr.location)].models.always.locators = "Shore04_l_JRH3F";

						if(Locations[FindLocation(chr.location)].models.always.locators == "Shore04_l_JRH4")
						Locations[FindLocation(chr.location)].models.always.locators = "Shore04_l_JRH4F";

						TraceAndLog("itemLogic hoist_flag");
						LAi_QuestDelay("hoist_flag", 1.0);
					}
				}
				else
				{
					if(Locations[FindLocation(chr.location)].models.always.locators == "Shore04_l_JRH3_spyglass")
					{
						//NO FLAG (pchar has picked up spyglass to check boat on shore)

						switch(chr.quest.wood_tower_view_direction)
						{
							case "right":
								LAi_SetPlayerType(chr);
								LAi_SetFightMode(chr, true);

								LAi_QuestDelay("boat_zoom", 1.0);
							break;

							case "front":
								LAi_SetActorType(chr);
								LAi_ActorTurnToLocator(chr, "ships_other", "ship_21");
								chr.quest.wood_tower_view_direction = "right";

								LAi_QuestDelay("blaze_huh", 1.0);
							break;

							case "left":
								LAi_SetActorType(chr);
								LAi_ActorTurnToLocator(chr, "ships_other", "ship_6");
								chr.quest.wood_tower_view_direction = "front";
							break;

							case "start":
								LAi_SetActorType(chr);
								LAi_ActorTurnToLocator(chr, "ships_other", "ship_10");
								chr.quest.wood_tower_view_direction = "left";
							break;
						}
						return;
					}
				}
			break;

			case "box2":
				//ladder in water
				RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
				GiveItem2Character(chr, "bladeladder2");
				EquipCharacterByItem(chr, "bladeladder2");

				Locations[FindLocation(chr.location)].models.always.locators = "Shore04_l_JRH2";

				LAi_QuestDelay("pick_up_ship_ladder", 0.1);
			break;

			case "box3":
				//chest at boat
				if(CheckAttribute(chr, "quest.Bunce") && chr.quest.Bunce == "awaken") return;

				if(CheckAttribute(chr, "quest.cave_shore_pirates") && chr.quest.cave_shore_pirates == "trying_to_lift")
				{
					return;
				}
				else
				{
					if(CheckAttribute(chr, "quest.cave_shore_pirates") && chr.quest.cave_shore_pirates == "lifting")
					{

						if(CheckAttribute(chr, "quest.cave_shore_red_chest") && chr.quest.cave_shore_red_chest == "free")
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladewhistle");
							GiveItem2Character(chr, "bladechest_red");
							EquipCharacterByItem(chr, "bladechest_red");

							TakeItemFromCharacter(chr, "bladeflag_eng");
							TakeItemFromCharacter(chr, "bladeflag_fra");
							TakeItemFromCharacter(chr, "bladeflag_spa");
							TakeItemFromCharacter(chr, "bladeflag_por");
							TakeItemFromCharacter(chr, "bladeflag_hol");
							TakeItemFromCharacter(chr, "bladeflag_pir");

							locations[FindLocation("wr_wood_tower2")].reload.l4.disable = 1;//locked to balcony

							LAi_QuestDelay("equip_redchest_caveshore", 0.1);
							return;
						}
						else return;
					}
				}
				else
				{
					ChangeCharacterAddressGroup(chr, "wr_cave_shore", "goto", "boat7D");
					chr.quest.cave_shore_boat = "ground";
					PlaySound("PEOPLE\step_ground1.wav");
					PlaySound("PEOPLE\step_ground1.wav");

					if(CheckAttribute(chr, "quest.cave_shore_pirates") && chr.quest.cave_shore_pirates == "actors")
					{
						LAi_SetOfficerType(CharacterFromID("pir_cap6"));
						LAi_SetOfficerType(CharacterFromID("pir_cap10"));
						LAi_SetOfficerType(CharacterFromID("pir_cap11"));
						LAi_SetOfficerType(CharacterFromID("pir_cap17"));
						LAi_SetOfficerType(CharacterFromID("pir_cap21"));
						LAi_SetOfficerType(CharacterFromID("pir_cap24"));

						chr.quest.cave_shore_pirates = "officers";
					}
				}
			break;

			case "box5":
				//ground at boat
				ChangeCharacterAddressGroup(chr, "wr_cave_shore", "goto", "boat7");
				chr.quest.cave_shore_boat = "chest";
				PlaySound("PEOPLE\step_stone.wav");

				if(CheckAttribute(chr,"quest.stuck_red_chest") && chr.quest.stuck_red_chest == "observed")
				{
					return;
				}
				else
				{
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");
					chr.quest.stuck_red_chest = "observed"
					Logit(TranslateString("","The Chest from the Blue Cavern - and it's stuck under the Boat!"));
					AddQuestRecord("Cave_shore", "5");
				}
			break;

			case "box4":
				//place ladder at cliff
				if(chr.equip.blade == "bladeladder2")
				{
					LAi_SetFightMode(chr, true);
					PlaySound("OBJECTS\DUEL\man_attack1.wav");

					LAi_QuestDelay("place_ladder_cave_shore", 1.0);
				}
				else
				{
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");
				}
			break;

			case "box6":
				//head visible in tower top

				if(CheckCharacterItem(chr,"bladeflag_pir"))
				{
					chr.quest.wood_tower_route = "way_up";
				}
				else chr.quest.wood_tower_route = "way_down";

				if(CheckAttribute(chr, "quest.wood_tower_route") && chr.quest.wood_tower_route == "way_up")
				{
					LAi_QuestDelay("wood_top_up", 0.01);
				}

				if(CheckAttribute(chr, "quest.wood_tower_route") && chr.quest.wood_tower_route == "way_down")
				{
					DoQuestReloadToLocation("wr_wood_tower3", "goto", "stairs", "wood_top_down3");

				}
			break;

			case "box7":
				//from sacristy between
				ChangeCharacterAddressGroup(chr, "wr_cave_shore", "goto", "arrive");
				PlaySound("PEOPLE\run_roof.wav");
			break;

			case "box8":
				//climb ladder up
				ChangeCharacterAddressGroup(chr, "wr_cave_shore", "reload", "reload6");
				PlaySound("PEOPLE\creak2.wav");
			break;

			case "box9":
				//climb ladder down
				ChangeCharacterAddressGroup(chr, "wr_cave_shore", "goto", "reload5");
				PlaySound("PEOPLE\step_grass1.wav");
			break;

			case "box10":
				//NO FLAG (pchar has picked up spyglass to check boat on shore)

					switch(chr.quest.wood_tower_view_direction)
					{
						case "right":
							LAi_SetPlayerType(chr);
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("boat_zoom", 1.0);
						break;

						case "front":
							LAi_SetActorType(chr);
							LAi_ActorTurnToLocator(chr, "ships_other", "ship_21");
							chr.quest.wood_tower_view_direction = "right";

							LAi_QuestDelay("blaze_huh", 1.0);
						break;
					}
					return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_church_inside")
	{
		switch(chr.boxname)
		{
			case "box1":
				//collection box

				LaunchItemsBox(&ar);

				LAi_QuestDelay("collection_box", 0.1);
			break;

			case "box2":
				//ship lever

			if(CheckAttribute(chr, "quest.votiv_lever_function") && chr.quest.votiv_lever_function == "temp_off")
			{
				return;
			}
			else
			{
				PlaySound("INTERFACE\lever_up.wav");
				chr.quest.votiv_lever_function = "temp_off";

				if(Locations[FindLocation("wr_church_inside")].models.always.l3 == "lever_down_B")
				{
					chr.quest.votiv_lever = "M";
					Locations[FindLocation("wr_church_inside")].models.always.l3 = "lever_down_M";
					Locations[FindLocation("wr_church_inside")].reload.l1.disable = 1;
					Locations[FindLocation("wr_sacristy")].reload.l1.disable = 0;
				}
				else
				{
					if(Locations[FindLocation("wr_church_inside")].models.always.l3 == "lever_down_M")
					{
						chr.quest.votiv_lever = "F";
						Locations[FindLocation("wr_church_inside")].models.always.l3 = "lever_down_F";
						Locations[FindLocation("wr_church_inside")].reload.l1.disable = 1;
						Locations[FindLocation("wr_sacristy")].reload.l1.disable = 1;
					}
				}
				else
				{
					if(Locations[FindLocation("wr_church_inside")].models.always.l3 == "lever_down_F")
					{
						chr.quest.votiv_lever = "B";
						Locations[FindLocation("wr_church_inside")].models.always.l3 = "lever_down_B";
						Locations[FindLocation("wr_church_inside")].reload.l1.disable = 0;
						Locations[FindLocation("wr_sacristy")].reload.l1.disable = 1;
					}
				}

				LAi_QuestDelay("votiv_ship", 0.5);
			}
			break;

			case "box3":
				//to pulpit

				ChangeCharacterAddressGroup(chr, "wr_church_inside", "goto", "pulpit");
				PlaySound("PEOPLE\step_stairway.wav");
			break;

			case "box4":
				//from pulpit

				ChangeCharacterAddressGroup(chr, "wr_church_inside", "box", "box3");
				PlaySound("PEOPLE\step_echo1.wav");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="church_choir")
	{
		switch(chr.boxname)
		{
			case "box1":
				if(CheckAttribute(chr, "quest.choir_box1") && chr.quest.choir_box1 == "open")
				{
					PlaySound("INTERFACE\Closet_Open.wav");
					LaunchItemsBox(&ar);

					LAi_QuestDelay("choir_many_animists_check", 0.1);
				}
				else PlaySound("INTERFACE\door_locked2.wav");
			break;

			case "box2":
				switch(chr.quest.choir_ladder)
				{
					case "not_found":
						PlaySound("AMBIENT\JAIL\jail_door1.wav");
						Logit(TranslateString("","The lock is too rusty - I can't move the key."));
					break;

					case "found":
						if(IsEquipCharacterByItem(chr, "bladeladder"))
						{
							if(LAi_IsFightMode(chr))
							{
								//this is your 2:nd 'open box'
								PlaySound("OBJECTS\DUEL\man_attack1.wav");

								LAi_QuestDelay("place_ladder_choir_box2", 1.0);
							}
							else
							{
								ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck2");
								LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], false);
								LAi_SetFightMode(chr, true);

								LAi_QuestDelay("stay_at_choir_box2", 1.0);
							}
						}
						else
						{
						 	PlaySound("AMBIENT\JAIL\jail_door1.wav");
							Logit(TranslateString("","The lock is too rusty - I can't move the key."));
						}
					break;

					case "placed":
						//later when ladder is placed
						PlaySound("PEOPLE\step_stairway.wav");
						ChangeCharacterAddressGroup(chr, "church_choir", "goto", "ladder1");

						LAi_QuestDelay("choir_ladder_up", 1.0);
					break;

					case "oilbottle":
						if(IsEquipCharacterByItem(chr, "bladeoilbottle"))
						{
							if(LAi_IsFightMode(chr))
							{
								//this is your 2:nd 'open box'
								PlaySound("PEOPLE\oil_unlock.wav");

								LAi_QuestDelay("oilbottle_choir_box2", 3.0);
							}
							else
							{
								ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck2");
								LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], false);
								LAi_SetFightMode(chr, true);

								LAi_QuestDelay("stay_at_choir_box2", 1.0);
							}
						}
						else
						{
							PlaySound("PEOPLE\step_stairway.wav");
							ChangeCharacterAddressGroup(chr, "church_choir", "goto", "ladder1");

							LAi_QuestDelay("choir_ladder_up", 1.0);
						}
					break;

					case "blocking":
						if(LAi_IsFightMode(chr))
						{
							//this is your 2:nd 'open box'
							PlaySound("OBJECTS\DUEL\man_attack1.wav");

							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							GiveItem2Character(chr, "bladeladder");
							EquipCharacterbyItem(chr, "bladeladder");

							LAi_QuestDelay("remove_ladder_choir_box2", 0.5);
						}
						else
						{
							ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck2");
							LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], false);
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("stay_at_choir_box2", 1.0);
						}
					break;

					case "open_chest":
						LaunchItemsBox(&ar);

						LAi_QuestDelay("choir_churchsilver_check", 0.1);
					break;
				}
				return;
			break;

			case "box3":
				if(CheckAttribute(chr, "quest.choir_box3") && chr.quest.choir_box3 == "open")
				{
					PlaySound("INTERFACE\Closet_Open.wav");
					LaunchItemsBox(&ar);
				}
				else
				{
					if(IsEquipCharacterByItem(chr, "PiratesDagger"))
					{
						if(LAi_IsFightMode(chr))
						{
							//this is your 2:nd 'open box'
							PlaySound("PEOPLE\knife_closet.wav");

							LAi_QuestDelay("knifeuse_choir_box3", 2.5);
						}
						else
						{
							ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck3");
							LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], false);
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("stay_at_choir_box3", 1.0);
						}
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_huh.wav");

						Logit(TranslateString("","Neither lock nor handle. How do I open it?"));
					}
				}
			break;

			case "box4":
				if(CheckAttribute(chr, "quest.choir_box4") && chr.quest.choir_box4 == "open")
				{
					LaunchItemsBox(&ar);
				}
				else
				{
					if(IsEquipCharacterByItem(chr, "bladelockpick"))
					{
						if(LAi_IsFightMode(chr))
						{
							//this is your 2:nd 'open box'
							PlaySound("PEOPLE\lockpick.wav");

							LAi_QuestDelay("lockpick_choir_box4", 3.0);
						}
						else
						{
							ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck4");
							LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], false);
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("stay_at_choir_box4", 1.0);
						}
					}
					else PlaySound("INTERFACE\door_locked2.wav");
				}
			break;

			case "box5":
				if(CheckAttribute(chr, "quest.choir_box5") && chr.quest.choir_box5 == "open")
				{
					PlaySound("INTERFACE\Closet_Open.wav");
					LaunchItemsBox(&ar);
				}
				else
				{
					if(IsEquipCharacterByItem(chr, "bladehandle"))
					{
						if(LAi_IsFightMode(chr))
						{
							//this is your 2:nd 'open box'
							PlaySound("PEOPLE\chopchop.wav");

							LAi_QuestDelay("handle_choir_box5", 1.5);
						}
						else
						{
							ChangeCharacterAddressGroup(chr, "church_choir", "goto", "stuck5");
							LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], false);
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("stay_at_choir_box5", 1.0);
						}
					}
					else{
						PlaySound("VOICE\ENGLISH\blaze_huh.wav");
						Logit(TranslateString("","Neither lock nor handle. How do I open it?"));
					}
				}
			break;

			case "box6":
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_QuestDelay("choir_clock_up", 0.5);
			break;

			case "box7":
				PlaySound("INTERFACE\paper.wav");
			break;

			case "box8":
				PlaySound("INTERFACE\cello.wav");
			break;

			case "box9":
				PlaySound("INTERFACE\flute.wav");
			break;

			case "box10":
				LaunchItemsBox(&ar);

				LAi_QuestDelay("choir_ladder_down", 1.0);
			break;

			case "box11":
				PlaySound("INTERFACE\paper.wav");
			break;

			case "box12":
				PlaySound("INTERFACE\book_close.wav");
			break;

			case "box13":
				PlaySound("INTERFACE\violin.wav");

				LAi_QuestDelay("choir_violin_right_down", 1.0);
			break;

			case "box14":
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_QuestDelay("choir_violin_right_up", 0.5);
			break;

			case "box15":
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_QuestDelay("choir_violin_left_up", 0.5);
			break;

			case "box16":
				if(CheckAttribute(chr, "quest.choir_lockpick") && chr.quest.choir_lockpick == "not_found")
				{
					PlaySound("INTERFACE\violin.wav");

					LAi_QuestDelay("choir_lockpick", 0.5);
				}
				else
				{
					PlaySound("INTERFACE\violin.wav");

					LAi_QuestDelay("choir_violin_left_down", 0.5);
				}
			break;

			case "box17":
				if(IsEquipCharacterByItem(chr, "bladekeygrand"))
				{
					if(LAi_IsFightMode(chr))
					{
						//this is your 2:nd 'open box'
						PlaySound("INTERFACE\key_lock.wav");
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						TakeItemFromCharacter(chr, "bladekeygrand");
						EquipCharacterByItem(chr, "bladeX4");

						LAi_SetFightMode(chr, false);
						LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], true);

						LAi_QuestDelay("place_choir_clockkey", 1.0);
					}
					else
					{
						LAi_LocationFightDisable(&Locations[FindLocation("church_choir")], false);
						LAi_SetFightMode(chr, true);
					}
				}
				else
				{
					if(CheckAttribute(chr, "quest.choir_clock") && chr.quest.choir_clock == "clock_started")
					{
						return;
					}
					else
					{
						if(CheckAttribute(chr, "quest.choir_clock") && chr.quest.choir_clock == "key_placed")
						{
							chr.quest.choir_clock = "clock_started";	//this is ok!
							PlaySound("INTERFACE\clock_wind_up.wav");

							LAi_QuestDelay("choir_wind_up_clock", 2.2);
						}
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
						Logit(TranslateString("","It has stopped."));

						LAi_QuestDelay("choir_clock_down", 1.0);
					}
				}
			break;

			case "box18":
				ChangeCharacterAddressGroup(chr, "church_choir", "goto", "gate19");
				PlaySound("PEOPLE\creak2.wav");
			break;

			case "box19":
				ChangeCharacterAddressGroup(chr, "church_choir", "goto", "gate18");
				PlaySound("PEOPLE\creak2.wav");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="church_wine_cellar")
	{
		switch(chr.boxname)
		{
			case "box1":
				//lever is down, cellar is dry (but a little foggy)

				Locations[FindLocation("wr_wine_cellar")].models.always.locators = "Cellar_downstairs_locators_JRH_flood2";
				locations[FindLocation("wr_wine_cellar")].environment.sea = "true";

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_down_floor")
				{
						Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_floor";
						Locations[FindLocation("church_wine_cellar")].models.always.l1 = "";		//no elevator
						Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_down";
						SetCharacterShipLocation(characterFromID("pir_cap26"), "church_wine_cellar");

						SetCharacterShipLocation(characterFromID("pir_cap28"), "church_wine_cellar");//barrel3_roll as a ship
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "";
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_down_barrel")
				{
					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "empty")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_ship";
						Locations[FindLocation("church_wine_cellar")].models.always.l1 = "";		//no elevator
						Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_down";
						SetCharacterShipLocation(characterFromID("pir_cap26"), "church_wine_cellar");

						SetCharacterShipLocation(characterFromID("pir_cap27"), "church_wine_cellar");
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "";
					}

					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "filled")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_down"
					}
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_up")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_45";

					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "empty")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_up";
					}

					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "final")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_steplock";		//was ""
					}
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_up_floor")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_up_floor";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_45";

					SetCharacterShipLocation(characterFromID("pir_cap28"), "church_wine_cellar");
					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "";
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_final")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_final";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_up";
					SetCharacterShipLocation(characterFromID("pir_cap26"), "church_wine_cellar");

					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_steplock";					//was ""
				}

				PlaySound("INTERFACE\lever_up.wav");
				Locations[FindLocation("church_wine_cellar")].models.always.l5 = "lever1_up";
				locations[FindLocation("church_wine_cellar")].environment.sea = "true";

				SetCurrentTime(11.00, 0);
				SetNextWeather("Clear");
				chr.quest.JRH_rain = "Mine Fog 1";

				LAi_QuestDelay("church_wine_cellar_water_in", 0.5);
				return;
			break;

			case "box2":
				//lever is up, cellar is flooded

				Locations[FindLocation("wr_wine_cellar")].models.always.locators = "Cellar_downstairs_locators_JRH_dry2";
				locations[FindLocation("wr_wine_cellar")].environment.sea = "false";

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_down")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_down_barrel";
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_ship")
				{
					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "final")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_final";
						Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_final";
						Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_up";
						SetCharacterShipLocation(characterFromID("pir_cap26"), "none");

						SetCharacterShipLocation(characterFromID("pir_cap27"), "none");
						SetCharacterShipLocation(characterFromID("pir_cap28"), "none");
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_steplock";
					}
					else
					{
						Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_down_barrel";//check!
						Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_down";
						Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_up";
						SetCharacterShipLocation(characterFromID("pir_cap26"), "none");

						SetCharacterShipLocation(characterFromID("pir_cap27"), "none");
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_down";
					}
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_floor")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_down_floor";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_down";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_up";
					SetCharacterShipLocation(characterFromID("pir_cap26"), "none");

					SetCharacterShipLocation(characterFromID("pir_cap28"), "none");
					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_floor";
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_up")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_up";	//already
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_45";		//already

					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "final")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_steplock";
					}
					else Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_up";
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_up_floor")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_up_floor";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_up";	//already
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_45";		//already

					SetCharacterShipLocation(characterFromID("pir_cap28"), "none");
					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_floor";
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_final")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_final";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_final";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_up";
					SetCharacterShipLocation(characterFromID("pir_cap26"), "none");

					SetCharacterShipLocation(characterFromID("pir_cap27"), "none");
					SetCharacterShipLocation(characterFromID("pir_cap28"), "none");
					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_steplock";
				}

				PlaySound("INTERFACE\lever_down.wav");
				Locations[FindLocation("church_wine_cellar")].models.always.l5 = "lever1_down";
				locations[FindLocation("church_wine_cellar")].environment.sea = "false";

				SetCurrentTime(11.00, 0);
				SetNextWeather("Clear");
				chr.quest.JRH_rain = "Mine Fog 1";

				LAi_QuestDelay("church_wine_cellar_water_out", 0.5);
				return;
			break;

			case "box3":
				//free rope end (flood_ship)
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "floor")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_up_floor";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_45";
					SetCharacterShipLocation(characterFromID("pir_cap26"), "none");

					SetCharacterShipLocation(characterFromID("pir_cap27"), "none");
				}
				else
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "elevator3_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_45";
					SetCharacterShipLocation(characterFromID("pir_cap26"), "none");

					SetCharacterShipLocation(characterFromID("pir_cap27"), "none");

					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "empty")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_up";
					}
				}

				LAi_QuestDelay("church_wine_cellar_rope_wall", 0.5);
				return;
			break;

			case "box4":
				//rope on wall
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_up"
				|| Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_up_floor")
				{
					Logit(TranslateString("","No, the elevator is to heavy!"));
					return;
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_up")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_ship";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_down";
					SetCharacterShipLocation(characterFromID("pir_cap26"), "church_wine_cellar");

					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "empty")
					{
						SetCharacterShipLocation(characterFromID("pir_cap27"), "church_wine_cellar");
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "";
					}

					if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "final")
					{
						Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_steplock";		//was ""
					}

					LAi_QuestDelay("church_wine_cellar_rope_free", 0.5);
					return;
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_flood_up_floor")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_flood_floor";
					Locations[FindLocation("church_wine_cellar")].models.always.l1 = "";
					Locations[FindLocation("church_wine_cellar")].models.always.l2 = "rope_down";
					SetCharacterShipLocation(characterFromID("pir_cap26"), "church_wine_cellar");

					LAi_QuestDelay("church_wine_cellar_rope_free", 0.5);
					return;
				}
			break;

			case "box5":
				//empty barrel
				PlaySound("AMBIENT\TAVERN\open_bottle.wav");

				LAi_QuestDelay("empty_church_barrel", 0.5);
				return;
			break;

			case "box6":
				//push barrel off elevator
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				if(CheckAttribute(chr, "quest.church_barrel") && chr.quest.church_barrel == "empty")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_down_floor";
					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_floor";

					LAi_QuestDelay("push_church_barrel_off_elevator", 0.5);
					return;
				}
				else
				{
					Logit(TranslateString("","No, the barrel is to heavy!"));
					return;
				}
			break;

			case "box7":
				//push barrel on OR under elevator
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_down_floor")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_down_barrel";
					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_down";

					LAi_QuestDelay("push_church_barrel_on_elevator", 0.5);
					return;
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_up_floor")
				{
					Locations[FindLocation("church_wine_cellar")].models.always.locators = "cwc_dry_up";
					Locations[FindLocation("church_wine_cellar")].models.always.l6 = "barrel3_steplock";

					LAi_QuestDelay("push_church_barrel_under_elevator", 0.5);
					return;
				}
			break;

			case "box8":
				PlaySound("INTERFACE\Closet_Open.wav");
				LaunchItemsBox(&ar);

				if(locations[FindLocation(chr.location)].box8.items.bladebottle_CE0 >=1)
				{
					LAi_QuestDelay("empty_bottle_check", 0.1);
				}

				LAi_QuestDelay("return_from_box8_churchcellar", 1.0);
				return;
			break;

			case "box9":
				PlaySound("INTERFACE\Closet_Open.wav");
				LaunchItemsBox(&ar);

				if(locations[FindLocation(chr.location)].box9.items.bladebottle_CE0 >=1)
				{
					LAi_QuestDelay("empty_bottle_check", 0.1);
				}

				LAi_QuestDelay("return_from_box9_churchcellar", 1.0);
				return;
			break;

			case "box10":
				PlaySound("INTERFACE\Closet_Open.wav");
				LaunchItemsBox(&ar);
				return;
			break;

			case "box11":
				PlaySound("INTERFACE\Closet_Open.wav");
				LaunchItemsBox(&ar);
				return;
			break;

			case "box12":
				PlaySound("INTERFACE\Closet_Open.wav");
				LaunchItemsBox(&ar);
				return;
			break;

			case "box13":
				//wine barrel
				if(CheckAttribute(chr,"quest.church_wine") && chr.quest.church_wine == "on")
				{
					PlaySound("INTERFACE\water_tap.wav");
					chr.quest.church_wine = "off";
					LAi_SetPlayerType(chr);

					LAi_QuestDelay("church_running_wine", 0.01);
				}
				else
				{
					if(CheckAttribute(chr,"quest.churchcellar_fillbottle") && chr.quest.churchcellar_fillbottle == "on")
					{
						return;
					}
					else
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CE0")
						{
							chr.quest.churchcellar_fillbottle = "on";
							PlaySound("INTERFACE\water_tap.wav");
							LAi_SetStayType(chr);

							LAi_QuestDelay("church_fill_winebottle", 0.5);
						}
						else
						{
							PlaySound("INTERFACE\water_tap.wav");
							chr.quest.church_wine = "on";
							LAi_SetStayType(chr);

							LAi_QuestDelay("church_running_wine", 0.5);
							LAi_QuestDelay("church_its_wine", 1.0);
						}
					}
				}
			break;

			case "box14":
				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_final")
				{
					ChangeCharacterAddressGroup(chr, "church_wine_cellar", "goto", "reload12");
					PlaySound("INTERFACE\rusty.wav");
				}
				else  PlaySound("INTERFACE\locked_window.wav");
			break;

			case "box15":
				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_final")
				{
					ChangeCharacterAddressGroup(chr, "church_wine_cellar", "goto", "reload11");
					PlaySound("INTERFACE\rusty.wav");
				}
				else  PlaySound("INTERFACE\locked_window.wav");
			break;
		//----------------------------------------------------------------------------------------------------
			case "box16":
				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_final")
				{
					ChangeCharacterAddressGroup(chr, "church_wine_cellar", "goto", "box9");
					PlaySound("INTERFACE\rusty.wav");
				}
				else  PlaySound("INTERFACE\locked_window.wav");
			break;

			case "box17":
				ChangeCharacterAddressGroup(chr, "church_wine_cellar", "goto", "reload9");
				PlaySound("INTERFACE\rusty.wav");
			break;
		//----------------------------------------------------------------------------------------------------
			case "box18":
				if(Locations[FindLocation(chr.location)].models.always.locators == "cwc_dry_final")
				{
					ChangeCharacterAddressGroup(chr, "church_wine_cellar", "goto", "box8");
					PlaySound("INTERFACE\rusty.wav");
				}
				else  PlaySound("INTERFACE\locked_window.wav");
			break;

			case "box19":
				ChangeCharacterAddressGroup(chr, "church_wine_cellar", "goto", "reload7");
				PlaySound("INTERFACE\rusty.wav");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_farm_corridor")
	{
		switch(chr.boxname)
		{
			case "box1":
				//at candle
				if(LAi_IsFightMode(chr))
				{
					//this is your 2:nd 'open box', used for picking up scroll46

					if(CheckAttribute(chr, "quest.keymiddle") && chr.quest.keymiddle == "on_counter")
					{
						PlaySound("INTERFACE\took_item.wav");
						chr.quest.keymiddle = "picked_up";
						GiveItem2Character(chr,"key18");

						Locations[FindLocation("wr_farm_corridor")].models.always.l1 = "";
						Locations[FindLocation("wr_farm_corridor")].locators_radius.reload.reload2 = 0.0001;
						Locations[FindLocation("wr_farm_corridor")].locators_radius.box.box2 = 0.5;	//enable key funct

						LAi_QuestDelay("pick_up_key18", 0.5);
						return;
					}

					if(CheckAttribute(chr, "quest.scroll46") && chr.quest.scroll46 == "on_counter")
					{
						PlaySound("INTERFACE\paper.wav");
						chr.quest.scroll46 = "picked_up";
						GiveItem2Character(chr,"book46");

						//key only visible if candle are lit:
						if(Locations[FindLocation("wr_farm_corridor")].models.always.locators == "StoreSmall_locators_JRH_normal")
						{
							Locations[FindLocation("wr_farm_corridor")].models.always.l1 = "keymiddle";
						}
						else Locations[FindLocation("wr_farm_corridor")].models.always.l1 = "";

						LAi_QuestDelay("pick_up_book46", 0.5);
						return;
					}
				}
				else
				{

					string gunID = GetCharacterEquipByGroup(chr,GUN_ITEM_TYPE);
					aref gun;
					Items_FindItem(gunID, &gun);

					if(CheckAttribute(gun, "model"))
					{
						if(HasSubStr(gun.model, "pistol"))
						{
							//LogIt("model is a pistol");
							LAi_QuestDelay("temp_ammo_check_corridor_pistol", 0.1);
						}
					}

					if(CheckAttribute(chr, "quest.scroll46") && chr.quest.scroll46 == "on_counter")
					{
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						EquipCharacterByItem(chr, "bladeX4");
					}

					ChangeCharacterAddressGroup(chr, "wr_farm_corridor", "goto", "candle_stuck");
					LAi_LocationFightDisable(&Locations[FindLocation("wr_farm_corridor")], false);
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("stay_at_candle", 1.0);
					return;
				}
			break;

			case "box2":
				//door function
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_from_corridor", 2.0);
				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_farm_servant")
	{
		switch(chr.boxname)
		{
			case "box3":
				//hatch is hidden

				Locations[FindLocation("wr_farm_servant")].models.always.locators = "sh_l_JRH2_open";
				Locations[FindLocation("wr_farm_alchemy")].reload.l3.disable = 0;	//open from alchemy

				LAi_SetActorType(chr);
				LAi_ActorTurnToLocator(chr, "reload", "reload3");

				LAi_QuestDelay("pull_carpet", 1.0);
				return;
			break;

			case "box4":
				//hatch is visible
				Locations[FindLocation("wr_farm_servant")].models.always.locators = "sh_l_JRH2_closed_doc";
				Locations[FindLocation("wr_farm_alchemy")].reload.l3.disable = 1;	//closed from alchemy

				LAi_SetActorType(chr);
				LAi_ActorTurnToLocator(chr, "goto", "goto3");

				LAi_QuestDelay("pull_carpet", 1.0);
				return;
			break;
		}

		LaunchItemsBox(&ar);
		return;
	}

	if(Locations[locidx].id=="wr_wine_cellar")
	{
		switch(chr.boxname)
		{
			case "box1":
				//lever is down, cellar is dry (but a little foggy)
				PlaySound("INTERFACE\lever_up.wav");
				Locations[FindLocation("wr_wine_cellar")].models.always.l2 = "lever1_up";
				locations[FindLocation("wr_wine_cellar")].environment.sea = "true";

				SetCurrentTime(11.00, 0);
				SetNextWeather("Clear");
				chr.quest.JRH_rain = "Mine Fog 1";

				if(CheckAttribute(chr,"quest.wine_cellar_enemies") && chr.quest.wine_cellar_enemies == "started")
				{
					Locations[FindLocation("wr_wine_cellar")].models.always.locators = "Cellar_downstairs_locators_JRH_flood2";
				}
				else Locations[FindLocation("wr_wine_cellar")].models.always.locators = "Cellar_downstairs_locators_JRH_flood1";

				LAi_QuestDelay("wr_wine_cellar_water_in", 0.5);
				return;
			break;

			case "box2":
				//lever is up, cellar is flooded
				PlaySound("INTERFACE\lever_down.wav");

				Locations[FindLocation("wr_wine_cellar")].models.always.l2 = "lever1_down";
				locations[FindLocation("wr_wine_cellar")].environment.sea = "false";

				SetCurrentTime(11.00, 0);
				SetNextWeather("Clear");
				chr.quest.JRH_rain = "Mine Fog 1";

				if(Locations[FindLocation(chr.location)].models.always.locators == "Cellar_downstairs_locators_JRH_flood1")
					Locations[FindLocation("wr_wine_cellar")].models.always.locators = "Cellar_downstairs_locators_JRH_dry1";

				if(Locations[FindLocation(chr.location)].models.always.locators == "Cellar_downstairs_locators_JRH_flood2")
					Locations[FindLocation("wr_wine_cellar")].models.always.locators = "Cellar_downstairs_locators_JRH_dry2";

				LAi_QuestDelay("wr_wine_cellar_water_out", 0.5);
				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="Defoes_cabin")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("INTERFACE\paper.wav");
				return;
			break;

			case "box2":
				PlaySound("INTERFACE\paper.wav");
				return;
			break;

			case "box4":
				PlaySound("INTERFACE\door_locked2.wav");
				return;
			break;

			case "box5":
				PlaySound("INTERFACE\door_locked2.wav");
				return;
			break;

			case "box6":
				PlaySound("INTERFACE\paper.wav");
				return;
			break;

			LaunchItemsBox(&ar);
		}
		return;
	}

	if(Locations[locidx].id=="wr_gall_captain")
	{
		switch(chr.boxname)
		{
			case "box3":
				string weaponID7 = GetCharacterEquipByGroup(chr,BLADE_ITEM_TYPE);
				aref weapon7;
				Items_FindItem(weaponID7, &weapon7);

				if(CheckAttribute(chr,"quest.gall_captain") && chr.quest.gall_captain == "open")
				{
					Logit(TranslateString("","Cannonball storage"));
					PlaySound("PEOPLE\step_iron.wav");
					PlaySound("PEOPLE\step_iron.wav");
					PlaySound("PEOPLE\step_iron.wav");
					return;
				}

				if(LAi_IsFightMode(chr))
				{
					PlaySound("PEOPLE\blade_basket.wav");
					PlaySound("OBJECTS\DUEL\sword_broken.wav");
					RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
					TakeNItems(chr, weaponID7, -20);
					EquipCharacterByItem(chr, "bladeX4");

					EquipCharacterByItem(chr, "pistol203");

					LAi_QuestDelay("cannonballs_again", 2.0);
				}
				else
				{
					if(CheckAttribute(weapon7, "id"))
					{
						if(weapon7.id == "bladeX4" || weapon7.id == ""
						|| weapon7.id == "bladepowderhornA" || weapon7.id == "bladepowderhornP" )
						{
							Logit(TranslateString("","I need a blade to open that box!"));
						}
					}

					if(CheckCharacterItem(chr,"bladeA11"))
					{
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						EquipCharacterByItem(chr, "bladeA11");
					}

					LAi_SetFightMode(chr, true);
					return;
				}
			break;

			LaunchItemsBox(&ar);
		}
		return;
	}

	if(Locations[locidx].id=="wr_corv_capmd")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("INTERFACE\locked_window.wav");
				return;
			break;

			case "box2":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box3":
				if(CheckAttribute(chr,"quest.ship_wc") && chr.quest.ship_wc == "sit_down")
				{
					PlaySound("PEOPLE\Toilet.wav");

					LAi_QuestDelay("ship_wc", 1.5);	//was 2.3
				}

				if(CheckAttribute(chr,"quest.ship_wc") && chr.quest.ship_wc == "start")
				{
					ChangeCharacterAddressGroup(chr, "wr_corv_capmd", "goto", "wc_stay");
					LAi_SetSitType(chr);
					PlaySound("AMBIENT\JAIL\sigh.wav");
					chr.quest.ship_wc = "sit_down";
				}
			break;

			case "box4":
				ChangeCharacterAddressGroup(chr, "wr_corv_capmd", "goto", "wc_stay");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_corv_capsm")
	{
		switch(chr.boxname)
		{
			case "box2":
				PlaySound("PEOPLE\ram.wav");

				if(Locations[FindLocation("wr_corv_capsm")].reload.l1.disable == 1)
				{
					LAi_QuestDelay("unlock_capsm_crew", 0.5);
				}

				if(Locations[FindLocation("wr_corv_capsm")].reload.l1.disable == 0)
				{
					LAi_QuestDelay("lock_capsm_crew", 0.5);
				}
			break;

			case "box3":
				//placing barrel2 on floor

				if(LAi_IsFightMode(chr))
				{
					//this is your 2:nd 'open box'

					if(CheckCharacterItem(chr,"bladebarrel2"))
					{
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						TakeItemFromCharacter(chr, "bladebarrel2");

						if(CheckCharacterItem(chr,"bladeanchor"))
						{
							EquipcharacterByItem(chr, "bladeanchor");
						}
						else EquipcharacterByItem(chr, "bladepclub203");

						Locations[FindLocation("wr_corv_capsm")].models.always.locators = "capsm_l_JRH2";//barrel placed
						Locations[FindLocation("wr_corv_capsm")].image = "";
						DoQuestReloadToLocation("wr_corv_capsm", "goto", "barrel", "Vane_at_corvette6");
					}
				}
				else
				{
					LAi_LocationFightDisable(&Locations[FindLocation("wr_corv_capsm")], false);
					LAi_SetFightMode(chr, true);
				}
			break;

			case "box4":
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "wr_corv_capsm", "reload", "reload3");

				LAi_QuestDelay("enter_via_wc", 1.0);
			break;

			LaunchItemsBox(&ar);
			return;
		}
		return;
	}

	if(Locations[locidx].id=="wr_corv_crew")
	{
		switch(chr.boxname)
		{
			case "box3":
				//door to yellow deck
				if(LAi_IsFightMode(chr))
				{
					//this is your 2:nd 'open box', using bladeitems. (fire gun = gunitems)
					if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladekeysimple")
					{
						PlaySound("INTERFACE\key_unlock.wav");

						LAi_QuestDelay("unlock_crew_deck1", 1.0);
					}

					if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladecompasses")
					{
						if(CheckAttribute(chr,"quest.beltkey") && chr.quest.beltkey == "on_map")
						{
							if(CheckAttribute(chr,"quest.tablemap") && chr.quest.tablemap == "on_floor")
							{
								//pick up key here
								PlaySound("INTERFACE\took_item.wav");
								chr.quest.beltkey = "picked_up";
								GiveItem2Character(chr, "bladekeysimple");
								EquipCharacterByItem(chr, "bladekeysimple");
								Locations[FindLocation("wr_corv_crew")].models.always.l3 = "";//no key
								Locations[FindLocation("wr_corv_crew")].models.always.l2 = "";//no map
								TakeItemFromCharacter(chr, "bladecompasses");
								RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
								TakeItemFromCharacter(chr, "pistolhand");

								LAi_QuestDelay("use_gunitem_at_belt_door", 1.0);
							}
							else LAi_QuestDelay("use_bladeitem_at_belt_door", 1.0);//???
						}

						if(CheckAttribute(chr,"quest.beltkey") && chr.quest.beltkey == "in_lock")
						{
							if(CheckAttribute(chr,"quest.tablemap") && chr.quest.tablemap == "under_door")
							{
								PlaySound("PEOPLE\beltkey_drop.wav");
								chr.quest.beltkey = "on_map";

								LAi_QuestDelay("use_bladeitem_at_belt_door", 1.0);
							}
							else
							{
								PlaySound("PEOPLE\beltkey.wav");
								Logit(TranslateString("","The door is locked from the other side with the key still in the lock."));

								LAi_QuestDelay("use_bladeitem_at_belt_door", 1.0);
							}
						}
					}
				}
				else
				{
					ChangeCharacterAddressGroup(chr, "wr_corv_crew", "goto", "goto8");
					LAi_SetActorType(chr);
					LAi_ActorTurnToLocator(chr, "goto", "goto10");

					LAi_QuestDelay("stay_at_belt_door", 0.5);
					return;
				}
			break;

			case "box4":
				if(CheckAttribute(chr,"quest.crew_to_ships") && chr.quest.crew_to_ships == "closed")
				{
					Logit(TranslateString("","Prize ships"));
					PlaySound("INTERFACE\knock.wav");
					return;
				}
				else
				{
					ChangeCharacterAddressGroup(chr, "wr_corv_crew", "reload", "reload3");
					PlaySound("PEOPLE\creak2.wav");
				}
			break;

			LaunchItemsBox(&ar);
			return;
		}
		return;
	}

	if(Locations[locidx].id=="wr_farm_bedroom")
	{
		switch(chr.boxname)
		{
			case "box1":
				//niche is hidden
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				Locations[FindLocation(chr.location)].models.always.locators = "largehouse02_locators_JRH2";
				Locations[FindLocation("wr_farm_bedroom")].image = "";

				if(CheckAttribute(chr,"quest.book49_check") && chr.quest.book49_check == "off")
				{
					chr.quest.book49_check = "on";
					LAi_QuestDelay("book49_pickup_check", 0.1);
				}

				LAi_QuestDelay("change_bedroom_chart", 1.0);
			break;

			case "box4":
				//niche is open
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				Locations[FindLocation(chr.location)].models.always.locators = "largehouse02_locators_JRH1";
				Locations[FindLocation("wr_farm_bedroom")].image = "";

				LAi_QuestDelay("change_bedroom_chart", 1.0);
			break;

			case "box2":
				//window is closed
				if(Locations[FindLocation("wr_farm_bedroom")].models.always.window == "largehouse02_windows")
				{
					PlaySound("PEOPLE\beltkey.wav");
					Locations[FindLocation("wr_farm_bedroom")].models.always.window = "largehouse02_windows2";	//1 closed hatch
					Locations[FindLocation("wr_farm_bedroom")].models.always.l4 = "largehouse02_windows3";		//1 open hatch
					Locations[FindLocation("wr_farm_bedroom")].locators_radius.box.box2 = 0.0001;
					Locations[FindLocation("wr_farm_bedroom")].locators_radius.box.box3 = 1.0;
					locations[FindLocation("wr_farm_bedroom")].type = "indian_seashore";
					Locations[FindLocation("wr_farm_bedroom")].image = "";

					LAi_QuestDelay("open_bedroom_window", 1.0);
				}
			break;

			case "box3":
				//window is open
				if(Locations[FindLocation("wr_farm_bedroom")].models.always.window == "largehouse02_windows2")
				{
					PlaySound("PEOPLE\creak2.wav");
					Locations[FindLocation("wr_farm_bedroom")].models.always.window = "largehouse02_windows";	//2 closed hatches
					Locations[FindLocation("wr_farm_bedroom")].models.always.l4 = "";		//no open hatch
					Locations[FindLocation("wr_farm_bedroom")].locators_radius.box.box2 = 1.0;
					Locations[FindLocation("wr_farm_bedroom")].locators_radius.box.box3 = 0.0001;
					locations[FindLocation("wr_farm_bedroom")].type = "Rogers_private";
					Locations[FindLocation("wr_farm_bedroom")].image = "";

					LAi_QuestDelay("close_bedroom_window", 1.0);
				}
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_corv_deck1")
	{
		switch(chr.boxname)
		{
			case "box1":
				if(IsEquipCharacterByItem(chr, "bladebottle_CT2_sulf_w"))
				{
					ChangeCharacterAddressGroup(chr, "wr_corv_deck1", "goto", "goto3");
					LAi_SetActorType(chr);
					LAi_ActorTurnToLocator(chr, "goto", "goto4");

					LAi_QuestDelay("acid_copper_door", 1.0);
				}
			break;

			case "box2":
				PlaySound("PEOPLE\Jump_Counter.wav");
				ChangeCharacterAddressGroup(chr, "wr_corv_deck1", "goto", "crate2");

				LAi_QuestDelay("yellow_jump_crate2", 0.5);
			break;

			case "box3":
				PlaySound("PEOPLE\Jump_Counter.wav");
				ChangeCharacterAddressGroup(chr, "wr_corv_deck1", "goto", "crate3");

				LAi_QuestDelay("yellow_jump_crate3", 0.5);
			break;

			case "box4":
				PlaySound("PEOPLE\run_wood.wav");
				ChangeCharacterAddressGroup(chr, "wr_corv_deck1", "goto", "stair");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_gall_galley")
	{
		LaunchItemsBox(&ar);
		return;
	}

	if(Locations[locidx].id=="wr_farm_alchemy")
	{
		switch(chr.boxname)
		{
			case "box1":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box2":
				//LEVER
				if(CheckAttribute(chr,"quest.alchemy_lever") && chr.quest.alchemy_lever == "down")
				{
						PlaySound("INTERFACE\lever_up.wav");
						chr.quest.alchemy_lever = "up";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l6 = "lever1_up";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l4 = "bars_up";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l3 = "plank_down";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l7 = "rope_down";

						Locations[FindLocation("wr_farm_alchemy")].locators_radius.box.box4 = 0.5;//at fireplace
						Locations[FindLocation("wr_farm_alchemy")].locators_radius.box.box3 = 0.0001;//plank disabled

						LAi_QuestDelay("alchemy_bars_up", 0.5);
				}
				else
				{
						PlaySound("INTERFACE\lever_down.wav");
						chr.quest.alchemy_lever = "down";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l6 = "lever1_down";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l4 = "bars_down";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l3 = "plank_up";
						Locations[FindLocation("wr_farm_alchemy")].models.always.l7 = "rope_up";

						Locations[FindLocation("wr_farm_alchemy")].locators_radius.box.box4 = 0.0001;//at fireplace
						Locations[FindLocation("wr_farm_alchemy")].locators_radius.box.box3 = 0.5;//plank enabled

						LAi_QuestDelay("alchemy_bars_down", 0.5);
				}
			break;

			case "box3":
				//OXYGEN
				LAi_SetSitType(chr);
				PlaySound("PEOPLE\basket.wav");

				LAi_QuestDelay("alchemy_plank_oxygen", 0.8);
			break;

			case "box4":
				//FIREPLACE
				if(LAi_IsFightMode(chr))
				{
					//this is your 2:nd 'open box', used for placing bladeitems. (fire gun = gunitems)

					if(CheckAttribute(chr,"quest.apparatus_level"))
					{
						if(chr.quest.apparatus_level == "start")
						{
							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladecauldron")
							{
								PlaySound("INTERFACE\pinion_place.wav");
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								TakeItemFromCharacter(chr, "bladecauldron");
								EquipCharacterByItem(chr, "bladeX4");

								chr.quest.apparatus_level = "cauldron";
								chr.quest.cauldron = "empty";
								chr.quest.apparatus_cooling = "1";
								Locations[FindLocation("wr_farm_alchemy")].models.always.l9 = "cauldron3";

								LAi_QuestDelay("place_distillery_item", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladecauldron_w")
							{
								PlaySound("INTERFACE\pinion_place.wav");
								PlaySound("INTERFACE\rum_barrel_filled.wav");
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								TakeItemFromCharacter(chr, "bladecauldron_w");
								EquipCharacterByItem(chr, "bladeX4");

								chr.quest.apparatus_level = "cauldron";
								chr.quest.cauldron = "water";
								chr.quest.apparatus_cooling = "2";
								Locations[FindLocation("wr_farm_alchemy")].models.always.l9 = "cauldron3_w";

								if(CheckAttribute(chr,"quest.qbook_cauldron") && chr.quest.qbook_cauldron == "done")
								{

								}
								else
								{
									chr.quest.qbook_cauldron = "done";
									AddQuestRecord("Alchemy_apparatus", "2");
								}

								LAi_QuestDelay("place_distillery_item", 1.0);
								LAi_QuestDelay("alchemy_boiling_loop", 2.0);
								return;
							}
						}

						if(chr.quest.apparatus_level == "retort")
						{
							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladetop")
							{
								PlaySound("INTERFACE\glass1.wav");
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								TakeItemFromCharacter(chr, "bladetop");
								EquipCharacterByItem(chr, "bladeX4");

								chr.quest.apparatus_level = "top";
								chr.quest.top = "yes";
								Locations[FindLocation("wr_farm_alchemy")].models.always.l11 = "top3";

								LAi_QuestDelay("place_distillery_item", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CG2")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "G2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_G2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_sulf_c")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "T2_sulf_c";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_T2_sulf_c";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CP2")
							{
								PlaySound("OBJECTS\DUEL\pistol_small2.wav");
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "P2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_P2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								if(CheckAttribute(chr,"quest.qbook_retort") && chr.quest.qbook_retort == "done")
								{

								}
								else
								{
									chr.quest.qbook_retort = "done";
									AddQuestRecord("Alchemy_tutorial", "5");
								}

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}
						}

						if(chr.quest.apparatus_level == "top")
						{
							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CG2")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "G2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_G2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_sulf_c")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "T2_sulf_c";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_T2_sulf_c";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CP2")
							{
								PlaySound("OBJECTS\DUEL\pistol_small2.wav");
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "P2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_P2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								if(CheckAttribute(chr,"quest.qbook_retort") && chr.quest.qbook_retort == "done")
								{

								}
								else
								{
									chr.quest.qbook_retort = "done";
									AddQuestRecord("Alchemy_tutorial", "5");
								}

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}
						}

						if(chr.quest.apparatus_level == "glass_tube")
						{
							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CE0")
							{
								PlaySound("INTERFACE\glass1.wav");
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								TakeItemFromCharacter(chr, "bladebottle_CE0");
								EquipCharacterByItem(chr, "bladeX4");

								chr.quest.apparatus_level = "empty_bottle";
								chr.quest.empty_bottle = "yes";
								Locations[FindLocation("wr_farm_alchemy")].models.always.l13 = "bottle_FE0";

								if(CheckAttribute(chr,"quest.qbook_receiver") && chr.quest.qbook_receiver == "done")
								{

								}
								else
								{
									chr.quest.qbook_receiver = "done";
									AddQuestRecord("Alchemy_apparatus", "1");

									if(CheckAttribute(chr,"quest.cauldron") && chr.quest.cauldron == "water")
									{
										CloseQuestHeader("Alchemy_apparatus");
										chr.quest.apparatus_hint = "no";
									}
								}

								LAi_QuestDelay("glass_on_stool_sound", 0.5);
								LAi_QuestDelay("place_distillery_item", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CG2")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "G2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_G2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_sulf_c")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "T2_sulf_c";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_T2_sulf_c";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CP2")
							{
								PlaySound("OBJECTS\DUEL\pistol_small2.wav");
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "P2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_P2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								if(CheckAttribute(chr,"quest.qbook_retort") && chr.quest.qbook_retort == "done")
								{

								}
								else
								{
									chr.quest.qbook_retort = "done";
									AddQuestRecord("Alchemy_tutorial", "5");
								}

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}
						}

						if(chr.quest.apparatus_level == "empty_bottle")
						{
							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CG2")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								//apparatus_level still is empty_bottle obs!
								chr.quest.apparatus_liquid = "G2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_G2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_sulf_c")
							{
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "T2_sulf_c";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_T2_sulf_c";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CP2")
							{
								PlaySound("OBJECTS\DUEL\pistol_small2.wav");
								PlaySound("AMBIENT\TAVERN\open_bottle.wav");
								chr.quest.apparatus_liquid = "P2";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l10 = "retort_P2";

								if(CheckAttribute(chr, "quest.cauldron") && chr.quest.cauldron == "water")
								{
									chr.quest.apparatus_cooling = "3";
								}
								else chr.quest.apparatus_cooling = "2";

								if(CheckAttribute(chr,"quest.qbook_retort") && chr.quest.qbook_retort == "done")
								{

								}
								else
								{
									chr.quest.qbook_retort = "done";
									AddQuestRecord("Alchemy_tutorial", "5");
								}

								LAi_QuestDelay("fill_apparatus_with_liquid", 0.5);
								return;
							}
						}

						if(chr.quest.apparatus_level == "finished")
						{
							if(CheckAttribute(chr, "quest.apparatus_liquid") && chr.quest.apparatus_liquid == "G2")
							{
								PlaySound("INTERFACE\button2.wav");
								chr.quest.apparatus_level = "glass_tube";
								chr.quest.apparatus_liquid = "none";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l13 = "";
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								GiveItem2Character(chr,"bladebottle_CT1_sulf");
								EquipCharacterByItem(chr, "bladebottle_CT1_sulf");

								LAi_QuestDelay("place_distillery_item", 0.5);
							}
							if(CheckAttribute(chr, "quest.apparatus_liquid") && chr.quest.apparatus_liquid == "T2_sulf_c")
							{
								PlaySound("INTERFACE\button2.wav");
								chr.quest.apparatus_level = "glass_tube";
								chr.quest.apparatus_liquid = "none";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l13 = "";
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								GiveItem2Character(chr,"bladebottle_CT1_nitr");
								EquipCharacterByItem(chr, "bladebottle_CT1_nitr");

								LAi_QuestDelay("place_distillery_item", 0.5);
							}
							if(CheckAttribute(chr, "quest.apparatus_liquid") && chr.quest.apparatus_liquid == "P2")
							{
								PlaySound("INTERFACE\button2.wav");
								chr.quest.apparatus_level = "glass_tube";
								chr.quest.apparatus_liquid = "none";

								Locations[FindLocation("wr_farm_alchemy")].models.always.l13 = "";
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								GiveItem2Character(chr,"bladebottle_CB1");
								EquipCharacterByItem(chr, "bladebottle_CB1");

								if(CheckAttribute(chr,"quest.qbook_alcohol") && chr.quest.qbook_alcohol == "done")
								{

								}
								else
								{
									chr.quest.qbook_alcohol = "done";
									AddQuestRecord("Alchemy_tutorial", "3");
								}

								LAi_QuestDelay("place_distillery_item", 0.5);
							}
						}

						if(chr.quest.apparatus_level != "start" && chr.quest.cauldron == "empty")
						{
							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CW1")
							{
								PlaySound("INTERFACE\bottle_molasses.wav");
								RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
								TakeItemFromCharacter(chr, "bladebottle_CW1");
								GiveItem2Character(chr,"bladebottle_CE0");
								EquipCharacterByItem(chr, "bladebottle_CE0");

								chr.quest.cauldron = "water";
								Locations[FindLocation("wr_farm_alchemy")].models.always.l9 = "cauldron3_w";
								if(CheckAttribute(chr, "quest.apparatus_liquid") && chr.quest.apparatus_liquid == "none")
								{
									chr.quest.apparatus_cooling = "2";
								}
								else chr.quest.apparatus_cooling = "3";

								if(CheckAttribute(chr,"quest.qbook_cauldron") && chr.quest.qbook_cauldron == "done")
								{

								}
								else
								{
									chr.quest.qbook_cauldron = "done";
									AddQuestRecord("Alchemy_apparatus", "2");


									if(CheckAttribute(chr,"quest.apparatus_level") && chr.quest.apparatus_level == "empty_bottle")
									{
										CloseQuestHeader("Alchemy_apparatus");
										chr.quest.apparatus_hint = "no";
									}
								}

								LAi_QuestDelay("place_distillery_item", 3.0);
								LAi_QuestDelay("alchemy_boiling_loop", 4.0);
								return;
							}
						}
					}
				}
				else
				{
					if(CheckAttribute(chr, "quest.apparatus_level") && chr.quest.apparatus_level == "finished")
					{
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						EquipCharacterByItem(chr, "bladeX4");
					}

					chr.quest.lab_position = "fireplace";
					ChangeCharacterAddressGroup(chr, "wr_farm_alchemy", "goto", "fireplace_stuck");
					LAi_LocationFightDisable(&Locations[FindLocation("wr_farm_alchemy")], false);
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("stay_at_fireplace", 1.0);
					return;
				}
			break;

			case "box5":
				//MIXTABLE
				if(LAi_IsFightMode(chr))
				{
					//this is your 2:nd 'open box', used for placing, filling or picking up bottles

					//NO BOTTLE
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "none")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CE0")
						{
							PlaySound("INTERFACE\glass1.wav");
							PlaySound("PEOPLE\step_stairway2.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CE0");
							EquipCharacterByItem(chr, "bladeX4");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_ME0";
							chr.quest.mixtable_bottle = "ME0";

							LAi_QuestDelay("place_mixtable_item", 0.5);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CW1")
						{
							PlaySound("INTERFACE\glass2.wav");
							PlaySound("PEOPLE\step_stairway2.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CW1");
							EquipCharacterByItem(chr, "bladeX4");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MW1";
							chr.quest.mixtable_bottle = "MW1";

							LAi_QuestDelay("place_mixtable_item", 0.5);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CB1")
						{
							PlaySound("INTERFACE\glass2.wav");
							PlaySound("PEOPLE\step_stairway2.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CB1");
							EquipCharacterByItem(chr, "bladeX4");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MB1";
							chr.quest.mixtable_bottle = "MB1";

							LAi_QuestDelay("place_mixtable_item", 0.5);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_sulf")
						{
							PlaySound("INTERFACE\glass2.wav");
							PlaySound("PEOPLE\step_stairway2.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_sulf");
							EquipCharacterByItem(chr, "bladeX4");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_sulf";
							chr.quest.mixtable_bottle = "MT1_sulf";

							LAi_QuestDelay("place_mixtable_item", 0.5);
							LAi_QuestDelay("alchemy_acid_fog", 1.5);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_nitr")
						{
							PlaySound("INTERFACE\glass2.wav");
							PlaySound("PEOPLE\step_stairway2.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_nitr");
							EquipCharacterByItem(chr, "bladeX4");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_nitr";
							chr.quest.mixtable_bottle = "MT1_nitr";

							LAi_QuestDelay("place_mixtable_item", 0.5);
							LAi_QuestDelay("alchemy_acid_fog", 1.5);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_hydr")
						{
							PlaySound("INTERFACE\glass2.wav");
							PlaySound("PEOPLE\step_stairway2.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_hydr");
							EquipCharacterByItem(chr, "bladeX4");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_hydr";
							chr.quest.mixtable_bottle = "MT1_hydr";

							LAi_QuestDelay("place_mixtable_item", 0.5);
							LAi_QuestDelay("alchemy_acid_fog", 1.5);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_hydrnitr")
						{
							PlaySound("INTERFACE\glass2.wav");
							PlaySound("PEOPLE\step_stairway2.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_hydrnitr");
							EquipCharacterByItem(chr, "bladeX4");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_hydrnitr";
							chr.quest.mixtable_bottle = "MT1_hydrnitr";

							LAi_QuestDelay("place_mixtable_item", 0.5);
							return;
						}
						//other bottles ev. in here giving Hmm that's not a good idea or so...
					}

					//EMPTY BOTTLE
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "ME0")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CW1")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CW1");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MW1";
							chr.quest.mixtable_bottle = "MW1";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CB1")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CB1");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MB1";
							chr.quest.mixtable_bottle = "MB1";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_sulf")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_sulf");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_sulf";
							chr.quest.mixtable_bottle = "MT1_sulf";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							LAi_QuestDelay("alchemy_acid_fog", 4.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_nitr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_nitr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_nitr";
							chr.quest.mixtable_bottle = "MT1_nitr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							LAi_QuestDelay("alchemy_acid_fog", 4.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_hydr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_hydr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_hydr";
							chr.quest.mixtable_bottle = "MT1_hydr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							LAi_QuestDelay("alchemy_acid_fog", 4.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_hydrnitr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_hydrnitr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_hydrnitr";
							chr.quest.mixtable_bottle = "MT1_hydrnitr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_hydr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT2_hydr");
							GiveItem2Character(chr,"bladebottle_CT1_hydr");
							EquipCharacterByItem(chr, "bladebottle_CT1_hydr");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_hydr";
							chr.quest.mixtable_bottle = "MT1_hydr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							LAi_QuestDelay("alchemy_acid_fog", 4.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_hydrnitr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT2_hydrnitr");
							GiveItem2Character(chr,"bladebottle_CT1_hydrnitr");
							EquipCharacterByItem(chr, "bladebottle_CT1_hydrnitr");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT1_hydrnitr";
							chr.quest.mixtable_bottle = "MT1_hydrnitr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						//other bottles ev. in here giving Hmm that's not a good idea or so...
					}

					//HALF FULL BOTTLE: WATER
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MW1")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CB1")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CB1");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MB2";
							chr.quest.mixtable_bottle = "MB2";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_sulf")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_sulf");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_sulf_w";
							chr.quest.mixtable_bottle = "MT2_sulf_w";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_nitr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_nitr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_nitr_w";
							chr.quest.mixtable_bottle = "MT2_nitr_w";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						//other bottles ev. in here giving Hmm that's not a good idea or so...
					}

					//HALF FULL BOTTLE: ALCOHOL
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MB1")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CW1")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CW1");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MB2";
							chr.quest.mixtable_bottle = "MB2";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}
					}

					//HALF FULL BOTTLE: H2SO4
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT1_sulf")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CW1")
						{
							//explosion
							PlaySound("INTERFACE\bottle_molasses.wav");

							LAi_QuestDelay("alchemy_acid_explosion", 3.0);
							return;
						}
					}

					//HALF FULL BOTTLE: HNO3
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT1_nitr")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_hydr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_hydr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_hydrnitr";
							chr.quest.mixtable_bottle = "MT2_hydrnitr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_hydr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT2_hydr");
							GiveItem2Character(chr,"bladebottle_CT1_hydr");
							EquipCharacterByItem(chr, "bladebottle_CT1_hydr");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_hydrnitr";
							chr.quest.mixtable_bottle = "MT2_hydrnitr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CW1")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CW1");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							LAi_QuestDelay("alchemy_acid_boiling", 3.0);
							return;
						}
					}

					//HALF FULL BOTTLE: HCl
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT1_hydr")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_nitr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_nitr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_hydrnitr";
							chr.quest.mixtable_bottle = "MT2_hydrnitr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_hydrnitr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_hydrnitr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MA2";
							chr.quest.mixtable_bottle = "MA2";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_hydrnitr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT2_hydrnitr");
							GiveItem2Character(chr,"bladebottle_CT1_hydrnitr");
							EquipCharacterByItem(chr, "bladebottle_CT1_hydrnitr");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MA2";
							chr.quest.mixtable_bottle = "MA2";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}
					}

					//HALF FULL BOTTLE: HCl + HNO3
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT1_hydrnitr")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_hydr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_hydr");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MA2";
							chr.quest.mixtable_bottle = "MA2";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT2_hydr")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT2_hydr");
							GiveItem2Character(chr,"bladebottle_CT1_hydr");
							EquipCharacterByItem(chr, "bladebottle_CT1_hydr");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MA2";
							chr.quest.mixtable_bottle = "MA2";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}
					}

					//HALF FULL BOTTLE: copperas
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MV1")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CW1")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CW1");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");

							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MG2";
							chr.quest.mixtable_bottle = "MG2";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}
					}

					//HALF FULL BOTTLE: nitre
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MS1_chil")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_sulf")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_sulf");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_sulf_c";
							chr.quest.mixtable_bottle = "MT2_sulf_c";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							return;
						}
					}

					//HALF FULL BOTTLE: salt
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MS1_salt")
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CT1_sulf")
						{
							PlaySound("INTERFACE\bottle_molasses.wav");
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							TakeItemFromCharacter(chr, "bladebottle_CT1_sulf");
							GiveItem2Character(chr,"bladebottle_CE0");
							EquipCharacterByItem(chr, "bladebottle_CE0");
							locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "bottle_MT2_hydr";
							chr.quest.mixtable_bottle = "MT2_hydr";

							LAi_QuestDelay("place_mixtable_item", 3.0);
							LAi_QuestDelay("alchemy_acid_fog", 4.0);
							return;
						}
					}

					//FULL BOTTLE: cognac
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MB2")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";

						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CB2");
						EquipCharacterByItem(chr, "bladebottle_CB2");

						if(CheckAttribute(chr, "quest.boat_to_prizeships") && chr.quest.boat_to_prizeships == "not_yet")
						{
							LAi_SetStayType(chr);
						}

						if(CheckAttribute(chr,"quest.qbook_cognac") && chr.quest.qbook_cognac == "done")
						{

						}
						else
						{
							chr.quest.qbook_cognac = "done";
							AddQuestRecord("Alchemy_tutorial", "4");
							CloseQuestHeader("Alchemy_tutorial");
							chr.quest.process_hint = "no";
						}

						LAi_QuestDelay("place_mixtable_item", 0.5);
						LAi_QuestDelay("switch_to_potion_cognac", 3.0);		//was 5.0
					}

					//FULL BOTTLE: H2SO4 + water
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT2_sulf_w")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CT2_sulf_w");
						EquipCharacterByItem(chr, "bladebottle_CT2_sulf_w");
						chr.quest.Minerva_copper = "no";
						AddQuestRecord("Alchemy_copper", "2");

						LAi_QuestDelay("place_mixtable_item", 0.5);
					}

					//FULL BOTTLE: H2SO4 + nitre
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT2_sulf_c")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CT2_sulf_c");
						EquipCharacterByItem(chr, "bladebottle_CT2_sulf_c");

						LAi_QuestDelay("place_mixtable_item", 0.5);
					}

					//FULL BOTTLE: HNO3 + water (Aqua Fortis)
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT2_nitr_w")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CT2_nitr_w");
						EquipCharacterByItem(chr, "bladebottle_CT2_nitr_w");
						chr.quest.Minerva_silver = "no";
						AddQuestRecord("Alchemy_silver", "2");

						LAi_QuestDelay("place_mixtable_item", 0.5);
					}

					//FULL BOTTLE: HCl
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT2_hydr")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CT2_hydr");
						EquipCharacterByItem(chr, "bladebottle_CT2_hydr");

						LAi_QuestDelay("place_mixtable_item", 0.5);
					}

					//FULL BOTTLE: HCl + HNO3
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MT2_hydrnitr")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CT2_hydrnitr");
						EquipCharacterByItem(chr, "bladebottle_CT2_hydrnitr");

						LAi_QuestDelay("place_mixtable_item", 0.5);
					}

					//FULL BOTTLE: Aqua Regis
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MA2")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CA2");
						EquipCharacterByItem(chr, "bladebottle_CA2");
						chr.quest.Minerva_gold = "no";
						AddQuestRecord("Alchemy_gold", "2");

						LAi_QuestDelay("place_mixtable_item", 0.5);
					}

					//FULL BOTTLE: copperas + water
					if(CheckAttribute(chr, "quest.mixtable_bottle") && chr.quest.mixtable_bottle == "MG2")
					{
						PlaySound("INTERFACE\button2.wav");
						chr.quest.mixtable_bottle = "none";

						Locations[FindLocation("wr_farm_alchemy")].models.always.l5 = "";
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr,"bladebottle_CG2");
						EquipCharacterByItem(chr, "bladebottle_CG2");

						LAi_QuestDelay("place_mixtable_item", 0.5);
					}
				}
				else
				{
					if(CheckAttribute(chr, "quest.mixtable_bottle"))
					{
						if(chr.quest.mixtable_bottle == "MA2" || chr.quest.mixtable_bottle == "MG2" || chr.quest.mixtable_bottle == "MT2_hydrnitr"
						|| chr.quest.mixtable_bottle == "MT2_hydr" || chr.quest.mixtable_bottle == "MT2_sulf_c" || chr.quest.mixtable_bottle == "MT2_sulf_w"
						|| chr.quest.mixtable_bottle == "MT2_nitr_w" || chr.quest.mixtable_bottle == "MB2")
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladeX4");
						}
					}

					chr.quest.lab_position = "mixtable";
					ChangeCharacterAddressGroup(chr, "wr_farm_alchemy", "goto", "mixtable_stuck");
					LAi_LocationFightDisable(&Locations[FindLocation("wr_farm_alchemy")], false);
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("stay_at_mixtable", 1.0);
					return;
				}
			break;

			case "box6":
				PlaySound("INTERFACE\key_unlock.wav");
				chr.quest.distillery_items = "open";

				LAi_QuestDelay("unlock_from_alchemy", 2.0);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_farm_booty")
	{
		switch(chr.boxname)
		{
			case "box8":
				//water barrel
				if(CheckAttribute(chr,"quest.farm_water") && chr.quest.farm_water == "on")
				{
					PlaySound("INTERFACE\water_tap.wav");
					chr.quest.farm_water = "off";
					LAi_SetPlayerType(chr);

					LAi_QuestDelay("farm_running_water", 0.01);
				}
				else
				{
					if(CheckAttribute(chr,"quest.farmbooty_fillbottle") && chr.quest.farmbooty_fillbottle == "on")
					{
						return;
					}
					else
					{
						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladecauldron")
						{
							chr.quest.farmbooty_fillbottle = "on";
							LAi_SetStayType(chr);

							LAi_QuestDelay("farm_fill_cauldron_booty", 0.5);
						}
						else
						{
							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladebottle_CE0")
							{
								chr.quest.farmbooty_fillbottle = "on";
								PlaySound("INTERFACE\water_tap.wav");
								LAi_SetStayType(chr);

								LAi_QuestDelay("farm_fill_waterbottle", 0.5);
							}
						}
						else
						{
							PlaySound("INTERFACE\water_tap.wav");
							chr.quest.farm_water = "on";
							LAi_SetStayType(chr);

							LAi_QuestDelay("farm_running_water", 0.5);
						}
					}
				}

				return;
			break;

			case "box1":
				if(CheckAttribute(chr,"quest.distillery_items") && chr.quest.distillery_items == "open")
				{
					LaunchItemsBox(&ar);

					if(locations[FindLocation(chr.location)].box1.items.bladebottle_CP2 >=1)
					{
						LAi_QuestDelay("champagne_bottle_check", 0.1);
					}

					if(locations[FindLocation(chr.location)].box1.items.book51 ==1)
					{
						LAi_QuestDelay("book51_check", 0.1);
					}
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box2":
				if(CheckAttribute(chr,"quest.distillery_items") && chr.quest.distillery_items == "open")
				{
					LaunchItemsBox(&ar);

					if(locations[FindLocation(chr.location)].box2.items.pistolglass_tube >=1)
					{
						LAi_QuestDelay("glass_tube_check", 0.1);
						return;
					}
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box3":
				if(CheckAttribute(chr,"quest.distillery_items") && chr.quest.distillery_items == "open")
				{
					LaunchItemsBox(&ar);

					if(locations[FindLocation(chr.location)].box3.items.bladetop >=1)
					{
						LAi_QuestDelay("top_check", 0.1);
						return;
					}
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box4":
				if(CheckAttribute(chr,"quest.distillery_items") && chr.quest.distillery_items == "open")
				{
					LaunchItemsBox(&ar);

					if(locations[FindLocation(chr.location)].box4.items.pistolretort >=1)
					{
						LAi_QuestDelay("retort_check", 0.1);
						return;
					}
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box6":
				if(CheckAttribute(chr,"quest.distillery_items") && chr.quest.distillery_items == "open")
				{
					LaunchItemsBox(&ar);

					if(locations[FindLocation(chr.location)].box6.items.bladebottle_CE0 >=1)
					{
						LAi_QuestDelay("empty_bottle_check", 0.1);
						return;
					}
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box9":
				//looks like a locked wardrobe (before open fron alchemy)
				PlaySound("INTERFACE\locked_window.wav");
				return;
			break;

			LaunchItemsBox(&ar);
			return;
		}
		return;
	}

	if(Locations[locidx].id=="wr_secret")
	{
		if(CheckAttribute(chr,"quest.clear_study_boxes") && chr.quest.clear_study_boxes == "yes")
		{
			locations[FindLocation(chr.location)].box1.items.blade1 = 0;
			locations[FindLocation(chr.location)].box1.items.pistol20 = 0;
			locations[FindLocation(chr.location)].box1.items.ammobag1 = 0;
			locations[FindLocation(chr.location)].box1.items.ammobag2 = 0;

			locations[FindLocation(chr.location)].box1.items."bladeA5" = 0;
			locations[FindLocation(chr.location)].box1.items."spyglass3" = 0;
			locations[FindLocation(chr.location)].box1.items.temp_coins = 0;
			locations[FindLocation(chr.location)].box1.items.sewing_kit = 0;
			locations[FindLocation(chr.location)].box1.items.tobacco = 0;
			locations[FindLocation(chr.location)].box1.items.folding_knife = 0;
			locations[FindLocation(chr.location)].box1.items.compass1 = 0;
			locations[FindLocation(chr.location)].box1.items.pistoltinderbox = 0;
			locations[FindLocation(chr.location)].box1.items.key17 = 0;

			locations[FindLocation(chr.location)].box1.items.red_uniform = 0;
			locations[FindLocation(chr.location)].box1.items.sextant = 0;
			locations[FindLocation(chr.location)].box1.items.tin_jug = 0;
			locations[FindLocation(chr.location)].box1.items.tobacco = 0;
			locations[FindLocation(chr.location)].box1.items."pistol9+2" = 0;
			locations[FindLocation(chr.location)].box1.items.silver_bar = 0;
			locations[FindLocation(chr.location)].box1.items.clock1 = 0;
 			locations[FindLocation(chr.location)].box1.items.foreign_items = 0;
			locations[FindLocation(chr.location)].box1.items.drawing_kit = 0;
			locations[FindLocation(chr.location)].box1.items.strange_shells = 0;
			locations[FindLocation(chr.location)].box1.items.package = 0;
			locations[FindLocation(chr.location)].box1.items.temp_purse = 0;

			locations[FindLocation(chr.location)].box1.money = 0;
		}

		LaunchItemsBox(&ar);
		return;
	}

	if(Locations[locidx].id=="wr_corv_smallcabin_L")
	{
		switch(chr.boxname)
		{
			case "box2":
				PlaySound("PEOPLE\recoil.wav");
				ChangeCharacterAddressGroup(chr, "wr_corv_smallcabin_L", "goto", "goto8");
			break;

			case "box3":
				PlaySound("INTERFACE\wheel_take.wav");
				RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
				GiveItem2Character(chr,"pistolwheel");
				EquipCharacterByItem(chr, "pistolwheel");
				Locations[FindLocation("wr_corv_smallcabin_L")].models.always.l2 = "";		//wheel picked up

				Locations[FindLocation("wr_corv_smallcabin_L")].locators_radius.reload.reload7 = 0.5;
				Locations[FindLocation("wr_corv_smallcabin_L")].locators_radius.box.box2 = 0.0001;

				LAi_QuestDelay("pick_up_pistolwheel", 0.5);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_corv_smallcabin_R")
	{
		switch(chr.boxname)
		{
			case "box2":
				PlaySound("PEOPLE\recoil.wav");
				ChangeCharacterAddressGroup(chr, "wr_corv_smallcabin_R", "goto", "goto9");
			break;

			case "box4":
				LaunchItemsBox(&ar);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_gall_cap_inner")
	{
		switch(chr.boxname)
		{
			case "box1":
				Logit(TranslateString("","Water supply"));
				PlaySound("INTERFACE\rum_barrel_filled.wav");
			break;

			case "box2":
				if(CheckAttribute(chr,"quest.cap_inner_gp_box") && chr.quest.cap_inner_gp_box == "locked")
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
				else LaunchItemsBox(&ar);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_gall_deck2_prow")
	{
		switch(chr.boxname)
		{
			case "box2":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_prow_left", 2.0);
			break;

			case "box1":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_prow_right", 2.0);
			break;

			case "box3":
				PlaySound("INTERFACE\pinion_take.wav");
				RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
				GiveItem2Character(chr,"bladepinion_small");
				EquipCharacterByItem(chr, "bladepinion_small");
				Locations[FindLocation("wr_gall_deck2_prow")].models.always.l2 = "";//small pinion picked up
				Locations[FindLocation("wr_gall_deck2_prow")].locators_radius.box.box3 = 0.001;

				LAi_QuestDelay("pick_up_pinion_small", 0.5);
			break;

			case "box4":
				if(IsEquipCharacterByItem(chr, "bladeirontool"))
				{
					LAi_SetFightMode(chr, true);
					Locations[FindLocation("wr_gall_deck2_prow")].locators_radius.box.box4 = 0.0001;
					Locations[FindLocation("wr_gall_deck2_prow")].locators_radius.randitem.randitem5 = 1.5;		//plank

					LAi_QuestDelay("remove_plank_prow", 1.0);
				}
				else
				{
					Logit(TranslateString("","I can't remove that plank with my bare hands."));
					Logit(TranslateString("","But I guess it's the Galley."));
					PlaySound("VOICE\ENGLISH\blaze_sigh.wav");

					if(CheckAttribute(chr,"quest.qbook_crowbar") && chr.quest.qbook_crowbar == "done")
					{

					}
					else
					{
						chr.quest.qbook_crowbar = "done";
						AddQuestRecord("Open_the_galley", "2");
					}
				}
			break;

			case "box5":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_prow_galley", 2.0);
			break;

			case "box6":
				//anvil
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_SetSitType(chr);

				LAi_QuestDelay("anvil_too_heavy", 1.0);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_gall_deck2_stern")
	{
		switch(chr.boxname)
		{
			case "box1":
				if(CheckAttribute(chr,"quest.cannon_goodspile") && chr.quest.cannon_goodspile == "gone")
				{
					Logit(TranslateString("","Cannonball storage is empty!!"));
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");
				}
				else
				{
					Logit(TranslateString("","Cannonball storage"));
					PlaySound("PEOPLE\step_iron.wav");
					PlaySound("PEOPLE\step_iron.wav");
					PlaySound("PEOPLE\step_iron.wav");
				}
				return;
			break;

			case "box2":
				Logit(TranslateString("","Wad of rugs supply"));
				PlaySound("PEOPLE\clothes1.wav");
				return;
			break;

			case "box3":
				Logit(TranslateString("","Gunpowder storage"));
				PlaySound("PEOPLE\grass_noise.wav");
				return;
			break;

			case "box4":
				Logit(TranslateString("","Wad of rugs supply"));
				PlaySound("PEOPLE\clothes1.wav");
				return;
			break;

			case "box7":
				Logit(TranslateString("","Gunpowder storage"));
				PlaySound("PEOPLE\grass_noise.wav");
				return;
			break;

			case "box8":
				Logit(TranslateString("","Gunpowder storage"));
				PlaySound("PEOPLE\grass_noise.wav");
				return;
			break;

			case "box9":
				Logit(TranslateString("","Gunpowder storage"));
				PlaySound("PEOPLE\grass_noise.wav");
				return;
			break;

			case "box10":
				Logit(TranslateString("","Gunpowder storage"));
				PlaySound("PEOPLE\grass_noise.wav");
				return;
			break;

			case "box5":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_stern_left", 2.0);
			break;

			case "box6":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_stern_right", 2.0);
			break;

			case "box11":
				if(IsEquipCharacterByItem(chr, "bladebottle_CA2"))
				{
					LAi_SetPlayerType(chr);
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("acid_gold_door", 1.0);
				}
			break;

			case "box12":
				if(CheckCharacterItem(chr,"bladebottle_CA2"))
				{
					Locations[FindLocation("wr_gall_deck2_stern")].locators_radius.reload.reload5 = 0.001;
					Locations[FindLocation("wr_gall_deck2_stern")].locators_radius.box.box11 = 1.0;
					ChangeCharacterAddressGroup(chr, "wr_gall_deck2_stern", "goto", "goto3");
				}
				else
				{
					ChangeCharacterAddressGroup(chr, "wr_gall_deck2_stern", "reload", "reload5");
				}
				PlaySound("PEOPLE\creak2.wav");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_gall_hold_first")
	{
		switch(chr.boxname)
		{
			case "box1":
				//tie ropes to elevator
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_QuestDelay("ropes_to_elevator", 1.0);

				return;
			break;

			case "box2":
				//pick up bladeirontool
				chr.quest.bladeirontool = "picked_up";
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
				EquipCharacterByItem(chr, "bladeX4");
				LAi_SetFightMode(chr, true);
				Locations[FindLocation("wr_gall_hold_first")].models.always.l5 = "";//irontool picked up
				Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box2 = 0.001;
				Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box5 = 0.5;		//irontool

				LAi_QuestDelay("pick_up_bladeirontool", 1.0);

				return;
			break;

			case "box3":
				if(IsEquipCharacterByItem(chr, "bladebottle_CT2_nitr_w"))
				{
					ChangeCharacterAddressGroup(chr, "wr_gall_hold_first", "goto", "goto2");
					LAi_SetActorType(chr);
					LAi_ActorTurnToLocator(chr, "goto", "goto3");

					LAi_QuestDelay("acid_silver_door", 1.0);
				}
				else
				{
					PlaySound("INTERFACE\knock.wav");
					PlaySound("PEOPLE\crew_noise.wav");
					PlaySound("PEOPLE\crew_noise.wav");
					PlaySound("PEOPLE\crew_noise.wav");

					LAi_QuestDelay("Pchar_hah", 7.0);
				}
			break;

			case "box6":
				//short stair floor level
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "wr_gall_hold_first", "goto", "reload4");
			break;

			case "box4":
				//short stair medium level
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "wr_gall_hold_first", "goto", "reload5");
			break;

			case "box5":
				//short stair top level
				PlaySound("PEOPLE\jump.wav");
				ChangeCharacterAddressGroup(chr, "wr_gall_hold_first", "goto", "reload6");

				if(!CheckCharacterItem(chr,"bladeirontool")) LAi_QuestDelay("mast_so_what", 1.0);
			break;

			case "box7":
				//crew sound
				PlaySound("INTERFACE\knock.wav");
				PlaySound("PEOPLE\crew_noise.wav");
				PlaySound("PEOPLE\crew_noise.wav");
				PlaySound("PEOPLE\crew_noise.wav");

				LAi_QuestDelay("Pchar_hah", 7.0);
			break;

		}
		return;
	}

	if(Locations[locidx].id=="wr_gall_hold_second")
	{
		switch(chr.boxname)
		{
			case "box1":
				//half way up stair to cap_inner
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "wr_gall_hold_second", "goto", "goto1");
			break;

			case "box2":
				if(IsEquipCharacterByItem(chr, "bladeirontool"))
				{
					LAi_SetFightMode(chr, true);
					Locations[FindLocation("wr_gall_hold_second")].locators_radius.box.box2 = 0.0001;
					Locations[FindLocation("wr_gall_hold_second")].locators_radius.randitem.randitem11 = 2.0;//1.5 no good

					LAi_QuestDelay("remove_planks_hold", 1.0);
				}
				else
				{
					Logit(TranslateString("","I can't remove that plank with my bare hands."));
					PlaySound("VOICE\ENGLISH\blaze_sigh.wav");
				}
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_ships")
	{
		switch(chr.boxname)
		{
			case "box3":
				if(CheckAttribute(chr,"quest.corvette_status") && chr.quest.corvette_status == "schhh")
				{
					//using this above as a check for part 10 (broadside etc)
					Logit(TranslateString("","Hmm. That's not a good idea"));

					return;
				}

				if(CheckAttribute(chr, "quest.deck_bell") && chr.quest.deck_bell == "broken")
				{
					PlaySound("INTERFACE\bell_broken.wav");
				}
				else PlaySound("INTERFACE\bell2.wav");

				if(CheckAttribute(chr,"quest.guncrew") && chr.quest.guncrew == "locked_in")
				{
					PlaySound("PEOPLE\crew_noise.wav");

					LAi_QuestDelay("Pchar_whatwasthat", 7.0);
				}
				else
				{
					if(CheckAttribute(chr,"quest.guncrew") && chr.quest.guncrew == "dialog_in_hold")
					{
						return;
					}
				}
				else
				{
					if(CheckAttribute(chr,"quest.guncrew") && chr.quest.guncrew == "free_in_hold")
					{
						if(Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_W3" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_N3"
						|| Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_E3" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_S3")
						return;	//if cannon high crew doesn't return

						if(CheckAttribute(chr,"quest.ammodeck") && chr.quest.ammodeck == "open")
						{
							chr.quest.guncrew = "at_cannon_with_ammo";

							Locations[FindLocation("wr_gall_deck2_stern")].locators_radius.reload.reload3 = 1.0;
							Locations[FindLocation("wr_gall_deck2_stern")].locators_radius.reload.reload2 = 1.0;
							Locations[FindLocation("wr_gall_deck2_stern")].locators_radius.box.box5 = 0.0001;
							Locations[FindLocation("wr_gall_deck2_stern")].locators_radius.box.box6 = 0.0001;
							Locations[FindLocation("wr_ships")].reload.l8.disable = 0;
							Locations[FindLocation("wr_ships")].reload.l9.disable = 0;

							GiveItem2Character(CharacterFromID("guncrew_1"), "pistolbarrel4");
							EquipCharacterByItem(CharacterFromID("guncrew_1"), "pistolbarrel4");

							if(chr.quest.ammodeck_ball == "yes")
							{
								RemoveCharacterEquip(CharacterFromID("guncrew_2"), BLADE_ITEM_TYPE);
								GiveItem2Character(CharacterFromID("guncrew_2"), "bladecannon_ball");
								EquipCharacterByItem(CharacterFromID("guncrew_2"), "bladecannon_ball");
								chr.quest.ammodeck_ball = "no";	//happens only first time
							}
							EquipCharacterByItem(CharacterFromID("guncrew_2"), "pistolrammer");

							RemoveCharacterEquip(CharacterFromID("guncrew_3"), BLADE_ITEM_TYPE);
							GiveItem2Character(CharacterFromID("guncrew_3"), "bladewad");
							EquipCharacterByItem(CharacterFromID("guncrew_3"), "bladewad");
							EquipCharacterByItem(CharacterFromID("guncrew_3"), "pistolboom");

							RemoveCharacterEquip(CharacterFromID("guncrew_4"), BLADE_ITEM_TYPE);
							GiveItem2Character(CharacterFromID("guncrew_4"), "bladebucket");
							EquipCharacterByItem(CharacterFromID("guncrew_4"), "bladebucket");
							GiveItem2Character(CharacterFromID("guncrew_4"), "pistolsponge");
							EquipCharacterByItem(CharacterFromID("guncrew_4"), "pistolsponge");

							LAi_QuestDelay("guncrew_exit_R8_1", 1.0);
							LAi_QuestDelay("guncrew_exit_R8_2", 2.0);
							LAi_QuestDelay("guncrew_exit_R9_1", 0.5);
							LAi_QuestDelay("guncrew_exit_R9_2", 2.0);
						}
						else
						{
							chr.quest.guncrew = "at_cannon_without_ammo";

							Locations[FindLocation("wr_gall_deck2_prow")].locators_radius.reload.reload3 = 1.0;
							Locations[FindLocation("wr_gall_deck2_prow")].locators_radius.reload.reload2 = 1.0;
							Locations[FindLocation("wr_gall_deck2_prow")].locators_radius.box.box1 = 0.0001;
							Locations[FindLocation("wr_gall_deck2_prow")].locators_radius.box.box2 = 0.0001;
							Locations[FindLocation("wr_ships")].reload.l10.disable = 0;
							Locations[FindLocation("wr_ships")].reload.l11.disable = 0;

							LAi_QuestDelay("guncrew_exit_R11_1", 1.0);
							LAi_QuestDelay("guncrew_exit_R11_2", 2.0);
							LAi_QuestDelay("guncrew_exit_R10_1", 0.5);
							LAi_QuestDelay("guncrew_exit_R10_2", 2.0);
						}
					}
				}
				else
				{
					if(CheckAttribute(chr,"quest.guncrew"))
					{
						if(chr.quest.guncrew == "at_cannon_with_ammo" || chr.quest.guncrew == "at_cannon_without_ammo")
						{
							int gunnergreeting = rand(3);
							switch (gunnergreeting)
							{
								case 0: PlaySound("VOICE\ENGLISH\guncrew_1.wav"); break;

								case 1: PlaySound("VOICE\ENGLISH\guncrew_2.wav"); break;

								case 2: PlaySound("VOICE\ENGLISH\guncrew_3.wav"); break;

								case 3: PlaySound("VOICE\ENGLISH\guncrew_4.wav"); break;
							}
						}
					}
				}
				return;
			break;

			case "box4":
				//use as a checkpoint only
				return;
			break;

			case "box5":
				//cannon up
				if(CheckAttribute(chr,"quest.deck_cannon") && chr.quest.deck_cannon == "no_ropes")
				{
					PlaySound("OBJECTS\DUEL\man_attack1.wav");
					return;
				}

				if(CheckAttribute(chr,"quest.pistolwheel") && chr.quest.pistolwheel == "picked_up")
				{
					Locations[FindLocation("wr_ships")].locators_radius.box.box12 = 0.001;
				}
				else Locations[FindLocation("wr_ships")].locators_radius.box.box12 = 1.2;


				if(Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_W1" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_N1"
				|| Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_E1" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_S1"
				|| Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_S1X" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_W0"
				|| Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_N0" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_E0"
				|| Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_S0")
				{
					PlaySound("OBJECTS\DUEL\man_attack1.wav");

					LAi_QuestDelay("shipcannon_up_box5", 1.0);
					return;
				}
			break;

			case "box6":
				if(Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_W2" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_N2"
				|| Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_E2" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_S2")
				{
					//cannon down
					Locations[FindLocation("wr_ships")].locators_radius.box.box12 = 0.001;
					PlaySound("PEOPLE\clothes1.wav");

					LAi_QuestDelay("shipcannon_down", 0.5);
					return;
				}

				if(Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_W3" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_N3"
				|| Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_E3" || Locations[FindLocation("wr_ships")].models.always.l4 == "cannon_S3")
				{

					//cannon hard down
					Locations[FindLocation("wr_ships")].locators_radius.box.box12 = 0.001;
					PlaySound("PEOPLE\clothes1.wav");
					Locations[FindLocation("wr_ships")].models.always.l2 = "";	//was deck_box
					Locations[FindLocation("wr_ships")].locators_radius.reload.reload6 = 1.0;//visible to crew but blocked

					LAi_QuestDelay("shipcannon_hard_down", 0.5);
					return;
				}
			break;

			case "box7":
				//ropes on quarterdeck
				if(CheckAttribute(chr,"quest.deck_cannon") && chr.quest.deck_cannon == "no_ropes")
				{
					PlaySound("OBJECTS\DUEL\man_attack1.wav");
					return;
				}

				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				Locations[FindLocation("wr_ships")].locators_radius.box.box7 = 0.0001;

				LAi_QuestDelay("shipcannon_high_up_box7", 1.0);
				return;
			break;

			case "box8":
				//left position
				if(CheckAttribute(chr,"quest.anchor_mechanism") && chr.quest.anchor_mechanism == "complete")
				{
					//anchor down! - is up, invisible else
					PlaySound("INTERFACE\shelf_cogs.wav");
					LAi_SetSitType(chr);

					chr.quest.anchor = "down";
					Locations[FindLocation("wr_ships")].models.always.l5 = "anchor0";		//down
					Locations[FindLocation("wr_ships")].models.always.l6 = "elevator&ropes_C2";	//air
					Locations[FindLocation("wr_ships")].models.always.l14 = "";			//never ropes when anchor is down
					Locations[FindLocation("wr_ships")].locators_radius.reload.reload7 = 1.0;
					Locations[FindLocation("wr_corv_deck1")].reload.l5.disable = 0;
					Locations[FindLocation("wr_corv_deck1")].models.always.l2 = "elevator&ropes_G2";//air

					if(chr.quest.anchor_size == "small")
					{
						SetCurrentTime(23.00, 0);
						SetNextWeather("Clear");
						//Weathers["Moon Night"].Rain.NumDrops = 0;
						//Weathers["Moon Night"].Fog.Enable = false;
						locations[FindLocation("wr_ships")].type = "silent_seashore";
					}

					if(CheckAttribute(chr,"quest.elevatorG_status"))
					{
						if(chr.quest.elevatorG_status == "ropes_placed")
						{
							Locations[FindLocation("wr_ships")].models.always.l7 = "ropes2";
							Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "ropes2";
							Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box1 = 0.001;//place ropes function
						}

						if(chr.quest.elevatorG_status == "elevator_ready")
						{
							Locations[FindLocation("wr_ships")].models.always.l7 = "elevator&ropes_G2";			//air
							Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "elevator&ropes_G2";
							Locations[FindLocation("wr_gall_hold_first")].locators_radius.randitem.randitem10 = 1.5;   	//enable pick up planks in hold
							Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box2 = 0.001;         	//disable pick up irontool
							Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box5 = 0.5;			//irontool

							if(CheckAttribute(chr,"quest.bladeirontool") && chr.quest.bladeirontool == "picked_up")
							{
								Locations[FindLocation("wr_gall_hold_first")].models.always.l5 = "";			//no irontool
								Locations[FindLocation("wr_ships")].models.always.l8 = "";				//no irontool
							}
							else
							{
								Locations[FindLocation("wr_gall_hold_first")].models.always.l5 = "irontool2";
								Locations[FindLocation("wr_ships")].models.always.l8 = "irontool";
							}

							if(CheckAttribute(chr,"quest.plank_position") && chr.quest.plank_position == "deck")
							{
								if(CheckAttribute(chr,"quest.elevator_position") && chr.quest.elevator_position == "hold")
								{
									Locations[FindLocation("wr_ships")].models.always.l9 = "plank2";
									chr.quest.plank_position = "air";
									Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 1.0;	//enable fall
									Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 0.0001;    	//disable pick up planks from deck
									Locations[FindLocation("wr_gall_hold_first")].models.always.l2 = "plank2";	//planks in the air seen from hold
								}

								if(CheckAttribute(chr,"quest.elevator_position") && chr.quest.elevator_position == "deck")
								{
									Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 0.0001;	//disable fall
									Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 2.0; 		//enable pick up planks from deck
								}
							}
							else
							{
								Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 1.0;	//enable fall

								if(CheckAttribute(chr,"quest.plank_position") && chr.quest.plank_position == "picked_up")
								{
									Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 2.0; 		//enable place planks on deck
								}
								else Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 0.0001;    	//disable pick up planks from deck
							}
						}
					}

					Locations[FindLocation("wr_ships")].image = "";
					Locations[FindLocation("wr_ships")].locators_radius.box.box8 = 0.0001;
					Locations[FindLocation("wr_ships")].locators_radius.box.box9 = 0.5;

					LAi_QuestDelay("anchor_down_ships", 1.0);
				}
				else
				{
					if(CheckAttribute(chr,"quest.anchor_mechanism") && chr.quest.anchor_mechanism == "anchor_lost")
					{

						//"anchor" down! - is up
						PlaySound("INTERFACE\shelf_cogs.wav");
						LAi_SetSitType(chr);

						chr.quest.anchor_lost = "down";
						Locations[FindLocation("wr_ships")].models.always.l5 = "anchor0";		//down

						Locations[FindLocation("wr_ships")].image = "";
						Locations[FindLocation("wr_ships")].locators_radius.box.box8 = 0.0001;
						Locations[FindLocation("wr_ships")].locators_radius.box.box9 = 0.5;

						LAi_QuestDelay("anchor_down_ships", 1.0);
					}
				}
				else
				{
					if(CheckAttribute(chr,"quest.anchor") && chr.quest.anchor == "up")
					{

						//anchor down! - mechanism not ready (do this before fixing with pinions etc)
						PlaySound("INTERFACE\shelf_cogs.wav");
						LAi_SetSitType(chr);

						chr.quest.anchor = "down";
						Locations[FindLocation("wr_ships")].models.always.l5 = "anchor0";		//down
						Locations[FindLocation("wr_ships")].models.always.l6 = "elevator&ropes_C2";	//air
						Locations[FindLocation("wr_ships")].locators_radius.reload.reload7 = 1.0;
						Locations[FindLocation("wr_corv_deck1")].models.always.l2 = "elevator&ropes_G2";//air

						if(CheckAttribute(chr,"quest.elevatorG_status"))
						{
							if(chr.quest.elevatorG_status == "ropes_placed")
							{
								Locations[FindLocation("wr_ships")].models.always.l7 = "ropes2";
								Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "ropes2";
								Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box1 = 0.001;//place ropes function
							}
						}

						Locations[FindLocation("wr_ships")].image = "";

						LAi_QuestDelay("anchor_down_ships", 1.0);
					}
					else
					{
						//pinions etc in here

						if(LAi_IsFightMode(chr))
						{
							//this is your 2:nd 'open box', used for placing/taking pinions. (fire gun = wheel)

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladepinion_small")
							{
								if(CheckAttribute(chr,"quest.wheel_pos_left") && chr.quest.wheel_pos_left == "wheel")
								{
									PlaySound("INTERFACE\damper_change.wav");
									LAi_QuestDelay("wheel_on_hub_already", 1.0);

									return;
								}
								else
								{
									if(CheckAttribute(chr,"quest.wheel_pos_right") && chr.quest.wheel_pos_right == "wheel")
									{
										//wheel on the other hub but blocking

										PlaySound("INTERFACE\damper_change.wav");
										LAi_QuestDelay("wheel_blocking", 1.0);

										return;
									}
								}
								else
								{
									if(CheckAttribute(chr,"quest.pinion_pos_left") && chr.quest.pinion_pos_left == "free")
									{
										//place small pinion!
										PlaySound("INTERFACE\pinion_place.wav");
										RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
										TakeItemFromCharacter(chr, "bladepinion_small");
										EquipCharacterByItem(chr, "bladeX4");

										Locations[FindLocation("wr_ships")].models.always.l10 = "pinion_small_L";
										chr.quest.pinion_pos_left = "small";

										LAi_QuestDelay("at_mechanism_L", 0.5);
										return;
									}

									if(CheckAttribute(chr,"quest.pinion_pos_left") && chr.quest.pinion_pos_left == "large")
									{
										//place small pinion & pick up large one!
										PlaySound("INTERFACE\pinion_place.wav");
										PlaySound("INTERFACE\pinion_take.wav");
										RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
										TakeItemFromCharacter(chr, "bladepinion_small");
										GiveItem2Character(chr,"bladepinion_large");
										EquipCharacterByItem(chr, "bladepinion_large");

										Locations[FindLocation("wr_ships")].models.always.l10 = "pinion_small_L";
										chr.quest.pinion_pos_left = "small";

										LAi_QuestDelay("at_mechanism_L", 0.5);
										return;
									}
								}
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladepinion_large")
							{
								if(CheckAttribute(chr,"quest.wheel_pos_left") && chr.quest.wheel_pos_left == "wheel")
								{
									PlaySound("INTERFACE\damper_change.wav");
									LAi_QuestDelay("wheel_on_hub_already", 1.0);

									return;
								}
								else
								{
									if(CheckAttribute(chr,"quest.wheel_pos_right") && chr.quest.wheel_pos_right == "wheel")
									{
										//wheel on the other hub but blocking

										PlaySound("INTERFACE\damper_change.wav");
										LAi_QuestDelay("wheel_blocking", 1.0);

										return;
									}
								}
								else
								{
									if(CheckAttribute(chr,"quest.pinion_pos_left") && chr.quest.pinion_pos_left == "free")
									{
										//place large pinion!
										PlaySound("INTERFACE\pinion_place.wav");
										RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
										TakeItemFromCharacter(chr, "bladepinion_large");
										EquipCharacterByItem(chr, "bladeX4");

										Locations[FindLocation("wr_ships")].models.always.l10 = "pinion_large_L";
										chr.quest.pinion_pos_left = "large";

										LAi_QuestDelay("at_mechanism_L", 0.5);
										return;
									}

									if(CheckAttribute(chr,"quest.pinion_pos_left") && chr.quest.pinion_pos_left == "small")
									{
										//place large pinion & pick up small one!
										PlaySound("INTERFACE\pinion_place.wav");
										PlaySound("INTERFACE\pinion_take.wav");
										RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
										TakeItemFromCharacter(chr, "bladepinion_large");
										GiveItem2Character(chr,"bladepinion_small");
										EquipCharacterByItem(chr, "bladepinion_small");

										Locations[FindLocation("wr_ships")].models.always.l10 = "pinion_large_L";
										chr.quest.pinion_pos_left = "large";

										LAi_QuestDelay("at_mechanism_L", 0.5);
										return;
									}
								}
							}

							if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladeX4")
							{
								if(CheckAttribute(chr,"quest.wheel_pos_left") && chr.quest.wheel_pos_left == "wheel")
								{
									PlaySound("INTERFACE\damper_change.wav");
									LAi_QuestDelay("wheel_on_hub_already", 1.0);

									return;
								}
								else
								{
									if(CheckAttribute(chr,"quest.wheel_pos_right") && chr.quest.wheel_pos_right == "wheel")
									{
										//wheel on the other hub but blocking

										PlaySound("INTERFACE\damper_change.wav");
										LAi_QuestDelay("wheel_blocking", 1.0);

										return;
									}
								}
								else
								{
									if(CheckAttribute(chr,"quest.pinion_pos_left") && chr.quest.pinion_pos_left == "small")
									{
										//pick up small one!
										PlaySound("INTERFACE\pinion_take.wav");
										RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
										GiveItem2Character(chr,"bladepinion_small");
										EquipCharacterByItem(chr, "bladepinion_small");

										Locations[FindLocation("wr_ships")].models.always.l10 = "";
										chr.quest.pinion_pos_left = "free";

										LAi_QuestDelay("at_mechanism_L", 0.5);
										return;
									}

									if(CheckAttribute(chr,"quest.pinion_pos_left") && chr.quest.pinion_pos_left == "large")
									{
										//pick up large one!
										PlaySound("INTERFACE\pinion_take.wav");
										RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
										GiveItem2Character(chr,"bladepinion_large");
										EquipCharacterByItem(chr, "bladepinion_large");

										Locations[FindLocation("wr_ships")].models.always.l10 = "";
										chr.quest.pinion_pos_left = "free";

										LAi_QuestDelay("at_mechanism_L", 0.5);
										return;
									}
								}
							}
						}
						else
						{
							if(CheckAttribute(chr,"quest.wheel_pos_left") && chr.quest.wheel_pos_left == "wheel")
							{
								RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
								if(!CheckCharacterItem(chr,"pistolhand")) GiveItem2Character(chr,"pistolhand");
								EquipCharacterByItem(chr, "pistolhand");//able to pick up wheel
							}

							chr.quest.deck_position = "mechanism_L";
							ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "stuck8");
							LAi_LocationFightDisable(&Locations[FindLocation("wr_ships")], false);
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("stay_at_stuck8", 1.0);
						}
					}
				}

				return;
			break;

			case "box9":
				//right position
				if(CheckAttribute(chr,"quest.broadside") && chr.quest.broadside == "started")
				{
					Logit(TranslateString("","Hmm. That's not a good idea"));
					return;
				}

				if(CheckAttribute(chr,"quest.anchor_mechanism") && chr.quest.anchor_mechanism == "complete")
				{
					//anchor up! - is down, invisible else
					PlaySound("PEOPLE\drill_water.wav");
					LAi_SetSitType(chr);

					LAi_QuestDelay("anchor_up_animation", 0.25);

					chr.quest.anchor = "up";
					Locations[FindLocation("wr_ships")].models.always.l6 = "elevator&ropes_C1";	//deck
					Locations[FindLocation("wr_corv_deck1")].models.always.l2 = "elevator&ropes_G1";//deck

					if(CheckAttribute(chr,"quest.anchor_size"))
					{
						if(chr.quest.anchor_size == "large")
						Locations[FindLocation("wr_ships")].models.always.l5 = "anchor1";

						if(chr.quest.anchor_size == "small")
						Locations[FindLocation("wr_ships")].models.always.l5 = "anchor_small1";
					}

					if(CheckAttribute(chr,"quest.elevator_ropes") && chr.quest.elevator_ropes == "picked_up")
					{
						Locations[FindLocation("wr_ships")].locators_radius.randitem.randitem2 = 0.0001;
					}
					else
					{
						Locations[FindLocation("wr_ships")].models.always.l14 = "ropesA";		//ropes on anchor
						Locations[FindLocation("wr_ships")].locators_radius.randitem.randitem2 = 1.5;	//with p.u. elevator_ropes
					}

					Locations[FindLocation("wr_ships")].locators_radius.reload.reload7 = 0.0001;
					Locations[FindLocation("wr_corv_deck1")].reload.l5.disable = 1;

					if(CheckAttribute(chr,"quest.elevatorG_status"))
					{
						if(chr.quest.elevatorG_status == "ropes_placed")
						{
							Locations[FindLocation("wr_ships")].models.always.l7 = "ropes0";
							Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "ropes0";
							Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box1 = 1.5;//place ropes function
						}

						if(chr.quest.elevatorG_status == "elevator_ready")
						{
							if(CheckAttribute(chr,"quest.plank_position") && chr.quest.plank_position == "deck")
							{
								Locations[FindLocation("wr_ships")].models.always.l7 = "elevator&ropes_G1";	//deck
								Locations[FindLocation("wr_ships")].models.always.l8 = "";			//invisible irontool on deck!
								Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "elevator&ropes_G1";

								Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 0.0001;//disable fall
								Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 0.0001;      //disable pick up planks from deck
								chr.quest.elevator_position = "deck";

								if(CheckAttribute(chr,"quest.bladeirontool") && chr.quest.bladeirontool == "picked_up")
								{
									Locations[FindLocation("wr_gall_hold_first")].models.always.l5 = "";			//no irontool
								}
								else
								{
									Locations[FindLocation("wr_gall_hold_first")].models.always.l5 = "irontool1";
									Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box2 = 0.5;          //enable pick up irontool
									Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box5 = 0.0001;       //irontool
								}
							}
							else
							{
								if(CheckAttribute(chr,"quest.plank_position") && chr.quest.plank_position == "air")
								{
									Locations[FindLocation("wr_ships")].models.always.l7 = "elevator&ropes_G0";	//hold
									Locations[FindLocation("wr_ships")].models.always.l8 = "";		//invisible irontool
									Locations[FindLocation("wr_gall_hold_first")].models.always.l2 = "plank1";
									Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "elevator&ropes_G0";
									Locations[FindLocation("wr_gall_hold_first")].models.always.l5 = "";	//invisible irontool
									Locations[FindLocation("wr_ships")].models.always.l9 = "plank1";	//on deck
									Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 0.0001;//disable fall
									Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 2.0;    //enable pick up planks from deck
									chr.quest.plank_position = "deck";
									chr.quest.elevator_position = "hold";
								}
							}
							else
							{
								Locations[FindLocation("wr_ships")].models.always.l7 = "elevator&ropes_G0";	//hold
								Locations[FindLocation("wr_ships")].models.always.l8 = "";		   	//invisible irontool
								Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "elevator&ropes_G0";
								Locations[FindLocation("wr_gall_hold_first")].models.always.l5 = "";	     	//invisible irontool
								Locations[FindLocation("wr_gall_hold_first")].locators_radius.randitem.randitem10 = 0.0001;   //disable pick up planks in hold
								Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 1.0;   	//enable fall
								chr.quest.elevator_position = "hold";

								if(CheckAttribute(chr,"quest.plank_position") && chr.quest.plank_position == "picked_up")
								{
									Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 2.0;      	//enable place planks on deck
								}
								else Locations[FindLocation("wr_ships")].locators_radius.box.box11 = 0.0001;      	//disable pick up planks from deck
							}
						}
					}

					Locations[FindLocation("wr_ships")].image = "";

					Locations[FindLocation("wr_ships")].locators_radius.box.box8 = 0.5;
					Locations[FindLocation("wr_ships")].locators_radius.box.box9 = 0.0001;

					LAi_QuestDelay("anchor_up_ships", 1.0);
				}
				else
				{
					if(CheckAttribute(chr,"quest.anchor_mechanism") && chr.quest.anchor_mechanism == "anchor_lost")
					{
						//anchor_lost up! - is down
						PlaySound("PEOPLE\drill_water.wav");
						LAi_SetSitType(chr);

						LAi_QuestDelay("anchor_up_animation", 0.25);

						chr.quest.anchor_lost = "up";
						Locations[FindLocation("wr_ships")].models.always.l5 = "anchor_lost";

						Locations[FindLocation("wr_ships")].image = "";

						Locations[FindLocation("wr_ships")].locators_radius.box.box8 = 0.5;
						Locations[FindLocation("wr_ships")].locators_radius.box.box9 = 0.0001;

						LAi_QuestDelay("anchor_up_ships", 1.0);
					}
				}
				else
				{
					//pinions etc in here - you can't lift the anchor

					if(LAi_IsFightMode(chr))
					{
						//this is your 2:nd 'open box', used for placing/taking pinions. (fire gun = wheel)

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladepinion_small")
						{
							if(CheckAttribute(chr,"quest.wheel_pos_right") && chr.quest.wheel_pos_right == "wheel")
							{
								PlaySound("INTERFACE\damper_change.wav");
								LAi_QuestDelay("wheel_on_hub_already", 1.0);

								return;
							}
							else
							{
								if(CheckAttribute(chr,"quest.wheel_pos_left") && chr.quest.wheel_pos_left == "wheel")
								{
									//wheel on the other hub but blocking

									PlaySound("INTERFACE\damper_change.wav");
									LAi_QuestDelay("wheel_blocking", 1.0);

									return;
								}
							}
							else
							{
								if(CheckAttribute(chr,"quest.pinion_pos_right") && chr.quest.pinion_pos_right == "free")
								{
									//place small pinion!
									PlaySound("INTERFACE\pinion_place.wav");
									RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
									TakeItemFromCharacter(chr, "bladepinion_small");
									EquipCharacterByItem(chr, "bladeX4");

									Locations[FindLocation("wr_ships")].models.always.l11 = "pinion_small_R";
									chr.quest.pinion_pos_right = "small";

									LAi_QuestDelay("at_mechanism_R", 0.5);
									return;
								}

								if(CheckAttribute(chr,"quest.pinion_pos_right") && chr.quest.pinion_pos_right == "large")
								{
									//place small pinion & pick up large one!
									PlaySound("INTERFACE\pinion_place.wav");
									PlaySound("INTERFACE\pinion_take.wav");
									RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
									TakeItemFromCharacter(chr, "bladepinion_small");
									GiveItem2Character(chr,"bladepinion_large");
									EquipCharacterByItem(chr, "bladepinion_large");

									Locations[FindLocation("wr_ships")].models.always.l11 = "pinion_small_R";
									chr.quest.pinion_pos_right = "small";

									LAi_QuestDelay("at_mechanism_R", 0.5);
									return;
								}
							}
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladepinion_large")
						{
							if(CheckAttribute(chr,"quest.wheel_pos_right") && chr.quest.wheel_pos_right == "wheel")
							{
								PlaySound("INTERFACE\damper_change.wav");
								LAi_QuestDelay("wheel_on_hub_already", 1.0);

								return;
							}
							else
							{
								if(CheckAttribute(chr,"quest.wheel_pos_left") && chr.quest.wheel_pos_left == "wheel")
								{
									//wheel on the other hub but blocking

									PlaySound("INTERFACE\damper_change.wav");
									LAi_QuestDelay("wheel_blocking", 1.0);

									return;
								}
							}
							else
							{
								if(CheckAttribute(chr,"quest.pinion_pos_right") && chr.quest.pinion_pos_right == "free")
								{
									//place large pinion!
									PlaySound("INTERFACE\pinion_place.wav");
									RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
									TakeItemFromCharacter(chr, "bladepinion_large");
									EquipCharacterByItem(chr, "bladeX4");

									Locations[FindLocation("wr_ships")].models.always.l11 = "pinion_large_R";
									chr.quest.pinion_pos_right = "large";

									LAi_QuestDelay("at_mechanism_R", 0.5);
									return;
								}

								if(CheckAttribute(chr,"quest.pinion_pos_right") && chr.quest.pinion_pos_right == "small")
								{
									//place large pinion & pick up small one!
									PlaySound("INTERFACE\pinion_place.wav");
									PlaySound("INTERFACE\pinion_take.wav");
									RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
									TakeItemFromCharacter(chr, "bladepinion_large");
									GiveItem2Character(chr,"bladepinion_small");
									EquipCharacterByItem(chr, "bladepinion_small");

									Locations[FindLocation("wr_ships")].models.always.l11 = "pinion_large_R";
									chr.quest.pinion_pos_right = "large";

									LAi_QuestDelay("at_mechanism_R", 0.5);
									return;
								}
							}
						}

						if(CheckAttribute(chr, "equip.blade") && chr.equip.blade == "bladeX4")
						{
							if(CheckAttribute(chr,"quest.wheel_pos_right") && chr.quest.wheel_pos_right == "wheel")
							{
								PlaySound("INTERFACE\damper_change.wav");
								LAi_QuestDelay("wheel_on_hub_already", 1.0);

								return;
							}
							else
							{
								if(CheckAttribute(chr,"quest.wheel_pos_left") && chr.quest.wheel_pos_left == "wheel")
								{
									//wheel on the other hub but blocking

									PlaySound("INTERFACE\damper_change.wav");
									LAi_QuestDelay("wheel_blocking", 1.0);

									return;
								}
							}
							else
							{
								if(CheckAttribute(chr,"quest.pinion_pos_right") && chr.quest.pinion_pos_right == "small")
								{
									//pick up small one!
									PlaySound("INTERFACE\pinion_take.wav");
									RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
									GiveItem2Character(chr,"bladepinion_small");
									EquipCharacterByItem(chr, "bladepinion_small");

									Locations[FindLocation("wr_ships")].models.always.l11 = "";
									chr.quest.pinion_pos_right = "free";

									LAi_QuestDelay("at_mechanism_R", 0.5);
									return;
								}

								if(CheckAttribute(chr,"quest.pinion_pos_right") && chr.quest.pinion_pos_right == "large")
								{
									//pick up large one!
									PlaySound("INTERFACE\pinion_take.wav");
									RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
									GiveItem2Character(chr,"bladepinion_large");
									EquipCharacterByItem(chr, "bladepinion_large");

									Locations[FindLocation("wr_ships")].models.always.l11 = "";
									chr.quest.pinion_pos_right = "free";

									LAi_QuestDelay("at_mechanism_R", 0.5);
									return;
								}
							}
						}
					}
					else
					{
						if(CheckAttribute(chr,"quest.wheel_pos_right") && chr.quest.wheel_pos_right == "wheel")
						{
							RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
							if(!CheckCharacterItem(chr,"pistolhand")) GiveItem2Character(chr,"pistolhand");
							EquipCharacterByItem(chr, "pistolhand");//able to pick up wheel
						}

						chr.quest.deck_position = "mechanism_R";
						ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "stuck9");
						LAi_LocationFightDisable(&Locations[FindLocation("wr_ships")], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("stay_at_stuck9", 1.0);
					}
				}

				return;
			break;

			case "box10":
				if(LAi_IsFightMode(chr))
				{
					//second 'open box'
					SetModel(chr, "Pira4M_HTUS", chr.model.animation, chr.sex, stf(chr.model.height), true);
					chr.quest.elevatorG_status = "ropes_placed";
					PlaySound("PEOPLE\clothes1.wav");
					TakeItemFromCharacter(chr, "elevator_ropes");

					if(CheckAttribute(chr,"quest.anchor"))
					{
						if(chr.quest.anchor == "up")
						{
							Locations[FindLocation("wr_ships")].models.always.l7 = "ropes0";
							Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "ropes0";
							Locations[FindLocation("wr_gall_hold_first")].locators_radius.box.box1 = 1.5;//place ropes function
						}

						if(chr.quest.anchor == "down")
						{
							Locations[FindLocation("wr_ships")].models.always.l7 = "ropes2";
							Locations[FindLocation("wr_gall_hold_first")].models.always.l3 = "ropes2";
						}
					}

					LAi_QuestDelay("place_elevator_ropes", 1.0);
				}
				else
				{
					//first 'open box'
					RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
					EquipCharacterByItem(chr, "bladeX4");
					LAi_LocationFightDisable(&Locations[FindLocation("wr_ships")], false);
					LAi_SetFightMode(chr, true);
				}

				return;
			break;

			case "box11":
				if(IsEquipCharacterByItem(chr, "bladeplank2") && IsEquipCharacterByItem(chr, "pistolplank2"))
				{
					PlaySound("PEOPLE\place_planks.wav");
					RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
					RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
					TakeItemFromCharacter(chr, "pistolplank2");
					TakeItemFromCharacter(chr, "bladeplank2");

					chr.quest.plank_position = "deck";
					Locations[FindLocation("wr_ships")].models.always.l9 = "plank1";
					Locations[FindLocation("wr_gall_hold_first")].models.always.l2 = "plank1";
					Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 0.0001;//disable fall

					LAi_QuestDelay("place_planks_on_deck", 1.0);
				}
				else
				{
					if(CheckAttribute(chr,"quest.plank_position") && chr.quest.plank_position == "deck")
					{
						if(CheckAttribute(chr,"quest.deck_position") && chr.quest.deck_position == "fight_enabled")
						{
							PlaySound("OBJECTS\DUEL\man_attack1.wav");
							Logit(TranslateString("","No, they have nailed down the planks!"));
						}
						else
						{
							RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							GiveItem2Character(chr, "bladeplank2");
							GiveItem2Character(chr, "pistolplank2");
							EquipCharacterbyItem(chr, "bladeplank2");
							EquipCharacterbyItem(chr, "pistolplank2");

							chr.quest.plank_position = "picked_up";
							Locations[FindLocation("wr_ships")].models.always.l9 = "";
							Locations[FindLocation("wr_gall_hold_first")].models.always.l2 = "";
							Locations[FindLocation("wr_ships")].locators_radius.reload.reload12 = 1.0;//enable fall

							LAi_QuestDelay("place_planks_on_deck", 1.0);//yes the same 
						}
					}
				}

				return;
			break;

			case "box12":
				PlaySound("INTERFACE\pinion_take.wav");
				RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
				GiveItem2Character(chr,"bladepinion_large");
				EquipCharacterByItem(chr, "bladepinion_large");
				Locations[FindLocation("wr_ships")].models.always.l15 = "";//large pinion picked up
				chr.quest.pistolwheel = "picked_up";
				Locations[FindLocation("wr_ships")].locators_radius.box.box12 = 0.001;

				LAi_QuestDelay("pick_up_pinion_large", 0.5);

				return;
			break;

			case "box13":
				if(CheckAttribute(chr,"quest.captains_door") && chr.quest.captains_door == "closed")
				{
					PlaySound("PEOPLE\wheel_open.wav");

					LAi_QuestDelay("open_captains_door", 4.0);
				}

				if(CheckAttribute(chr,"quest.captains_door") && chr.quest.captains_door == "open")
				{
					PlaySound("PEOPLE\wheel_close.wav");

					LAi_QuestDelay("close_captains_door", 3.5);
				}

				return;
			break;

			case "box14":
				//place anchor in prow

				if(CheckAttribute(chr,"quest.anchor_lost") && chr.quest.anchor_lost == "down")
				{
					PlaySound("PEOPLE\step_wood.wav");
					PlaySound("PEOPLE\step_wood.wav");
					LAi_SetSitType(chr);
					ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "pickup_ropes");

					LAi_QuestDelay("jump_corvette", 0.5);
				}

				if(CheckAttribute(chr,"quest.anchor_lost") && chr.quest.anchor_lost == "up")
				{
					if(LAi_IsFightMode(chr))
					{
						//second 'open box'
						PlaySound("INTERFACE\button3.wav");
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						TakeItemFromCharacter(chr, "bladeanchor");
						GiveItem2Character(chr, "bladeX4");
						EquipCharacterByItem(chr, "bladeX4");

						chr.quest.anchor_mechanism = "complete";
						chr.quest.anchor_size = "small";
						Locations[FindLocation("wr_ships")].models.always.l5 = "anchor_small1";
						chr.quest.anchor = "up";
						Locations[FindLocation("wr_ships")].locators_radius.box.box15 = 0.0001;

						LAi_QuestDelay("anchor_placed_at_corvette", 0.5);
					}
					else
					{
						//first 'open box'
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						EquipCharacterByItem(chr, "bladeanchor");
						LAi_LocationFightDisable(&Locations[FindLocation("wr_ships")], false);
						LAi_SetFightMode(chr, true);
					}
				}

				return;
			break;

			case "box15":
				//climb up to place anchor at prow
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				PlaySound("PEOPLE\step_wood.wav");
				LAi_SetSitType(chr);
				ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "prow");

				LAi_QuestDelay("jump_corvette", 0.5);

				return;
			break;

			case "box16":
				//climb up for a jump down to corvette
				PlaySound("PEOPLE\step_wood.wav");
				LAi_SetSitType(chr);
				ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "jump2");

				LAi_QuestDelay("abandon_galleon", 0.2);

				return;
			break;

			case "box17":
				//jump down to corvette
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				LAi_SetSitType(chr);
				ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "jump3");

				LAi_QuestDelay("abandon_galleon1", 1.0);

				return;
			break;

			case "box18":
				//move to steering wheel
				PlaySound("PEOPLE\run_wood.wav");
				ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "steering");

				return;
			break;

			case "box19":
				//enter ships
				PlaySound("PEOPLE\recoil.wav");
				ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "reload2");
			break;

			case "box20":
				//leave ships
				PlaySound("PEOPLE\recoil.wav");
				ChangeCharacterAddressGroup(chr, "wr_ships", "reload", "reload3");
			break;

			case "box21":
				//climb up mast
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "reload16");

				if(CheckAttribute(chr,"quest.elevatorG_status") || CheckCharacterItem(chr,"elevator_ropes"))
				{
				}
				else LAi_QuestDelay("mast_so_what", 1.0);
			break;

			case "box22":
				//climb down mast
				PlaySound("PEOPLE\Jump.wav");
				ChangeCharacterAddressGroup(chr, "wr_ships", "goto", "reload15");
			break;

			case "box23":
				//start replacement for box 8 (anchor down)

				if(CheckAttribute(chr,"quest.anchor") && chr.quest.anchor == "up")
				{

					//anchor down! - mechanism not ready (do this before fixing with pinions etc)
					PlaySound("INTERFACE\shelf_cogs.wav");
					LAi_SetSitType(chr);

					chr.quest.anchor = "down";
					Locations[FindLocation("wr_ships")].models.always.l5 = "anchor0";		//down
					Locations[FindLocation("wr_ships")].models.always.l6 = "elevator&ropes_C2";	//air
					Locations[FindLocation("wr_ships")].locators_radius.reload.reload7 = 1.0;
					Locations[FindLocation("wr_corv_deck1")].models.always.l2 = "elevator&ropes_G2";//air

					Locations[FindLocation("wr_ships")].image = "";

					LAi_QuestDelay("anchor_down_ships", 1.0);
				}
				else
				{
					Logit(TranslateString("","Not much of a mechanism left here. The Pinions and the Wheel are all missing."));
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");

					if(CheckAttribute(chr,"quest.qbook_pinions") && chr.quest.qbook_pinions == "done")
					{

					}
					else
					{
						chr.quest.qbook_pinions = "done";
						AddQuestRecord("Repair_the_anchor", "2");
					}
				}
			break;

			case "box24":
				//start replacement for box 9 (anchor up)

				Logit(TranslateString("","Not much of a mechanism left here. The Pinions and the Wheel are all missing."));
				PlaySound("VOICE\ENGLISH\blaze_hah.wav");

				if(CheckAttribute(chr,"quest.qbook_pinions") && chr.quest.qbook_pinions == "done")
				{

				}
				else
				{
					chr.quest.qbook_pinions = "done";
					AddQuestRecord("Repair_the_anchor", "2");
				}
			break;

		}
		return;
	}

	if(Locations[locidx].id=="wr_corvette")
	{
		switch(chr.boxname)
		{
			case "box3":
				PlaySound("INTERFACE\bell_broken.wav");

				return;
			break;

			case "box5":
				//cannon up
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				return;
			break;

			case "box7":
				//ropes on quarterdeck
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				return;
			break;

			case "box8":
				//left position

				//anchor down! - is up, invisible else
				PlaySound("INTERFACE\shelf_cogs.wav");
				chr.quest.anchor = "down";
				Locations[FindLocation("wr_corvette")].models.always.l5 = "anchor0";		//down
				Locations[FindLocation("wr_corvette")].models.always.l6 = "elevator&ropes_C2";	//air
				Locations[FindLocation("wr_corvette")].locators_radius.reload.reload7 = 1.0;

				Locations[FindLocation("wr_corv_deck1")].reload.l5.disable = 0;
				Locations[FindLocation("wr_corv_deck1")].models.always.l2 = "elevator&ropes_G2";//air

				Locations[FindLocation("wr_corvette")].image = "";
				Locations[FindLocation("wr_corvette")].locators_radius.box.box8 = 0.0001;
				Locations[FindLocation("wr_corvette")].locators_radius.box.box9 = 0.5;

				LAi_QuestDelay("anchor_down_corvette", 1.0);

				return;
			break;

			case "box9":
				//right position

				//anchor up! - is down, invisible else
				PlaySound("PEOPLE\drill_water.wav");
				chr.quest.anchor = "up";
				Locations[FindLocation("wr_corvette")].models.always.l5 = "anchor_small1";
				Locations[FindLocation("wr_corvette")].models.always.l6 = "elevator&ropes_C1";	//deck
				Locations[FindLocation("wr_corvette")].locators_radius.reload.reload7 = 0.0001;

				Locations[FindLocation("wr_corv_deck1")].reload.l5.disable = 1;
				Locations[FindLocation("wr_corv_deck1")].models.always.l2 = "elevator&ropes_G1";//deck

				Locations[FindLocation("wr_corvette")].image = "";
				Locations[FindLocation("wr_corvette")].locators_radius.box.box8 = 0.5;
				Locations[FindLocation("wr_corvette")].locators_radius.box.box9 = 0.0001;

				LAi_QuestDelay("anchor_up_corvette", 1.0);

				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_cavern")
	{
		switch(chr.boxname)
		{
			case "box1":
				//locked chest hanging - door is open (start)
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				Locations[FindLocation("wr_cavern")].models.always.locators = "cavern_l_JRH_ground_open";

				LAi_QuestDelay("cavern_church_lock", 0.5);
				return;
			break;

			case "box2":
				//locked chest on ground - door is locked
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				Locations[FindLocation("wr_cavern")].models.always.locators = "cavern_l_JRH_air_closed";

				LAi_QuestDelay("cavern_church_unlock", 0.5);
				return;
			break;

			case "box3":
				//open chest on ground - door is locked
				if(CheckAttribute(chr,"quest.cavern_chestkey") && chr.quest.cavern_chestkey == "yes")
				{
					PlaySound("INTERFACE\key_lock.wav");

					Locations[FindLocation("wr_cavern")].models.always.locators = "cavern_l_JRH_ground_closed";

					LAi_QuestDelay("cavern_chest_lock", 0.5);
				}
				else
				{
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");
					Logit(TranslateString("","I can't lock the chest. The key and the entire lock are missing!"));

					LAi_QuestDelay("cavern_key_gone", 1.0);
				}

				return;
			break;

			case "box4":
				//ready to place the chest on ground
				if(CheckCharacterItem(chr,"bladechest_red"))
				{
					if(!IsEquipCharacterByItem(chr, "bladechest_red"))
					{
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						EquipCharacterbyItem(chr, "bladechest_red");
					}

					LAi_SetFightMode(chr, true);
					PlaySound("OBJECTS\DUEL\man_attack1.wav");
					Locations[FindLocation("wr_cavern")].models.always.locators = "cavern_l_JRH_ground_open";

					LAi_QuestDelay("cavern_place_chest", 1.0);
				}
				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_cannon_tower")
	{
		switch(chr.boxname)
		{
			case "box1":
				//gunpowder barrel
				PlaySound("AMBIENT\JAIL\jail_door2.wav");

				if(CheckAttribute(chr, "quest.wet_gp") && chr.quest.wet_gp == "yes")
				{
					TakeNItems(chr, "gunpowder", -100);

					LAi_QuestDelay("cannon_tower_dry_gp", 0.1);
				}

		 		LaunchItemsBox(&ar);
				return;
			break;

			case "box2":
				//R1: musket is up - door is locked (start)
				PlaySound("INTERFACE\lever_down.wav");
				Locations[FindLocation(chr.location)].models.always.locators = "Imayak_l_JRH1";
				LAi_QuestDelay("blue_cavern_unlock", 0.5);
				return;
			break;

			case "box3":
				//R1: musket is down - door is open
				PlaySound("INTERFACE\lever_up.wav");
				Locations[FindLocation(chr.location)].models.always.locators = "Imayak_l_JRH";
				LAi_QuestDelay("blue_cavern_lock", 0.5);
				return;
			break;

			case "box4":
				//not used
			break;

			case "box5":
				//missing musket lever
				if(IsEquipCharacterByItem(chr, "pistolmket"))
				{
					PlaySound("OBJECTS\DUEL\reload1.wav");
					RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
					if(!CheckCharacterItem(chr,"bladeX4")) GiveItem2Character(chr, "bladeX4");
					EquipCharacterByItem(chr, "bladeX4");
					RemoveCharacterEquip(chr, GUN_ITEM_TYPE);
					TakeItemFromCharacter(chr, "pistolmket");

					Locations[FindLocation(chr.location)].models.always.locators = "Imayak_l_JRH";

					LAi_QuestDelay("place_musket_lever", 1.0);
				}
				else
				{
					Logit(TranslateString("","One musket is missing!"));
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");
				}
				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_church_outside")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("PEOPLE\Run_roof.wav");
				ChangeCharacterAddressGroup(chr, "wr_church_outside", "goto", "goto6");
			break;

			case "box2":
				PlaySound("PEOPLE\Run_roof.wav");
				ChangeCharacterAddressGroup(chr, "wr_church_outside", "goto", "goto7");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_church_attic")
	{
		switch(chr.boxname)
		{
			case "box2":

			break;

			case "box3":
				PlaySound("PEOPLE\Run_roof.wav");
				ChangeCharacterAddressGroup(chr, "wr_church_attic", "goto", "goto4");

				LAi_QuestDelay("church_attic2", 0.1);
			break;

			case "box4":
				PlaySound("PEOPLE\Run_roof.wav");
				ChangeCharacterAddressGroup(chr, "wr_church_attic", "goto", "goto11");

				LAi_QuestDelay("church_attic2", 0.1);
			break;

			case "box5":
				PlaySound("PEOPLE\Run_roof.wav");
				ChangeCharacterAddressGroup(chr, "wr_church_attic", "goto", "window");

				LAi_QuestDelay("Vane_returns_to_attic", 1.0);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="Tavern_storeroom")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_storeroom", 2.0);
			break;

			case "box2":
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "Tavern_storeroom", "box", "box3");
			break;

			case "box3":
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "Tavern_storeroom", "box", "box2");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="Redmond_UsurerHouse")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_shop", 2.0);
			break;

			case "box2":
				if(!IsEquipCharacterByItem(chr, "bladepickaxe1")) EquipCharacterByItem(chr, "bladepickaxe1");
				LAi_SetFightMode(chr, true);

				LAi_QuestDelay("stick_on_floorhatch", 1.0);
			break;

			case "box3":
				PlaySound("PEOPLE\counter_openclose.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_UsurerHouse", "box", "box4");
			break;

			case "box4":
				PlaySound("PEOPLE\counter_openclose.wav");
				ChangeCharacterAddressGroup(chr, "Redmond_UsurerHouse", "box", "box3");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_bedroom")
	{
		switch(chr.boxname)
		{
			case "box1":
				//ordinary chest
				PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 		LaunchItemsBox(&ar);
				return;
			break;


			case "box2":
				PlaySound("INTERFACE\key_unlock.wav");

				LAi_QuestDelay("unlock_kitchen", 2.0);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_mine")
	{
		PlaySound("INTERFACE\key_unlock.wav");

		switch(chr.boxname)
		{
			case "box1":
				LAi_QuestDelay("unlock_tunnel_B", 2.0);
			break;

			case "box2":
				LAi_QuestDelay("unlock_tunnel_A", 2.0);
			break;

			case "box3":
				LAi_QuestDelay("unlock_tunnel_Z", 2.0);
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_animists")
	{
		switch(chr.boxname)
		{
			case "box1":
				//throne

				LAi_SetSitType(chr);

				if(Locations[FindLocation(chr.location)].models.always.locators == "scave_l_JRH_OFF")
				{
					PlaySound("AMBIENT\JAIL\sigh.wav");
					Logit(TranslateString("","No effect - the mechanism is not activated."));

					LAi_QuestDelay("temple_sit_function_OFF", 2.0);
				}
				else
				{
					PlaySound("INTERFACE\step_path.wav");

					LAi_QuestDelay("temple_mandala_turn", 0.3);
				}
			break;

			case "box2":
				//lever is down - function is on

				PlaySound("INTERFACE\lever_up.wav");

				Locations[FindLocation(chr.location)].models.always.locators = "scave_l_JRH_OFF";

				LAi_QuestDelay("temple_lever_OFF", 0.5);
				return;
			break;

			case "box3":
				//lever is up - function is off

				PlaySound("INTERFACE\lever_down.wav");

				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "1")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "scave_l_JRH_ON1";
				}

				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "2")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "scave_l_JRH_ON2";
				}

				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "3")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "scave_l_JRH_ON3";
				}

				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "4")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "scave_l_JRH_ON4";
				}

				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "5")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "scave_l_JRH_ON5";
				}

				LAi_QuestDelay("temple_lever_ON", 0.5);
				return;
			break;

			case "box4":
				if(CheckAttribute(chr,"quest.mine_bomb") && chr.quest.mine_bomb == "open")
				{
					PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 			LaunchItemsBox(&ar);
					return;
				}
				else
				{
					if(CheckCharacterItem(chr,"bladeaxe5"))
					{
						if(!IsEquipCharacterByItem(chr, "bladeaxe5")) EquipCharacterByItem(chr, "bladeaxe5");
						LAi_LocationFightDisable(&Locations[FindLocation(chr.location)], false);//temp only
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("axe5_to_minebomb", 1.0);
					}
					else
					{
						PlaySound("INTERFACE\door_locked2.wav");
						Logit(TranslateString("","What have they done here - nailed the cupboard?"));
						return;
					}
				}
			break;

			case "box5":
				PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 		LaunchItemsBox(&ar);

				LAi_QuestDelay("from_box5_temple", 1.0);
			break;

			case "box6":
				//was cell2
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				Logit(TranslateString("","No, I can't remove that thing whatever it is."));
				return;
			break;

			case "box7":
				//was cell4
				if(CheckCharacterItem(chr,"pistolspade"))
				{
					if(!IsEquipCharacterByItem(chr, "pistolspade")) EquipCharacterByItem(chr, "pistolspade");
					LAi_SetFightMode(chr, true);
				}
			break;

			case "box8":
				//to cell1
				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "2")
				{
					ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box9");
					PlaySound("INTERFACE\rusty.wav");
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box9":
				ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box8");
				PlaySound("INTERFACE\rusty.wav");
			break;

			case "box10":
				//to cell2
				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "3")
				{
					ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box11");
					PlaySound("INTERFACE\rusty.wav");
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box11":
				ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box10");
				PlaySound("INTERFACE\rusty.wav");
			break;

			case "box12":
				//to cell3
				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "4")
				{
					ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box13");
					PlaySound("INTERFACE\rusty.wav");
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box13":
				ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box12");
				PlaySound("INTERFACE\rusty.wav");
			break;

			case "box14":
				//to cell4
				if(CheckAttribute(chr,"quest.mandala_position") && chr.quest.mandala_position == "5")
				{
					ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box15");
					PlaySound("INTERFACE\rusty.wav");
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box15":
				ChangeCharacterAddressGroup(chr, "wr_animists", "box", "box14");
				PlaySound("INTERFACE\rusty.wav");
			break;

			case "box16":
				//to throne
				ChangeCharacterAddressGroup(chr, "wr_animists", "goto", "goto38");
				PlaySound("PEOPLE\recoil.wav");
			break;

			case "box17":
				//to writing desk
				ChangeCharacterAddressGroup(chr, "wr_animists", "goto", "sit1");
				PlaySound("PEOPLE\creak2.wav");
			break;

		}
		return;
	}

	if(Locations[locidx].id=="wr_gibbet")
	{
		switch(chr.boxname)
		{
			case "box1":
				//barrel end

				if(Locations[FindLocation(chr.location)].models.always.locators == "Pri_l_gibbet_JRH")
				{
					ChangeCharacterAddressGroup(chr, "wr_gibbet", "goto", "right");
					LAi_SetSitType(chr);
					PlaySound("INTERFACE\bottle_molasses.wav");
					Locations[FindLocation("wr_gibbet")].models.always.locators = "Pri_l_gibbet_JRH1";//barrel up

					LAi_QuestDelay("empty_barrel_gibbet3", 1.0);//staytype after 1 sec
					LAi_QuestDelay("empty_barrel_gibbet2", 3.0);//creak sound after 3 sec
					LAi_QuestDelay("empty_barrel_gibbet", 4.0);//reload after 4 sec
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "Pri_l_gibbet_JRH2")//empty barrel no skeleton
				{
					if(CheckCharacterItem(chr,"bladehammer"))
					{
						EquipCharacterByItem(chr, "bladehammer");
						ChangeCharacterAddressGroup(chr, "wr_gibbet", "goto", "right");
						LAi_SetFightMode(chr, true);
						LAi_QuestDelay("hammer_on_barrel", 1.0);
					}
					else
					{
						PlaySound("OBJECTS\DUEL\man_attack1.wav");
						Logit(TranslateString("","That barrel could be useful but I can't remove it with my bare hands from the gibbet."));
					}
				}
			break;

			case "box2":
				//skeleton end

				if(Locations[FindLocation(chr.location)].models.always.locators == "Pri_l_gibbet_JRH1")//barrel up
				{
					Logit(TranslateString("","Maybe I should cut him down."));
					ChangeCharacterAddressGroup(chr, "wr_gibbet", "goto", "goto5");//test 1 step back
					LAi_SetFightMode(chr, true);
					ChangeCharacterAddressGroup(CharacterFromID("wr_hanged"), "wr_gibbet", "goto", "goto3");//reset

					LAi_QuestDelay("cut_down_hanged", 1.0);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "Pri_l_gibbet_JRH3")//horizontal, up
				{
					if(CheckCharacterItem(chr,"bladeaxe4"))
					{
						EquipCharacterByItem(chr, "bladeaxe4");
						ChangeCharacterAddressGroup(chr, "wr_gibbet", "goto", "goto5");//test 1 step back
						LAi_SetFightMode(chr, true);
						ChangeCharacterAddressGroup(CharacterFromID("wr_hanged"), "wr_gibbet", "goto", "goto3");//reset

						LAi_QuestDelay("axe_on_skeleton", 1.0);
					}
					else
					{
						PlaySound("OBJECTS\DUEL\man_attack1.wav");
						Logit(TranslateString("","The corpse is too heavy walking around with."));
					}
				}
			break;

			case "box3":
				//poles in the middle
				if(CheckCharacterItem(chr,"bladesaw"))
				{
					EquipCharacterByItem(chr, "bladesaw");
					ChangeCharacterAddressGroup(chr, "wr_gibbet", "goto", "saw");
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("saw_on_gibbet", 1.0);
				}
				else
				{
					PlaySound("VOICE\ENGLISH\blaze_mhm.wav");
					Logit(TranslateString("","Maybe these poles and planks could be of some help."));
				}
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_food_supply")
	{
		switch(chr.boxname)
		{
			case "box1":
				//filled barrel
				if(CheckCharacterItem(chr,"bladebarrel"))
				{
					Logit(TranslateString("","My barrel is filled with rum!"));
					PlaySound("INTERFACE\rum_barrel_empty.wav");
					PlaySound("INTERFACE\rum_barrel_filled.wav");

					LAi_QuestDelay("rum_food_supply", 2.0);
				}
				else
				{
					//empty barrel
					if(CheckCharacterItem(chr,"bladebarrel2"))
					{
						PlaySound("INTERFACE\rum_barrel_empty.wav");
						PlaySound("INTERFACE\bottle_molasses.wav");
						chr.quest.prison_barrel = "filled";

						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						TakeItemFromCharacter(chr, "bladebarrel2");
						GiveItem2Character(chr, "bladebarrel");
						EquipCharacterByItem(chr, "bladebarrel");

						LAi_QuestDelay("filling_rum_food_supply", 4.0);
					}
				}
				else
				{
					Logit(TranslateString("","There sure is a lot of rum stacked in here"));
					PlaySound("INTERFACE\rum_barrel_empty.wav");
					PlaySound("INTERFACE\rum_barrel_filled.wav");

					LAi_QuestDelay("rum_food_supply", 2.0);
				}
			break;

			case "box7":
				//pick up food chest (and drop medicine chest, bandages or sack if you got any of those)

				if(CheckCharacterItem(chr,"rolls_of_bandages")) chr.quest.cellar_bandages = "placed";
				if(CheckCharacterItem(chr,"leeches")) chr.quest.cellar_leeches = "placed";

				if(CheckCharacterItem(chr,"meds1"))
				{
					chr.quest.cellar_meds1 = "placed";
					TakeItemFromCharacter(chr, "meds1");
				}
				if(CheckCharacterItem(chr,"meds2"))
				{
					chr.quest.cellar_meds2 = "placed";
					TakeItemFromCharacter(chr, "meds2");
				}
				if(CheckCharacterItem(chr,"meds3"))
				{
					chr.quest.cellar_meds3 = "placed";
					TakeItemFromCharacter(chr, "meds3");
				}
				if(CheckCharacterItem(chr,"Potion3"))
				{
					chr.quest.cellar_Potion3 = "placed";
					TakeItemFromCharacter(chr, "Potion3");
				}
				if(CheckCharacterItem(chr,"pistolgas"))
				{
					chr.quest.cellar_pistolgas = "placed";
					TakeItemFromCharacter(chr, "pistolgas");
				}
				if(CheckCharacterItem(chr,"mercury_bottles"))
				{
					chr.quest.cellar_mercury = "placed";
					TakeItemFromCharacter(chr, "mercury_bottles");
				}
				if(CheckCharacterItem(chr,"empty_bottless"))
				{
					chr.quest.cellar_emptyb = "placed";
					TakeItemFromCharacter(chr, "empty_bottles");
				}
				if(CheckCharacterItem(chr,"mdchest_B2"))
				{
					chr.quest.cellar_md_B2 = "placed";
					TakeItemFromCharacter(chr, "mdchest_B2");
				}
				if(CheckCharacterItem(chr,"mdchest_B3"))
				{
					chr.quest.cellar_md_B3 = "placed";
					TakeItemFromCharacter(chr, "mdchest_B3");
				}

				RemoveCharacterEquip(chr, GUN_ITEM_TYPE);

				if(CheckCharacterItem(chr,"pistolmdchest_F2B"))
				{
					chr.quest.med_chest = "F2B_placed";
					Log_SetStringToLog(XI_ConvertString("You give item"));
					PlaySound("INTERFACE\important_item.wav");
					TakeItemFromCharacter(chr, "pistolmdchest_F2A");
					TakeItemFromCharacter(chr, "pistolmdchest_F2B");

					Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_M";
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdchest_F2B_C"))
					{
						chr.quest.med_chest = "F2B_C_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdchest_F2A_C");
						TakeItemFromCharacter(chr, "pistolmdchest_F2B_C");
						TakeItemFromCharacter(chr, "rolls_of_bandages");

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_MC";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdchest_F2B_S"))
					{
						chr.quest.med_chest = "F2B_S_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdchest_F2A_S");
						TakeItemFromCharacter(chr, "pistolmdchest_F2B_S");
						TakeItemFromCharacter(chr, "leeches");	//if you got any

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_MS";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdchest_F2B_CS"))
					{
						chr.quest.med_chest = "F2B_CS_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdchest_F2A_CS");
						TakeItemFromCharacter(chr, "pistolmdchest_F2B_CS");
						TakeItemFromCharacter(chr, "rolls_of_bandages");
						TakeItemFromCharacter(chr, "leeches");	//if you got any

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_MCS";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdchest_F3B"))
					{
						chr.quest.med_chest = "F3B_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdchest_F3A");
						TakeItemFromCharacter(chr, "pistolmdchest_F3B");

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_M";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdchest_F3B_C"))
					{
						chr.quest.med_chest = "F3B_C_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdchest_F3A_C");
						TakeItemFromCharacter(chr, "pistolmdchest_F3B_C");
						TakeItemFromCharacter(chr, "rolls_of_bandages");

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_MC";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdchest_F3B_S"))
					{
						chr.quest.med_chest = "F3B_S_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdchest_F3A_S");
						TakeItemFromCharacter(chr, "pistolmdchest_F3B_S");
						TakeItemFromCharacter(chr, "leeches");	//if you got any

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_MS";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdchest_F3B_CS"))
					{
						chr.quest.med_chest = "F3B_CS_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdchest_F3A_CS");
						TakeItemFromCharacter(chr, "pistolmdchest_F3B_CS");
						TakeItemFromCharacter(chr, "rolls_of_bandages");
						TakeItemFromCharacter(chr, "leeches");	//if you got any

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_MCS";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdcloth"))
					{
						chr.quest.med_chest = "cloth_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdcloth");

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_C";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdsack"))
					{
						chr.quest.med_chest = "sack_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdsack");

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_S";
					}
				}
				else
				{
					if(CheckCharacterItem(chr,"pistolmdclothsack"))
					{
						chr.quest.med_chest = "clothsack_placed";
						Log_SetStringToLog(XI_ConvertString("You give item"));
						PlaySound("INTERFACE\important_item.wav");
						TakeItemFromCharacter(chr, "pistolmdclothsack");
						TakeItemFromCharacter(chr, "leeches");	//if you got any

						Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH2_CS";
					}
				}
				else
				{
					Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH";//no med items
				}


				LAi_QuestDelay("pickup_foodchest_place_mdchest", 0.5);
			break;

			case "box2":
				//pick up medicine chest - don't place anything

			    if(CheckAttribute(chr,"quest.med_monkey_food") && chr.quest.med_monkey_food == "done")
			    {
				Locations[FindLocation("wr_food_supply")].models.always.locators = "store03_locators_JRH";

				LAi_QuestDelay("pickup_mdchest_place_nothing", 0.5);
			    }
			    else
			    {
				Logit(TranslateString("","No, I can't carry the medicine stuff too."));
				PlaySound("VOICE\ENGLISH\blaze_hah.wav");
			    }
			break;

			case "box3":
				//meat
				if(CheckCharacterItem(chr,"key15"))
				{
					PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 			LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box4":
				//ale
				if(CheckCharacterItem(chr,"key15"))
				{
					PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 			LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box5":
				//bread
				if(CheckCharacterItem(chr,"key15"))
				{
					PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 			LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box6":
				//fish
				if(CheckCharacterItem(chr,"key15"))
				{
					PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 			LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box10":
				if(CheckAttribute(chr,"quest.mine_enabled") && chr.quest.mine_enabled == "yes")
				{
					PlaySound("PEOPLE\creak2.wav");
					ChangeCharacterAddressGroup(chr, "wr_food_supply", "box", "box11");
				}
				else PlaySound("INTERFACE\knock.wav");
				return;
			break;

			case "box11":
				if(CheckAttribute(chr,"quest.mine_enabled") && chr.quest.mine_enabled == "yes")
				{
					PlaySound("PEOPLE\creak2.wav");
					ChangeCharacterAddressGroup(chr, "wr_food_supply", "box", "box10");
				}
				else PlaySound("INTERFACE\knock.wav");
				return;
			break;

			case "box12":
				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				ChangeCharacterAddressGroup(chr, "wr_food_supply", "goto", "goto2");
				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_prison")
	{
		switch(chr.boxname)
		{
			case "box1":
				//steplock A outer cell
				RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);

				if(CheckAttribute(chr,"quest.prison_barrel") && chr.quest.prison_barrel == "empty")
				{
					GiveItem2Character(chr, "bladebarrel2");
					EquipCharacterByItem(chr, "bladebarrel2");

					//Log_SetStringToLog("itemlogic_empty");
					chr.quest.prison_barrel2 = "loop_off";//to stop ongoing loop
					chr.quest.prison_barrel3 = "pick_up";//to get locatorset ONE time

					if(CheckAttribute(chr,"quest.keybox13_prison") && chr.quest.keybox13_prison == "within_reach")
					{
						Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH00";//open floor hatch
					}
					else
					{
						Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH1";//open floor hatch
					}

					Locations[FindLocation("wr_prison")].image = "";
					DoQuestReloadToLocation("wr_prison", "goto", "goto2", "steplock_A_prison8");	//dead end
															//another way into the loop again
				}
				else
				{
					if(CheckAttribute(chr,"quest.prison_skull") && chr.quest.prison_skull == "placed")
					{
						GiveItem2Character(chr, "bladebarrel");
						EquipCharacterByItem(chr, "bladebarrel");

						//Log_SetStringToLog("itemlogic_else_is_filled + skull placed");
						Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH7";//skull,open floor hatch without barrel

						Locations[FindLocation("wr_prison")].image = "";
						//DoQuestReloadToLocation("wr_prison", "goto", "goto2", "steplock_A_prison4");//ok but very late arrive rogers

						DoQuestReloadToLocation("wr_prison", "goto", "goto2", "steplock_A_prison4_rogers");//try this instead
					}
					else
					{
						GiveItem2Character(chr, "bladebarrel");
						EquipCharacterByItem(chr, "bladebarrel");
						chr.quest.steplock_A_prison = "something_else";
						//try to avoid twice on goto3 to close hatch, when picked up filled barrel

						Log_SetStringToLog("itemlogic_else_is_filled");

						locations[FindLocation("wr_dungeon3_right")].reload.l1.disable = 1;//ladder up to inner cell

						if(CheckAttribute(chr,"quest.keybox13_prison") && chr.quest.keybox13_prison == "within_reach")
						{
							Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH00";//open floor hatch
						}
						else
						{
							Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH1";//open floor hatch
						}

						Locations[FindLocation("wr_prison")].image = "";
						DoQuestReloadToLocation("wr_prison", "goto", "goto2", "steplock_A_prison4");//into the loop again
					}
				}
			break;

			case "box2":
				//steplock B inner cell

				if(CheckAttribute(chr,"quest.prison_barrel4") && chr.quest.prison_barrel4 == "plank_placed_on_wall")
				{
					if(CheckCharacterItem(chr,"bladebarrel"))
					{
						//PUT DOWN BARREL
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						TakeItemFromCharacter(chr, "bladebarrel");
						EquipcharacterByItem(chr, "bladeA11");
						Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH9";//skull, barrel on steplock B, floor & wall open, plank on wall

						Locations[FindLocation("wr_prison")].image = "";
						DoQuestReloadToLocation("wr_prison", "goto", "goto4", "loading_image_back_prison");
					}
					else
					{
						//PICK UP BARREL
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
						GiveItem2Character(chr, "bladebarrel");
						EquipCharacterByItem(chr, "bladebarrel");
						Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH10";//skull, both open, plank on wall but NO NARREL

						Locations[FindLocation("wr_prison")].image = "";
						DoQuestReloadToLocation("wr_prison", "goto", "goto4", "loading_image_back_prison");
					}
				}
				else
				{
					//PICK UP BARREL
					RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
					GiveItem2Character(chr, "bladebarrel");
					EquipCharacterByItem(chr, "bladebarrel");
					chr.quest.steplock_B_prison = "something_else";
					chr.quest.prison_barrel4 = "wait_with_wall_plank";

					//Log_SetStringToLog("itemlogic");
					Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH7_A";//skull, open floor & wall, no barrel

					chr.quest.swimtime = "no";

					if(Locations[FindLocation("wr_dungeon3_left")].models.always.locators == "d03_l_JRH_L3")
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L1";

					if(Locations[FindLocation("wr_dungeon3_left")].models.always.locators == "d03_l_JRH_L4")
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L4";

					Locations[FindLocation("wr_mine")].reload.l5.disable = 1;		//tunnelA
					Locations[FindLocation("wr_dungeon3_left")].environment.sea = "false";	//tunnelA
					Locations[FindLocation("wr_dungeon3_left")].environment.weather = "false";

					SetCurrentTime(11.00, 0);
					SetNextWeather("Clear");
					chr.quest.JRH_rain = "Mine Fog 1";

					ChangeCharacterAddressGroup(CharacterFromID("wr_boc5"), "wr_mine", "goto", "goto3");
					LAi_SetStayType(CharacterFromID("wr_boc5"));
					ChangeCharacterAddressGroup(CharacterFromID("Powdermonkey"), "none", "", "");

					Locations[FindLocation("wr_prison")].image = "";
					DoQuestReloadToLocation("wr_prison", "goto", "goto4", "steplock_B_prison4");//into the loop again
				}
			break;

			case "box3":
				//reach key-box13 from outer cell with pickaxe

				if(CheckCharacterItem(chr,"bladepickaxe2"))
				{
					EquipCharacterByItem(chr, "bladepickaxe2");
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("pickaxe2_on_keybox", 1.0);
				}
				else
				{
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");
					Logit(TranslateString("","I need something with a hook to get those boxes."));

					if(CheckAttribute(chr,"quest.hook_to_keyboxes") && chr.quest.hook_to_keyboxes == "done")
					{

					}
					else
					{
						chr.quest.hook_to_keyboxes = "done";
						AddQuestRecord("Open_the_cell", "2");
					}
				}
			break;

			case "box4":
				//placing plank on wall standing on open floor hatch

				LAi_SetFightMode(chr, true);
				chr.quest.prison_barrel4 = "plank_placed_on_wall";
				Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH9";//skull, barrel on steplock B, floor & wall open, plank on wall

				LAi_QuestDelay("place_plank_on_wall", 1.0);
			break;

			case "box5":
				//placing barrel under open wall hatch

				if(CheckCharacterItem(chr,"bladebarrel"))
				{
					//PUT DOWN BARREL
					locations[FindLocation(chr.location)].box6.items.jewelry5 = 1;
					locations[FindLocation(chr.location)].box6.items.pistol206 = 1;
					locations[FindLocation(chr.location)].box6.items.blue_uniform = 1;

					RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
					TakeItemFromCharacter(chr, "bladebarrel");

					if(CheckCharacterItem(chr,"bladeA11"))
					{
						EquipcharacterByItem(chr, "bladeA11");
					}
					else EquipcharacterByItem(chr, "bladeX4");

					Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH11";//skull, barrel on steplock B, floor & wall open, plank on wall

					Locations[FindLocation("wr_prison")].image = "";
					DoQuestReloadToLocation("wr_prison", "goto", "goto30", "loading_image_back_prison");
				}
			break;

			case "box6":
				if(CheckAttribute(chr,"quest.prison_barrel4") && chr.quest.prison_barrel4 == "ready_to_remove_plank_from_wall")
				{
					//remove plank from wall

					PlaySound("PEOPLE\wood1.wav");

					LAi_QuestDelay("remove_plank_from_wall1", 0.1);
				}
				else
				{
					//blue chest: ordinary box procedure

					PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 			LaunchItemsBox(&ar);
					LAi_QuestDelay("get_all_3_items", 0.1);
					return;
				}
			break;

			case "box7":
				//place plank on floor

				RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
				TakeItemFromCharacter(chr, "bladeplank");
				EquipcharacterByItem(chr, "bladeA11");
				Locations[FindLocation("wr_prison")].models.always.locators = "Pri_l_JRH14";//floor closed, plank on floor

				Locations[FindLocation("wr_prison")].image = "";
				DoQuestReloadToLocation("wr_prison", "goto", "goto18", "place_plank_on_floor");
			break;

			case "box8":
				//cell door

				if(CheckAttribute(chr,"quest.prison_celldoor") && chr.quest.prison_celldoor == "open")
				{
					PlaySound("INTERFACE\rusty.wav");
					ChangeCharacterAddressGroup(chr, "wr_prison", "box", "box9");
				}
				else PlaySound("INTERFACE\locked_window.wav");
			break;

			case "box9":
				//cell door

				if(CheckAttribute(chr,"quest.prison_celldoor") && chr.quest.prison_celldoor == "open")
				{
					PlaySound("INTERFACE\rusty.wav");
					ChangeCharacterAddressGroup(chr, "wr_prison", "box", "box8");
				}
				else PlaySound("INTERFACE\locked_window.wav");
			break;

			case "box10":
				//step on open hatch
				if(CheckCharacterItem(chr,"bladeplank"))
				{
					if(!IsEquipCharacterByItem(chr, "bladeplank"))
					{
						RemoveCharacterEquip(chr, BLADE_ITEM_TYPE );
						EquipCharacterByItem(chr, "bladeplank");
					}
					SetLocatorRadius(locations[FindLocation(chr.location)], "box", "box11", 0.0001);
					SetLocatorRadius(locations[FindLocation(chr.location)], "box", "box4", 0.5);

					Locations[FindLocation("wr_prison")].locators_radius.box.box11 = 0.0001;
					Locations[FindLocation("wr_prison")].locators_radius.box.box4 = 0.5;
				}
				else
				{
					SetLocatorRadius(locations[FindLocation(chr.location)], "box", "box4", 0.0001);
					SetLocatorRadius(locations[FindLocation(chr.location)], "box", "box11", 0.5);

					Locations[FindLocation("wr_prison")].locators_radius.box.box4 = 0.0001;
					Locations[FindLocation("wr_prison")].locators_radius.box.box11 = 0.5;
				}

				PlaySound("PEOPLE\recoil.wav");
				PlaySound("PEOPLE\creak2.wav");
				ChangeCharacterAddressGroup(chr, "wr_prison", "goto", "goto10");
			break;

			case "box11":
				//jump down from open hatch

				PlaySound("PEOPLE\Jump.wav");
				ChangeCharacterAddressGroup(chr, "wr_prison", "goto", "goto11");
			break;

			case "box12":
				//step on barrel

				PlaySound("PEOPLE\recoil.wav");
				ChangeCharacterAddressGroup(chr, "wr_prison", "goto", "goto8");
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_mine_control")
	{
		switch(chr.boxname)
		{
			case "box1":
				//lever is up - system1 (mine) is off
				PlaySound("INTERFACE\lever_down.wav");

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH1";
					LAi_QuestDelay("mine_lights_1", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2_G" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3_G")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH1_G";
					LAi_QuestDelay("mine_lights_1G", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2_F" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3_F")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH1_F";
					Locations[FindLocation("wr_mine")].models.always.locators = "mine_l_JRH1";
					Locations[FindLocation("wr_dungeon4_main")].models.always.locators = "d04_l_JRH_OFF1";

					Locations[FindLocation("wr_dungeon3_right")].models.always.locators = "d03_l_JRH_R1";
					if(CheckAttribute(chr,"quest.swimtime") && chr.quest.swimtime == "yes")
					{
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L3";
					}
					else
					{
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L1";
					}

					LAi_QuestDelay("mine_lights_1F", 0.5);
				}
			break;

			case "box2":
				//lever is up - system2 (tunnelA) is off
				PlaySound("INTERFACE\lever_down.wav");

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH2";
					LAi_QuestDelay("mine_lights_2", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1_G" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3_G")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH2_G";
					LAi_QuestDelay("mine_lights_2G", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1_F" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3_F")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH2_F";
					Locations[FindLocation("wr_mine")].models.always.locators = "mine_l_JRH2";
					Locations[FindLocation("wr_dungeon4_main")].models.always.locators = "d04_l_JRH_OFF1";

					Locations[FindLocation("wr_dungeon3_right")].models.always.locators = "d03_l_JRH_R2";
					if(CheckAttribute(chr,"quest.swimtime") && chr.quest.swimtime == "yes")
					{
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L4";
					}
					else
					{
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L2";
					}

					LAi_QuestDelay("mine_lights_2F", 0.5);
				}
			break;

			case "box3":
				//lever is up - system3 (tunnelZ) is off
				PlaySound("INTERFACE\lever_down.wav");

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH3";
					LAi_QuestDelay("mine_lights_3", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1_G" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2_G")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH3_G";
					LAi_QuestDelay("mine_lights_3G", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1_F" || Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2_F")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH3_F";
					Locations[FindLocation("wr_mine")].models.always.locators = "mine_l_JRH3";
					Locations[FindLocation("wr_dungeon4_main")].models.always.locators = "d04_l_JRH_ON1";

					Locations[FindLocation("wr_dungeon3_right")].models.always.locators = "d03_l_JRH_R1";
					if(CheckAttribute(chr,"quest.swimtime") && chr.quest.swimtime == "yes")
					{
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L3";
					}
					else
					{
						Locations[FindLocation("wr_dungeon3_left")].models.always.locators = "d03_l_JRH_L1";
					}

					LAi_QuestDelay("mine_lights_3F", 0.5);
				}
			break;

			case "box4":
				//lever is down - gas OR fire

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1_G")
				{
					PlaySound("INTERFACE\lever_up.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH1";
					LAi_QuestDelay("mine_lights_gas_off", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2_G")
				{
					PlaySound("INTERFACE\lever_up.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH2";
					LAi_QuestDelay("mine_lights_gas_off", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3_G")
				{
					PlaySound("INTERFACE\lever_up.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH3";
					LAi_QuestDelay("mine_lights_gas_off", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1_F")
				{
					PlaySound("INTERFACE\lever_up.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH1";
					LAi_QuestDelay("mine_lights_fire_off", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2_F")
				{
					PlaySound("INTERFACE\lever_up.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH2";
					LAi_QuestDelay("mine_lights_fire_off", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3_F")
				{
					PlaySound("INTERFACE\lever_up.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH3";
					LAi_QuestDelay("mine_lights_fire_off", 0.5);
				}
			break;

			case "box5":
				//lever is up - no gas or fire

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH1")
				{
					PlaySound("INTERFACE\lever_down.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH1_G";
					LAi_QuestDelay("mine_lights_gas_on", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH2")
				{
					PlaySound("INTERFACE\lever_down.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH2_G";
					LAi_QuestDelay("mine_lights_gas_on", 0.5);
				}

				if(Locations[FindLocation(chr.location)].models.always.locators == "d02_l_JRH3")
				{
					PlaySound("INTERFACE\lever_down.wav");
					Locations[FindLocation(chr.location)].models.always.locators = "d02_l_JRH3_G";
					LAi_QuestDelay("mine_lights_gas_on", 0.5);
				}
			break;
		}
		return;
	}

	if(Locations[locidx].id=="Redmond_Town_01")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
	    	{
			//lever is up - bridge is unvisible (start)
			PlaySound("INTERFACE\lever_down.wav");
			Locations[FindLocation(chr.location)].models.always.locators = "Red01_l_JRH4";

			LAi_QuestDelay("bridge_visible", 1.0);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box3")
	    	{
			//lever is down - bridge is visible (on the way back ONLY!)
			PlaySound("INTERFACE\lever_up.wav");
			Locations[FindLocation(chr.location)].models.always.locators = "Red01_l_JRH_back_rope";
			chr.quest.bridge_check = "gone";

			LAi_QuestDelay("bridge_invisible", 1.0);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box4")
	    	{
			PlaySound("OBJECTS\DUEL\man_attack1.wav");
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "cat_burglar2");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box5")
	    	{
			PlaySound("OBJECTS\VOICES\DEAD\male\dead3.wav");
			PlaySound("OBJECTS\VOICES\DEAD\male\dead3.wav");
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "cat_burglar3");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box6")
	    	{
			chr.quest.high_roof_check = "ok";
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "cat_burglar9");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box7")
	    	{
			PlaySound("OBJECTS\DUEL\man_hit4.wav");
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "cat_burglar10");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box8")
	    	{
			PlaySound("PEOPLE\run_wood.wav");

			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "cat_burglar11");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box9")
	    	{
			PlaySound("OBJECTS\VOICES\DEAD\male\dead3.wav");
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "cat_burglar12");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box10")
	    	{
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "cat_burglar15");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box11")
	    	{
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "goto63");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box12")
	    	{
			ChangeCharacterAddressGroup(chr, "Redmond_Town_01", "goto", "goto62");
			return;
		}

	}

	if(Locations[locidx].id=="Redmond_shipyard")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box1")
	    	{
			PlaySound("INTERFACE\locked_window.wav");
			LAi_QuestDelay("shipyard_loft3", 1.0);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
	    	{
			PlaySound("INTERFACE\locked_window.wav");
			LAi_QuestDelay("shipyard_loft5", 1.0);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box3")
	    	{
			PlaySound("AMBIENT\JAIL\jail_door2.wav");
			LaunchItemsBox(&ar);
			return;
		}
	}

	if(Locations[locidx].id=="wr_gunroom")
	{
		switch(chr.boxname)
		{
			case "box1":
				//wheel on water tank

				if(CheckAttribute(chr,"quest.wheel_check") && chr.quest.wheel_check == "0")
				{
					chr.quest.wheel_check = "1";
					//chr.quest.4checks = sti(chr.quest.3checks) + 1;//not used yet
				}

				if(CheckAttribute(chr,"quest.rum_phase") && chr.quest.rum_phase == "2") return;
				if(CheckAttribute(chr,"quest.rum_phase") && chr.quest.rum_phase == "3") return;

				PlaySound("INTERFACE\rum_wheel.wav");
				PlaySound("INTERFACE\rusty.wav");

				if(CheckAttribute(chr,"quest.rum_water") && chr.quest.rum_water == "filled")
				{
					if(CheckAttribute(chr,"quest.rum_wheel") && chr.quest.rum_wheel == "on")
					{
						chr.quest.rum_wheel = "off";
						LAi_QuestDelay("wheel_water", 0.1);
					}
					else
					{
						chr.quest.rum_wheel = "on";
						LAi_QuestDelay("wheel_water", 3.0);
					}
				}

				Logit(TranslateString("","Water valve"));
				return;
			break;

			case "box2":
				//open water tank

				if(CheckAttribute(chr,"quest.water_check") && chr.quest.water_check == "0")
				{
					chr.quest.water_check = "1";
					//chr.quest.4checks = sti(chr.quest.3checks) + 1;//not used yet
				}

				PlaySound("AMBIENT\TAVERN\open_bottle.wav");
				Logit(TranslateString("","Water tank"));

				LAi_QuestDelay("water_tank", 1.0);
				return;
			break;

			case "box3":
				//molasses tank

				if(CheckAttribute(chr,"quest.molasses_check") && chr.quest.molasses_check == "0")
				{
					chr.quest.molasses_check = "1";
					//chr.quest.4checks = sti(chr.quest.3checks) + 1;//not used yet

					SetQuestHeader("Distiller");
					AddQuestRecord("Distiller", "1");
					//DeleteQuestHeader("Woodes_Rogers_reward_4");	//skip it earlier: when "Librarian" is started
				}

				if(CheckAttribute(chr,"quest.rum_molasses") && chr.quest.rum_molasses == "filled")
				{
					PlaySound("INTERFACE\rum_barrel_filled.wav");
					PlaySound("INTERFACE\rum_barrel_empty.wav");
				}

			//........................................................................................

				if(CheckAttribute(chr,"quest.rum_molasses") && chr.quest.rum_molasses == "bladebottle")
				{
					if(CheckCharacterItem(chr,"pistolbottlew4"))
					{
						TakeItemFromCharacter(chr, "pistolbottlew4");
						EquipCharacterByItem(chr, "pistol204");
						PlaySound("INTERFACE\bottle_molasses.wav");

						chr.quest.rum_molasses = "filled";
						LAi_QuestDelay("bartender_arrives", 4.0);	//quest continues ...
					}
					else
					{
						PlaySound("INTERFACE\rum_barrel_empty.wav");
						if(CheckAttribute(chr,"quest.rum_phase") && chr.quest.rum_phase != "3")
						PlaySound("INTERFACE\took_item.wav");
					}
				}

				if(CheckAttribute(chr,"quest.rum_molasses") && chr.quest.rum_molasses == "pistolbottle")
				{
					if(CheckCharacterItem(chr,"bladebottlew4"))
					{
						TakeItemFromCharacter(chr, "bladebottlew4");
						EquipCharacterByItem(chr, "bladeA11");
						PlaySound("INTERFACE\bottle_molasses.wav");

						chr.quest.rum_molasses = "filled";
						LAi_QuestDelay("bartender_arrives", 4.0);	//quest continues ...
					}
					else
					{
						PlaySound("INTERFACE\rum_barrel_empty.wav");
						if(CheckAttribute(chr,"quest.rum_phase") && chr.quest.rum_phase != "3")
						PlaySound("INTERFACE\took_item.wav");
					}
				}

				if(CheckAttribute(chr,"quest.rum_molasses") && chr.quest.rum_molasses == "empty")
				{
					if(CheckCharacterItem(chr,"bladebottlew4") && CheckCharacterItem(chr,"pistolbottlew4") )
					{
						TakeItemFromCharacter(chr, "bladebottlew4");
						EquipCharacterByItem(chr, "bladeA11");
						PlaySound("INTERFACE\bottle_molasses.wav");
						chr.quest.rum_molasses = "bladebottle";
					}
					else
					{
						if(CheckCharacterItem(chr,"bladebottlew4"))
						{
							TakeItemFromCharacter(chr, "bladebottlew4");
							EquipCharacterByItem(chr, "bladeA11");
							PlaySound("INTERFACE\bottle_molasses.wav");
							chr.quest.rum_molasses = "bladebottle";
						}
					}
					else
					{
						if(CheckCharacterItem(chr,"pistolbottlew4"))
						{
							TakeItemFromCharacter(chr, "pistolbottlew4");
							EquipCharacterByItem(chr, "pistol204");
							PlaySound("INTERFACE\bottle_molasses.wav");
							chr.quest.rum_molasses = "pistolbottle";
						}
					}
					else
					{
						PlaySound("INTERFACE\rum_barrel_empty.wav");

						if(CheckAttribute(chr,"quest.rum_phase") )
						{
							if(chr.quest.rum_phase == "3" || chr.quest.rum_phase == "4")
							{
								//no key sound please
							}
							else PlaySound("INTERFACE\took_item.wav");
						}
					}
				}

				Logit(TranslateString("","Molasses tank"));
				return;
			break;

			case "box4":
				//damper

				if(CheckAttribute(chr,"quest.damper_check") && chr.quest.damper_check == "0")
				{
					chr.quest.dmaper_check = "1";
					//chr.quest.4checks = sti(chr.quest.3checks) + 1;//not used yet
				}

				if(CheckAttribute(chr,"quest.rum_damper") && chr.quest.rum_damper == "closed")
				{
					PlaySound("INTERFACE\damper_change.wav");
					chr.quest.rum_damper = "half_open";
					chr.quest.rum_fire = "unlit";

					Locations[FindLocation(chr.location)].models.always.locators = "tavern02_locators_JRH1";

					LAi_QuestDelay("damper", 0.5);
					return;
				}

				if(CheckAttribute(chr,"quest.rum_damper") && chr.quest.rum_damper == "half_open")
				{
					PlaySound("INTERFACE\damper_change.wav");
					chr.quest.rum_damper = "open";

					if(CheckAttribute(chr,"quest.rum_fire") && chr.quest.rum_fire == "unlit")
					Locations[FindLocation(chr.location)].models.always.locators = "tavern02_locators_JRH2";

					if(CheckAttribute(chr,"quest.rum_fire") && chr.quest.rum_fire == "lit")
					Locations[FindLocation(chr.location)].models.always.locators = "tavern02_locators_JRH2_F";

					LAi_QuestDelay("damper", 0.5);
					return;
				}

				if(CheckAttribute(chr,"quest.rum_damper") && chr.quest.rum_damper == "open")
				{
					PlaySound("INTERFACE\damper_change.wav");
					chr.quest.rum_damper = "half_closed";

					if(CheckAttribute(chr,"quest.rum_fire") && chr.quest.rum_fire == "unlit")
					Locations[FindLocation(chr.location)].models.always.locators = "tavern02_locators_JRH1";

					if(CheckAttribute(chr,"quest.rum_fire") && chr.quest.rum_fire == "lit")
					Locations[FindLocation(chr.location)].models.always.locators = "tavern02_locators_JRH1_F";

					LAi_QuestDelay("damper", 0.5);
					return;
				}

				if(CheckAttribute(chr,"quest.rum_damper") && chr.quest.rum_damper == "half_closed")
				{
					PlaySound("INTERFACE\damper_close.wav");
					chr.quest.rum_damper = "closed";

					Locations[FindLocation(chr.location)].models.always.locators = "tavern02_locators_JRH0";

					LAi_QuestDelay("damper", 0.5);
					return;
				}
			break;

			case "box5":
				//climb to water tank

				PlaySound("OBJECTS\DUEL\man_attack1.wav");
				ChangeCharacterAddressGroup(chr, "wr_gunroom", "reload", "reload1");
				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_study")
	{
		switch(chr.boxname)
		{
			case "box1":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box2":
				//treasure tales
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book36") && chr.quest.wr_book36 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book36") )
					{
						LAi_QuestDelay("book36and27_check", 0.1);
						LAi_QuestDelay("book36_check", 0.1);
					}
				}
				return;
			break;

			case "box3":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box4":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box5":
				if(CheckAttribute(chr,"quest.study_chest") && chr.quest.study_chest == "open")
				{
					//once opened stays open
					LaunchItemsBox(&ar);
					return;
				}
				else
				{
					if(CheckCharacterItem(chr,"key10"))
					{
						PlaySound("INTERFACE\key_unlock.wav");
						chr.quest.study_chest = "open";
						TakeItemFromCharacter(chr, "key10");
						LaunchItemsBox(&ar);
						return;
					}
					else
					{
						PlaySound("INTERFACE\locked_window.wav");
						return;
					}
				}
			break;

			case "box6":
				LaunchItemsBox(&ar);
				return;
			break;

			case "box7":
				//locked counter with 4 levers

				if(CheckCharacterItem(chr,"key17"))
				{
					PlaySound("INTERFACE\key_lock.wav");
					chr.quest.study_counter = "open";
					TakeItemFromCharacter(chr, "key17");

					LAi_QuestDelay("pick_up_pirate_flag", 0.5);
				}
				else
				{
					if(CheckAttribute(chr,"quest.study_counter") && chr.quest.study_counter == "open")
					{
						LaunchItemsBox(&ar);
					}
					else PlaySound("INTERFACE\locked_window.wav");
				}
			break;

			case "box8":
				//lever2 is up or missing (1 from left)
				if(CheckAttribute(chr,"quest.study_lever2") && chr.quest.study_lever2 == "up")
				{
					if(CheckAttribute(chr,"quest.study_lever1") && chr.quest.study_lever1 == "down")
					{
						//wall is gone
						PlaySound("INTERFACE\lever_down.wav");
						chr.quest.study_lever2 = "down";
						Locations[FindLocation("wr_study")].models.always.l2 = "lever2_down";
						Locations[FindLocation("wr_study")].models.always.l5 = "bars_up";
						Locations[FindLocation("wr_study")].locators_radius.box.box8 = 0.0001;
						Locations[FindLocation("wr_study")].locators_radius.box.box12 = 0.5;

						LAi_QuestDelay("study_bars_up", 0.5);
					}
					else
					{
						if(chr.quest.study_lever1 == "up" && chr.quest.study_lever3 == "up" && chr.quest.study_lever4 == "up")
						{
   							PlaySound("INTERFACE\lever_stuck.wav");
							return;
						}
						else
						{
							PlaySound("INTERFACE\step_reset.wav");
							chr.quest.study_position = "8";
							LAi_QuestDelay("study_levers_reset1", 1.0);
							return;
						}
					}
				}

				if(CheckAttribute(chr,"quest.study_lever2") && chr.quest.study_lever2 == "missing")
				{
					if(CheckCharacterItem(chr,"bladelever"))
					{
						if(!IsEquipCharacterByItem(chr, "bladelever"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladelever");
						}

						LAi_LocationFightDisable(&Locations[FindLocation(chr.location)], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("study_place_lever2_A", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_huh.wav");
					}
					return;
				}
			break;

			case "box9":
				//lever3 is up or missing (2 from left)
				if(CheckAttribute(chr,"quest.study_lever3") && chr.quest.study_lever3 == "up")
				{
					if(CheckAttribute(chr,"quest.study_lever1") && chr.quest.study_lever1 == "down")
					{
						//wall is gone
						if(CheckAttribute(chr,"quest.study_lever2") && chr.quest.study_lever2 == "down")
						{
							//bars are up
							PlaySound("INTERFACE\lever_down.wav");
							chr.quest.study_lever3 = "down";
							Locations[FindLocation("wr_study")].models.always.l3 = "lever3_down";
							Locations[FindLocation("wr_study")].models.always.l6 = "girder_free";
							Locations[FindLocation("wr_study")].locators_radius.box.box9 = 0.0001;
							Locations[FindLocation("wr_study")].locators_radius.box.box13 = 0.5;

							LAi_QuestDelay("study_girder_free", 0.5);
						}
						else
						{
							if(chr.quest.study_lever1 == "up" && chr.quest.study_lever2 == "up" && chr.quest.study_lever4 == "up")
							{
								PlaySound("INTERFACE\lever_stuck.wav");
								return;
							}
							else
							{
								PlaySound("INTERFACE\step_reset.wav");
								chr.quest.study_position = "9";

								LAi_QuestDelay("study_levers_reset1", 1.0);
								return;
							}
						}
					}
					else
					{
						if(chr.quest.study_lever1 == "up" && chr.quest.study_lever2 == "up" && chr.quest.study_lever4 == "up")
						{
							PlaySound("INTERFACE\lever_stuck.wav");
							return;
						}
						else
						{
							PlaySound("INTERFACE\step_reset.wav");
							chr.quest.study_position = "9";

							LAi_QuestDelay("study_levers_reset1", 1.0);
							return;
						}
					}
				}

				if(CheckAttribute(chr,"quest.study_lever3") && chr.quest.study_lever3 == "missing")
				{
					if(CheckCharacterItem(chr,"bladelever"))
					{
						if(!IsEquipCharacterByItem(chr, "bladelever"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladelever");
						}

						LAi_LocationFightDisable(&Locations[FindLocation(chr.location)], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("study_place_lever3_A", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_huh.wav");
					}
					return;
				}
			break;

			case "box10":
				//lever1 is up or missing (3 from left)
				if(CheckAttribute(chr,"quest.study_lever1") && chr.quest.study_lever1 == "up")
				{
					PlaySound("INTERFACE\lever_down.wav");
					chr.quest.study_lever1 = "down";
					Locations[FindLocation("wr_study")].models.always.l1 = "lever1_down";
					Locations[FindLocation("wr_study")].locators_radius.box.box10 = 0.0001;
					Locations[FindLocation("wr_study")].locators_radius.box.box14 = 0.5;
					Locations[FindLocation("wr_study")].locators_radius.reload.reload2 = 0.5;	//visible when wall is gone
					Locations[FindLocation(chr.location)].models.always.locators = "sh05_locators_JRH1";

					LAi_QuestDelay("study_wall_free", 0.5);
				}

				if(CheckAttribute(chr,"quest.study_lever1") && chr.quest.study_lever1 == "missing")
				{
					if(CheckCharacterItem(chr,"bladelever"))
					{
						if(!IsEquipCharacterByItem(chr, "bladelever"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladelever");
						}

						LAi_LocationFightDisable(&Locations[FindLocation(chr.location)], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("study_place_lever1_A", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_huh.wav");
					}
					return;
				}
			break;

			case "box11":
				//lever4 is up or missing (4 from left)
				if(CheckAttribute(chr,"quest.study_lever4") && chr.quest.study_lever4 == "up")
				{
					if(CheckAttribute(chr,"quest.study_lever1") && chr.quest.study_lever1 == "down")
					{
						//wall is gone
						if(CheckAttribute(chr,"quest.study_lever2") && chr.quest.study_lever2 == "down")
						{
							//bars are up
							if(CheckAttribute(chr,"quest.study_lever3") && chr.quest.study_lever3 == "down")
							{
								//girder is gone
								PlaySound("INTERFACE\lever_down.wav");
								chr.quest.study_lever4 = "down";
								Locations[FindLocation("wr_study")].models.always.l4 = "lever4_down";
								Locations[FindLocation("wr_study")].locators_radius.box.box11 = 0.0001;
								Locations[FindLocation("wr_study")].locators_radius.box.box15 = 0.5;

								LAi_QuestDelay("study_secret_unlock", 0.5);
							}
							else
							{
								if(chr.quest.study_lever1 == "up" && chr.quest.study_lever2 == "up" && chr.quest.study_lever3 == "up")
								{
									PlaySound("INTERFACE\lever_stuck.wav");
									return;
								}
								else
								{
									PlaySound("INTERFACE\step_reset.wav");
									chr.quest.study_position = "11";

									LAi_QuestDelay("study_levers_reset1", 1.0);
									return;
								}
							}
						}
						else
						{
							if(chr.quest.study_lever1 == "up" && chr.quest.study_lever2 == "up" && chr.quest.study_lever3 == "up")
							{
								PlaySound("INTERFACE\lever_stuck.wav");
								return;
							}
							else
							{
								PlaySound("INTERFACE\step_reset.wav");
								chr.quest.study_position = "11";

								LAi_QuestDelay("study_levers_reset1", 1.0);
								return;
							}
						}
					}
					else
					{
						if(chr.quest.study_lever1 == "up" && chr.quest.study_lever2 == "up" && chr.quest.study_lever3 == "up")
						{
							PlaySound("INTERFACE\lever_stuck.wav");
							return;
						}
						else
						{
							PlaySound("INTERFACE\step_reset.wav");
							chr.quest.study_position = "11";

							LAi_QuestDelay("study_levers_reset1", 1.0);
							return;
						}
					}
				}

				if(CheckAttribute(chr,"quest.study_lever4") && chr.quest.study_lever4 == "missing")
				{
					if(CheckCharacterItem(chr,"bladelever"))
					{
						if(!IsEquipCharacterByItem(chr, "bladelever"))
						{
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE);
							EquipCharacterByItem(chr, "bladelever");
						}

						LAi_LocationFightDisable(&Locations[FindLocation(chr.location)], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("study_place_lever4_A", 1.0);
					}
					else
					{
						PlaySound("VOICE\ENGLISH\blaze_huh.wav");
					}
					return;
				}
			break;

			case "box12":
				//lever2 is down (1 from left)
				PlaySound("INTERFACE\lever_up.wav");
				chr.quest.study_lever2 = "up";
				Locations[FindLocation("wr_study")].models.always.l2 = "lever2_up";
				Locations[FindLocation("wr_study")].models.always.l5 = "bars_down";
				Locations[FindLocation("wr_study")].locators_radius.box.box8 = 0.5;
				Locations[FindLocation("wr_study")].locators_radius.box.box12 = 0.0001;

				LAi_QuestDelay("study_bars_down", 0.5);
			break;

			case "box13":
				//lever3 is down (2 from left)
				PlaySound("INTERFACE\lever_up.wav");
				chr.quest.study_lever3 = "up";
				Locations[FindLocation("wr_study")].models.always.l3 = "lever3_up";
				Locations[FindLocation("wr_study")].models.always.l6 = "girder_block";
				Locations[FindLocation("wr_study")].locators_radius.box.box9 = 0.5;
				Locations[FindLocation("wr_study")].locators_radius.box.box13 = 0.0001;

				LAi_QuestDelay("study_girder_block", 0.5);
			break;

			case "box14":
				//lever1 is down (3 from left)
				PlaySound("INTERFACE\lever_up.wav");
				chr.quest.study_lever1 = "up";
				Locations[FindLocation("wr_study")].models.always.l1 = "lever1_up";
				Locations[FindLocation("wr_study")].locators_radius.box.box10 = 0.5;
				Locations[FindLocation("wr_study")].locators_radius.box.box14 = 0.0001;
				Locations[FindLocation(chr.location)].models.always.locators = "sh05_locators_JRH";

				LAi_QuestDelay("study_wall_block", 0.5);
			break;

			case "box15":
				//lever4 is down (4 from left)
				PlaySound("INTERFACE\lever_up.wav");
				chr.quest.study_lever4 = "up";
				Locations[FindLocation("wr_study")].models.always.l4 = "lever4_up";

				Locations[FindLocation("wr_study")].locators_radius.box.box11 = 0.5;
				Locations[FindLocation("wr_study")].locators_radius.box.box15 = 0.0001;

				LAi_QuestDelay("study_secret_lock", 0.5);
			break;

			case "box16":
				//Rogers corpse

				if(CheckAttribute(chr,"quest.clear_study_boxes") && chr.quest.clear_study_boxes == "yes")
				{
					locations[FindLocation(chr.location)].box16.items.blade1 = 0;
					locations[FindLocation(chr.location)].box16.items.pistol20 = 0;
					locations[FindLocation(chr.location)].box16.items.ammobag1 = 0;
					locations[FindLocation(chr.location)].box16.items.ammobag2 = 0;

					locations[FindLocation(chr.location)].box16.items."bladeA5" = 0;
					locations[FindLocation(chr.location)].box16.items."spyglass3" = 0;
					locations[FindLocation(chr.location)].box16.items.temp_coins = 0;
					locations[FindLocation(chr.location)].box16.items.sewing_kit = 0;
					locations[FindLocation(chr.location)].box16.items.tobacco = 0;
					locations[FindLocation(chr.location)].box16.items.folding_knife = 0;
					locations[FindLocation(chr.location)].box16.items.compass1 = 0;
					locations[FindLocation(chr.location)].box16.items.pistoltinderbox = 0;
					locations[FindLocation(chr.location)].box16.items.key17 = 0;

					locations[FindLocation(chr.location)].box16.items.red_uniform = 0;
					locations[FindLocation(chr.location)].box16.items.sextant = 0;
					locations[FindLocation(chr.location)].box16.items.tin_jug = 0;
					locations[FindLocation(chr.location)].box16.items.tobacco = 0;
					locations[FindLocation(chr.location)].box16.items."pistol9+2" = 0;
					locations[FindLocation(chr.location)].box16.items.silver_bar = 0;
					locations[FindLocation(chr.location)].box16.items.clock1 = 0;
 					locations[FindLocation(chr.location)].box16.items.foreign_items = 0;
					locations[FindLocation(chr.location)].box16.items.drawing_kit = 0;
					locations[FindLocation(chr.location)].box16.items.strange_shells = 0;
					locations[FindLocation(chr.location)].box16.items.package = 0;
					locations[FindLocation(chr.location)].box16.items.temp_purse = 0;

					locations[FindLocation(chr.location)].box16.money = 0;
				}

				LaunchItemsBox(&ar);
				return;
			break;
		}
		return;
	}

	if(Locations[locidx].id=="wr_residence")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box1")
	    	{
			//law
			LaunchItemsBox(&ar);

			if(CheckAttribute(chr,"quest.wr_book21") && chr.quest.wr_book21 == "placed")
			{
				//do nothing book is already placed
			}
			else
			{
				if(CheckCharacterItem(chr,"book21") )
				{
					LAi_QuestDelay("book21and24_check", 0.1);
					LAi_QuestDelay("book21_check", 0.1);
				}
			}
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box3")
	    	{
			//antiques jewels
			LaunchItemsBox(&ar);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
	    	{
			PauseAllSounds();
			PlaySound("INTERFACE\Clock.wav");
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box4")
	    	{
			ChangeCharacterAddressGroup(chr, "wr_residence", "goto", "goto13");
			PlaySound("PEOPLE\Run_wood.wav");
			return;
		}
	}

	if(Locations[locidx].id=="wr_library")
	{
		switch(chr.boxname)
		{
			case "box4":
				//history
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_gunroom") && chr.quest.wr_gunroom == "locked")
				{
					if(CheckCharacterItem(chr,"book24") )
					{
						//double check: before & after box visit
						//it was possible to unlock with wrong book
						LAi_QuestDelay("book24_unlock_check", 0.1);
					}
				}

				if(CheckAttribute(chr,"quest.wr_gunroom") && chr.quest.wr_gunroom == "unlocked")
				{
					LAi_QuestDelay("book24_lock_check", 0.1);
				}
			break;

			case "box2":
				//trade
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book34") && chr.quest.wr_book34 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book34") )
					{
						LAi_QuestDelay("book34_check", 0.1);
					}
				}
			break;

			case "box3":
				//chemistry
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book27") && chr.quest.wr_book27 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book27") )
					{
						LAi_QuestDelay("book27_check", 0.1);
					}
				}
			break;

			case "box5":
				//geo
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book33") && chr.quest.wr_book33 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book33") )
					{
						LAi_QuestDelay("book33_check", 0.1);
					}
				}
			break;

			case "box6":
				//shipbuild
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book23") && chr.quest.wr_book23 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book23") )
					{
						LAi_QuestDelay("book23_check", 0.1);
					}
				}
			break;

			case "box7":
				//sea battles
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book22") && chr.quest.wr_book22 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book22") )
					{
						LAi_QuestDelay("book22and26_check", 0.1);
						LAi_QuestDelay("book22_check", 0.1);
					}
				}

				//tour "sea battles"
				ChangeCharacterAddressGroup(chr, "wr_library", "box", "box14");
				LAi_QuestDelay("tour_library", 0.1);
				return;
			break;

			case "box12":
				//medicine
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book26") && chr.quest.wr_book26 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book26") )
					{
						LAi_QuestDelay("book26_check", 0.1);
					}
				}
			break;

			case "box8":
				//lever is up - gunroom door is hidden
				PlaySound("INTERFACE\lever_down.wav");

				if(CheckAttribute(chr,"quest.wr_library") && chr.quest.wr_library == "medicine")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH13";

				}
				else
				{
					if(CheckAttribute(chr,"quest.wr_library") && chr.quest.wr_library == "mission5")
					{
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH10";
					}
				}
				else
				{
					if(CheckAttribute(chr,"quest.wr_library") && chr.quest.wr_library == "book25")
					{
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH7";
					}
					else
					{
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH4";
					}
				}

				LAi_QuestDelay("gunroom_door_visible", 0.5);
				return;
			break;

			case "box9":
				//lever is down - gunroom door is visible
				PlaySound("INTERFACE\lever_up.wav");

				if(CheckAttribute(chr,"quest.wr_library") && chr.quest.wr_library == "medicine")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH12";

				}
				else
				{
					if(CheckAttribute(chr,"quest.wr_library") && chr.quest.wr_library == "mission5")
					{
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH9";
					}
				}
				else
				{
					if(CheckAttribute(chr,"quest.wr_library") && chr.quest.wr_library == "book25")
					{
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH6";
					}
					else
					{
						Locations[FindLocation(chr.location)].models.always.locators = "Res02_l_JRH3";
					}
				}

				LAi_QuestDelay("gunroom_door_hidden", 0.5);
				return;
			break;

			case "box10":
				//erotica
				LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.wr_book28") && chr.quest.wr_book28 == "placed")
				{
					//do nothing book is already placed
				}
				else
				{
					if(CheckCharacterItem(chr,"book28") )
					{
						LAi_QuestDelay("book28andCorkscrews_check", 0.1);
						LAi_QuestDelay("book28_check", 0.1);
					}
				}

				//tour "erotica"
				ChangeCharacterAddressGroup(chr, "wr_library", "box", "box15");
				LAi_QuestDelay("tour_library", 0.1);
				return;
			break;

			case "box1":
				//poetry
				LaunchItemsBox(&ar);

				if(CheckCharacterItem(chr,"emptysack") )
				{
					LAi_QuestDelay("book30_pickup", 0.1);
				}
				else LAi_QuestDelay("book30_return", 0.1);

				return;
			break;

			case "box14":
				//walk to seabattles or not

				if(CheckAttribute(chr,"quest.seabattles_enable") && chr.quest.seabattles_enable == "yes")
				{
					ChangeCharacterAddressGroup(chr, "wr_library", "goto", "goto19");
					PlaySound("PEOPLE\Run_wood.wav");
				}
				else PlaySound("VOICE\ENGLISH\blaze_hah.wav");

				return;
			break;

			case "box15":
				//walk to erotica or not

				if(CheckAttribute(chr,"quest.erotica_enable") && chr.quest.erotica_enable == "yes")
				{
					ChangeCharacterAddressGroup(chr, "wr_library", "goto", "goto21");
					PlaySound("PEOPLE\Run_wood.wav");
				}
				else PlaySound("VOICE\ENGLISH\blaze_huh.wav");

				return;
			break;

			//default:
			LaunchItemsBox(&ar);
			return;
		}
		return;
	}

	if(Locations[locidx].id=="wr_crew")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
	    	{
			//lever is down - hatch is closed (start) - counter is open
			PlaySound("INTERFACE\lever_up.wav");
			Locations[FindLocation(chr.location)].models.always.locators = "tavern03_locators_JRH2";

			LAi_QuestDelay("crew_hatch_open", 0.5);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box1")
	    	{
			//lever is up - hatch is open - counter is blocked
			PlaySound("INTERFACE\lever_down.wav");
			Locations[FindLocation(chr.location)].models.always.locators = "tavern03_locators_JRH1";

			LAi_QuestDelay("crew_hatch_lock", 0.5);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box3")
	    	{
			PlaySound("INTERFACE\locked_window.wav");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box4")
	    	{
			LaunchItemsBox(&ar);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box5")
	    	{
			ChangeCharacterAddressGroup(chr, "wr_crew", "box", "box6");
			PlaySound("PEOPLE\step_stairway.wav");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box6")
	    	{
			ChangeCharacterAddressGroup(chr, "wr_crew", "box", "box5");
			PlaySound("PEOPLE\step_stairway2.wav");
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box7")
	    	{
			Logit(TranslateString("","There's a chest - but how do I get to it?"));
			PlaySound("INTERFACE\knock.wav");

			if(CheckAttribute(chr,"quest.crew_chest") && chr.quest.crew_chest == "visible")
			{

			}
			else
			{
				chr.quest.crew_chest = "visible";
				AddQuestRecord("Open_the_mine", "2");	//only first time
			}

			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box8")
	    	{
			PlaySound("INTERFACE\knock.wav");
			return;
		}
	}

	if(Locations[locidx].id=="loanshark_cellar")
	{
		LaunchItemsBox(&ar);
		return;
	}

	if(Locations[locidx].id=="wr_shop")
	{
		switch(chr.boxname)
		{
			case "box2":
				Locations[FindLocation("wr_shop")].image = "";
				PlaySound("INTERFACE\lever_down.wav");
				chr.quest.wr_elevator = "down";

				if(CheckAttribute(chr,"quest.medicine_quest") && chr.quest.medicine_quest == "started")
				{
					Locations[FindLocation(chr.location)].models.always.locators = "residence05_locators_JRH_Ldown_mdc";
				}
				else
				{
					if(CheckAttribute(chr,"quest.wr_shoppistol") && chr.quest.wr_shoppistol == "yes")
					{
						Locations[FindLocation(chr.location)].models.always.locators = "residence05_locators_JRH_Ldown";
					}
				}
				else
				{
					Locations[FindLocation(chr.location)].models.always.locators = "residence05_locators_JRH_Ldown_P3";
				}

				LAi_QuestDelay("elevator_lever", 0.5);
				return;
			break;

			case "box3":
				if(CheckAttribute(chr,"quest.shop_elevator") && chr.quest.shop_elevator == "temp_off")
				{
					PlaySound("INTERFACE\lever_stuck.wav");
					Logit(TranslateString("","The lever is not working!!!"));
					return;
				}
				else
				{

					Locations[FindLocation("wr_shop")].image = "";
					PlaySound("INTERFACE\lever_up.wav");
					chr.quest.wr_elevator = "up";

					if(CheckAttribute(chr,"quest.medicine_quest") && chr.quest.medicine_quest == "started")
					{
						Locations[FindLocation(chr.location)].models.always.locators = "residence05_locators_JRH_Lup_mdc";
					}
					else
					{
						if(CheckAttribute(chr,"quest.wr_shoppistol") && chr.quest.wr_shoppistol == "yes")
						{
							Locations[FindLocation(chr.location)].models.always.locators = "residence05_locators_JRH_Lup";
						}
					}
					else
					{
						Locations[FindLocation(chr.location)].models.always.locators = "residence05_locators_JRH_Lup_P3";
					}

					LAi_QuestDelay("elevator_lever", 0.5);
					return;

				}
			break;

			case "box4":
				//double this one! box 4 = the locked one
				if(CheckCharacterItem(chr,"key8"))
				{
					//go inside
					PlaySound("INTERFACE\key_unlock.wav");
					LAi_QuestDelay("shop_closet", 2.0);
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box5":
				PlaySound("AMBIENT\JAIL\door_003.wav");
				LaunchItemsBox(&ar);

				chr.quest.shop_box5_tour1.win_condition.l1 = "locator";
				chr.quest.shop_box5_tour1.win_condition.l1.location = "wr_shop";
				chr.quest.shop_box5_tour1.win_condition.l1.locator_group = "goto";
				chr.quest.shop_box5_tour1.win_condition.l1.locator = "goto11";
				chr.quest.shop_box5_tour1.win_condition = "shop_box5_tour1";

				ChangeCharacterAddressGroup(chr, "wr_shop", "goto", "goto11");
				return;
			break;

			case "box9":
				PlaySound("AMBIENT\JAIL\door_003.wav");
				LaunchItemsBox(&ar);

				chr.quest.shop_box9_tour1.win_condition.l1 = "locator";
				chr.quest.shop_box9_tour1.win_condition.l1.location = "wr_shop";
				chr.quest.shop_box9_tour1.win_condition.l1.locator_group = "goto";
				chr.quest.shop_box9_tour1.win_condition.l1.locator = "goto6";
				chr.quest.shop_box9_tour1.win_condition = "shop_box_run_sound";

				ChangeCharacterAddressGroup(chr, "wr_shop", "goto", "goto6");
				return;
			break;

			case "box8":
				if(CheckAttribute(chr,"quest.wr_shop") && chr.quest.wr_shop == "box8_tour_open")
				{
					PlaySound("AMBIENT\JAIL\door_003.wav");
					LaunchItemsBox(&ar);
					LAi_QuestDelay("shop_box8_tour", 0.1);
					return;
				}
				else
				{
					if(CheckCharacterItem(chr,"key9"))
					{
						chr.quest.wr_shop = "box8_tour_open";
						TakeItemFromCharacter(chr, "key9");
						PlaySound("AMBIENT\JAIL\door_003.wav");
						LaunchItemsBox(&ar);
						LAi_QuestDelay("shop_box8_tour", 0.1);
						return;
					}
					else
					{
						PlaySound("INTERFACE\locked_window.wav");
						return;
					}
				}
			break;

			case "box10":
				PlaySound("AMBIENT\JAIL\door_003.wav");
				LaunchItemsBox(&ar);

				chr.quest.shop_box10_tour1.win_condition.l1 = "locator";
				chr.quest.shop_box10_tour1.win_condition.l1.location = "wr_shop";
				chr.quest.shop_box10_tour1.win_condition.l1.locator_group = "goto";
				chr.quest.shop_box10_tour1.win_condition.l1.locator = "goto9";
				chr.quest.shop_box10_tour1.win_condition = "shop_box_run_sound";

				ChangeCharacterAddressGroup(chr, "wr_shop", "goto", "goto9");
				return;
			break;

			case "box11":
				PlaySound("AMBIENT\JAIL\door_003.wav");
				LaunchItemsBox(&ar);

				chr.quest.shop_box11_tour1.win_condition.l1 = "locator";
				chr.quest.shop_box11_tour1.win_condition.l1.location = "wr_shop";
				chr.quest.shop_box11_tour1.win_condition.l1.locator_group = "goto";
				chr.quest.shop_box11_tour1.win_condition.l1.locator = "goto8";
				chr.quest.shop_box11_tour1.win_condition = "shop_box_run_sound";

				ChangeCharacterAddressGroup(chr, "wr_shop", "goto", "goto8");
				return;
			break;

			case "box12":
				PlaySound("AMBIENT\JAIL\door_003.wav");
				LaunchItemsBox(&ar);

				chr.quest.shop_box12_tour1.win_condition.l1 = "locator";
				chr.quest.shop_box12_tour1.win_condition.l1.location = "wr_shop";
				chr.quest.shop_box12_tour1.win_condition.l1.locator_group = "goto";
				chr.quest.shop_box12_tour1.win_condition.l1.locator = "goto10";
				chr.quest.shop_box12_tour1.win_condition = "shop_box_run_sound";

				ChangeCharacterAddressGroup(chr, "wr_shop", "goto", "goto10");
				LAi_QuestDelay("shop_box12_tour1", 1.0);
				return;
			break;

			case "box13":
				//medicine chest

				Logit(TranslateString("","If I just had something to carry this chest with!"));
				PlaySound("VOICE\ENGLISH\blaze_hah.wav");
				return;
			break;

			//default:
			PlaySound("AMBIENT\JAIL\door_003.wav");
			LaunchItemsBox(&ar);
			return;
		}
		return;
	}

	//so pchar not dies here
	if(Locations[locidx].id=="wr_shop_office")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
	    	{
			if(CheckAttribute(chr,"quest.chest_hint") && chr.quest.chest_hint == "dave")
			{
				LaunchItemsBox(&ar);
				return;
			}
			else
			{
				PlaySound("INTERFACE\locked_window.wav");
		 		return;
			}
		}
	}

	if(Locations[locidx].id=="Dave_Edna_room")
	{
		//elevator
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box1")
		{
			if(CheckAttribute(chr,"quest.wr_elevator") && chr.quest.wr_elevator == "down")
			{
				PlaySound("INTERFACE\elevator_gate.wav");

				LAi_QuestDelay("elevator_up", 0.5);
				return;
			}

			if(CheckAttribute(chr,"quest.wr_elevator") && chr.quest.wr_elevator == "up")
			{
				PlaySound("INTERFACE\locked_window.wav");
				return;
			}
		}

		//violin box
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
	    	{
			if(CheckAttribute(chr,"quest.med_Dave") && chr.quest.med_Dave == "violin_bought")
			{
				PlaySound("AMBIENT\JAIL\door_003.wav");
				LaunchItemsBox(&ar);
				return;
			}
			else
			{
				PlaySound("INTERFACE\locked_window.wav");
		 		return;
			}
		}

		//locked door
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box3")
	    	{
			PlaySound("INTERFACE\key_unlock.wav");

			LAi_QuestDelay("unlock_daves_room", 2.0);
			return;
		}
	}

	if(Locations[locidx].id=="wr_mother")
	{
		switch(chr.boxname)
		{
			case "box1":
				if(CheckAttribute(chr,"quest.wr_elevator") && chr.quest.wr_elevator == "up")
				{
					PlaySound("INTERFACE\elevator_gate.wav");
					LAi_QuestDelay("elevator_down", 0.5);
					return;
				}

				if(CheckAttribute(chr,"quest.wr_elevator") && chr.quest.wr_elevator == "down")
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box2":
				if(CheckAttribute(chr,"quest.medicine_quest") && chr.quest.medicine_quest == "started")
				{
					PlaySound("AMBIENT\JAIL\door_003.wav");
					LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box3":
				if(CheckAttribute(chr,"quest.medicine_quest") && chr.quest.medicine_quest == "started")
				{
					PlaySound("AMBIENT\JAIL\door_003.wav");
					LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box4":
				if(CheckAttribute(chr,"quest.medicine_quest") && chr.quest.medicine_quest == "started")
				{
					PlaySound("AMBIENT\JAIL\door_003.wav");
					LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;

			case "box5":
				if(CheckAttribute(chr,"quest.medicine_quest") && chr.quest.medicine_quest == "started")
				{
					PlaySound("AMBIENT\JAIL\door_003.wav");
					LaunchItemsBox(&ar);
					return;
				}
				else
				{
					PlaySound("INTERFACE\locked_window.wav");
					return;
				}
			break;
		}
	}

	if(Locations[locidx].id=="wr_gunpowder")
	{
		LaunchItemsBox(&ar);
		return;
	}

	if(Locations[locidx].id=="wr_armory")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box1")
		{
			PlaySound("AMBIENT\JAIL\door_003.wav");
			LaunchItemsBox(&ar);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
		{
			if(CheckAttribute(chr,"quest.wr_armorybox") && chr.quest.wr_armorybox == "open")
			{
				PlaySound("AMBIENT\JAIL\door_003.wav");
				LaunchItemsBox(&ar);
				return;
			}
			else
			{
				Logit(TranslateString("","The chest is blocked by a lot of goods."));
				PlaySound("VOICE\ENGLISH\blaze_hah.wav");
				return;
			}
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box3")
		{
			switch(chr.quest.wr_quest1)
			{
				case "pistol2":
					Logit(TranslateString("","Not a chance!"));
					PlaySound("OBJECTS\DUEL\man_attack1.wav");

					LAi_QuestDelay("armory_intro2", 0.1);
				break;

				case "blade_found":
					chr.quest.wr_quest1 = "blade_used2";
					LAi_LocationFightDisable(&Locations[FindLocation(chr.location)], false);
					LAi_SetFightMode(chr, true);

					LAi_QuestDelay("blade_on_armory_box", 1.0);
				break;

				case "blade_used2":
					LAi_QuestDelay("armory_balls", 0.1);
					PlaySound("AMBIENT\JAIL\door_003.wav");
					LaunchItemsBox(&ar);
				break;
			}
			return;
		}
	}

	if(Locations[locidx].id=="wr_kitchen")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box1" || chr.boxname == "box2" || chr.boxname == "box3")
	    	{
			PlaySound("AMBIENT\JAIL\door_003.wav");
			LaunchItemsBox(&ar);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box4")
	    	{
			//R1: lever is down - door is open
			PlaySound("INTERFACE\lever_up.wav");
			Locations[FindLocation(chr.location)].models.always.locators = "FlamHouse_locators_JRH2";

			LAi_QuestDelay("kitchen_R1_lock", 0.5);
			return;
		}

		if(CheckAttribute(chr,"boxname") && chr.boxname == "box5")
	    	{
			if(CheckAttribute(chr,"quest.wr_kitchendoor") && chr.quest.wr_kitchendoor == "stuck")
			{
				PlaySound("INTERFACE\lever_stuck.wav");
				Logit(TranslateString("","The lever is not working!!!"));

				LAi_QuestDelay("kitchen_lever_stuck", 1.0);
				return;
			}
			else
			{
				//R1: lever is up - door is locked (start)
				PlaySound("INTERFACE\lever_down.wav");
				Locations[FindLocation(chr.location)].models.always.locators = "FlamHouse_locators_JRH1";

				LAi_QuestDelay("kitchen_R1_unlock", 0.5);
				return;
			}
		}
	}

	if(Locations[locidx].id=="QC_store_JRH")
	{
		switch(chr.boxname)
		{
			case "box1":
				PlaySound("PEOPLE\counter_openclose.wav");
				ChangeCharacterAddressGroup(chr, "QC_store_JRH", "box", "box2");
			break;

			case "box2":
				PlaySound("PEOPLE\counter_openclose.wav");
				ChangeCharacterAddressGroup(chr, "QC_store_JRH", "box", "box1");
			break;
		}
		return;
	}

	//so pchar not dies here
	if(Locations[locidx].id=="QC_store_bedroom")
	{
		if(CheckAttribute(chr,"boxname") && chr.boxname == "box2")
	    	{
			LaunchItemsBox(&ar);
			return;
		}
	}

	if(Locations[locidx].id=="QC_shipyard2_JRH")
	{
		switch(chr.boxname)
		{
			case "box1":
				//F
				//Log_SetStringToLog("Box1");

				PlaySound("INTERFACE\closet_Open.wav");
		 		LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.shya_heavytool") && chr.quest.shya_heavytool == "taken")
				{

				}
				else LAi_QuestDelay("shya_take_heavytool", 0.1);
			break;

			case "box2":
				//AB lower chest
				//Log_SetStringToLog("Box2");

				if(CheckAttribute(chr,"quest.shya_box2") && chr.quest.shya_box2 == "open")
				{
					PlaySound("AMBIENT\JAIL\jail_door2.wav");
					LaunchItemsBox(&ar);

					if(CheckAttribute(chr,"quest.shya_drill") && chr.quest.shya_drill == "done")
					{
						//dont repeat take drill check
					}
					else LAi_QuestDelay("shya_take_drill", 0.1);
				}
				else
				{
					if(CheckAttribute(chr,"quest.shya_box2") && chr.quest.shya_box2 == "unlocked_but_stuck")
					{
						if(IsEquipCharacterByItem(chr, "tool3"))
						{
							LAi_LocationFightDisable(&Locations[chr.location], false);
							LAi_SetFightMode(chr, true);

							LAi_QuestDelay("shya_use_hammer", 1.0);
						}
						else
						{
							Logit(TranslateString("","It's unlocked but somehow the mechanism is jammed."));

							PlaySound("AMBIENT\JAIL\jail_door1.wav");
						}
					}
					else
					{
						if(CheckCharacterItem(chr,"key2"))
						{
							PlaySound("INTERFACE\key_unlock2.wav");
							chr.quest.shya_box2 = "unlocked_but_stuck";
							TakeItemFromCharacter(chr, "key2");
						}
						else
						{
							PlaySound("INTERFACE\locked_window.wav");
						}
					}
				}
			break;

			case "box3":
				//E chest function
				//Log_SetStringToLog("Box3");

				if(CheckAttribute(chr,"quest.shya_posE"))
				{
					if(chr.quest.shya_posE == "chest")
					{
						if(CheckAttribute(chr,"quest.shya_box3") && chr.quest.shya_box3 == "free_key")
						{
							PlaySound("INTERFACE\key_lock.wav");
							chr.quest.shya_box3 = "locked";
							GiveItem2Character(chr, "key4");

							LAi_QuestDelay("shya_delayed_ping", 1.0);
						}
						else
						{
							if(CheckAttribute(chr,"quest.shya_box3") && chr.quest.shya_box3 == "open")
							{
								PlaySound("INTERFACE\closet_Open.wav");
								chr.quest.shya_box3 = "free_key";
								LaunchItemsBox(&ar);
							}
						}
						else
						{
							//this is "locked" mode but don't check for this
							if(CheckCharacterItem(chr,"key4"))
							{
								PlaySound("INTERFACE\key_unlock2.wav");
								chr.quest.shya_box3 = "open";
								TakeItemFromCharacter(chr, "key4");
							}
							else
							{
								Logit(TranslateString("","It's an ordinary lock here."));
								PlaySound("INTERFACE\locked_window.wav");

							}
						}
					}
				}
			break;

			case "box4":
				//C drilling
				//Log_SetStringToLog("Box4");

				LAi_LocationFightDisable(&Locations[chr.location], false);
				LAi_SetFightMode(chr, true);

				chr.quest.shya_posC = "invisible";
				chr.quest.shya_drill = "done";
				ChangeCharacterAddressGroup(chr, "QC_shipyard2_JRH", "goto", "goto9");

				LAi_QuestDelay("shya_use_drill", 1.0);
				LAi_QuestDelay("shya_radius_check", 0.1);
			break;

			case "box5":
				//AB upper chest
				//Log_SetStringToLog("Box5");

				if(CheckAttribute(chr,"quest.shya_box5") && chr.quest.shya_box5 == "open")
				{
						PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 				LaunchItemsBox(&ar);

						LAi_QuestDelay("shya_take_blade4_box5", 0.1);
						LAi_QuestDelay("shya_take_key4_box5", 0.1);
						LAi_QuestDelay("shya_take_tar_box5", 1.0);
						LAi_QuestDelay("empty_carpenter_chest", 0.1);
				}
				else
				{
					if(CheckCharacterItem(chr,"key1"))
					{
						PlaySound("INTERFACE\key_unlock2.wav");
						TakeItemFromCharacter(chr, "key1");
						chr.quest.shya_box5 = "open";
					}
					else
					{
						PlaySound("INTERFACE\locked_window.wav");
					}
				}
			break;

			case "box6":
				//D basket chest
				//Log_SetStringToLog("Box6");

				if(CheckAttribute(chr,"quest.shya_box6") && chr.quest.shya_box6 == "open")
				{
					//already open
					PlaySound("PEOPLE\basket.wav");
		 			LaunchItemsBox(&ar);

					if(CheckAttribute(chr,"quest.shya_hammer") && chr.quest.shya_hammer == "taken")
					{

					}
					else LAi_QuestDelay("shya_take_hammer", 0.1);
				}
				else
				{
					if(IsEquipCharacterByItem(chr, "blade4"))
					{
						LAi_LocationFightDisable(&Locations[chr.location], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("shya_use_cutlass", 1.0);
					}
					else
					{
						PlaySound("OBJECTS\DUEL\man_attack1.wav");
						Logit(TranslateString("","No lock but it's stuck, maybe I can pry it open with any sharp and strong item."));
					}
				}
			break;

			case "box7":
				//Log_SetStringToLog("Box7");
				//only mast blocking drawer

				if(CheckAttribute(chr,"quest.shya_posJ") && chr.quest.shya_posJ == "blocked")
				{
					if(IsEquipCharacterByItem(chr, "tool2"))
					{
						LAi_LocationFightDisable(&Locations[chr.location], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("shya_use_axe", 1.0);
					}
					else
					{
						Logit(TranslateString("","Have to be careful - that beam rests only on a small piece of wood."));
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
					}
				}
			break;

			case "box8":
				//bookshelf
				//Log_SetStringToLog("Box8");

				PlaySound("INTERFACE\closet_Open.wav");
		 		LaunchItemsBox(&ar);
			break;

			case "box9":
				//P commode: push beam
				//Log_SetStringToLog("Box9");

				if(CheckAttribute(chr,"quest.shya_beam"))
				{
					if(chr.quest.shya_beam == "middle")
					{
						//push?
						if(CheckAttribute(chr,"quest.shya_barrel2") && chr.quest.shya_barrel2 == "taken")
						{
							Locations[FindLocation(chr.location)].models.always.l1 = "BeamL";
							PlaySound("OBJECTS\DUEL\man_attack1.wav");

							LAi_QuestDelay("push_MtoL", 0.5);
						}
						else
						{
							Logit(TranslateString("","If I only could push this beam a little."));
							PlaySound("VOICE\ENGLISH\blaze_hah.wav");
						}
					}
				}
			break;

			case "box10":
				//H push beam
				//Log_SetStringToLog("Box10");

				Locations[FindLocation(chr.location)].models.always.l1 = "BeamR";
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_QuestDelay("push_MtoR", 0.5);
			break;

			case "box11":
				//AB push beam
				//Log_SetStringToLog("Box11");

				if(CheckAttribute(chr,"quest.shya_barrel1") && chr.quest.shya_barrel1 == "taken")
				{
					Locations[FindLocation(chr.location)].models.always.l1 = "BeamM";
					PlaySound("OBJECTS\DUEL\man_attack1.wav");

					LAi_QuestDelay("push_RtoM", 0.5);
				}
				else
				{
					Logit(TranslateString("","If I only could push this beam a little."));
					PlaySound("VOICE\ENGLISH\blaze_hah.wav");
				}
			break;

			case "box12":
				//G large lock
				//Log_SetStringToLog("Box12");

				if(CheckAttribute(chr,"quest.shya_box12") && chr.quest.shya_box12 == "unlocked")
				{
					//this can only occur if NOT the other lock is unlocked
					PlaySound("INTERFACE\locked_window.wav");
					Logit(TranslateString("","Hmm, the other lock is not opened yet"));
				}
				else
				{
					if(CheckCharacterItem(chr,"key3"))
					{
						PlaySound("INTERFACE\key_unlock2.wav");
						TakeItemFromCharacter(chr, "key3");
						chr.quest.shya_box12 = "unlocked";

						//check if other lock also is unlocked, direct here
						if(CheckAttribute(chr,"quest.shya_box14") && chr.quest.shya_box14 == "unlocked")
						{
							//we go now to box17 for LaunchItemsBox
							chr.quest.shya_posC = "open";

							LAi_QuestDelay("shya_radius_check", 0.1);
						}
					}
					else
					{
						Logit(TranslateString("","It's a large lock to the left."));
						PlaySound("INTERFACE\locked_window.wav");
					}
				}

			break;

			case "box13":
				//G push beam
				//Log_SetStringToLog("Box13");

				Locations[FindLocation(chr.location)].models.always.l1 = "BeamM";
				PlaySound("OBJECTS\DUEL\man_attack1.wav");

				LAi_QuestDelay("push_LtoM", 0.5);
			break;

			case "box14":
				//Log_SetStringToLog("Box14");

				if(CheckAttribute(chr,"quest.shya_box14") && chr.quest.shya_box14 == "free_key")
				{
					PlaySound("INTERFACE\key_lock.wav");
					chr.quest.shya_box14 = "locked";
					GiveItem2Character(chr, "key4");

					LAi_QuestDelay("shya_delayed_ping", 1.0);
				}
				else
				{
					if(CheckAttribute(chr,"quest.shya_box14") && chr.quest.shya_box14 == "unlocked")
					{
						//this can only occur if NOT the other lock is unlocked
						PlaySound("INTERFACE\locked_window.wav");
						chr.quest.shya_box14 = "free_key";
						Logit(TranslateString("","Hmm, the other lock is not opened yet"));
					}
				}
				else
				{
					//this is "locked" mode but don't check for this
					if(CheckCharacterItem(chr,"key4"))
					{
						PlaySound("INTERFACE\key_unlock2.wav");
						chr.quest.shya_box14 = "unlocked";
						TakeItemFromCharacter(chr, "key4");


						//check if other lock also is unlocked, direct here
						if(CheckAttribute(chr,"quest.shya_box12") && chr.quest.shya_box12 == "unlocked")
						{
							//we go now to box17 for LaunchItemsBox
							chr.quest.shya_posC = "open";

							LAi_QuestDelay("shya_radius_check", 0.1);
						}
					}
					else
					{
						Logit(TranslateString("","It's an ordinary lock to the right."));
						PlaySound("INTERFACE\locked_window.wav");

					}
				}
			break;

	  		case "box15":
				//K at door

				if(CheckAttribute(chr,"quest.shya_posK") && chr.quest.shya_posK == "locked")
				{
					if(IsEquipCharacterByItem(chr, "tool1"))
					{
						LAi_LocationFightDisable(&Locations[chr.location], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("shya_use_compasses", 1.0);
					}
					else
					{
						Logit(TranslateString("","This 'lock' is so simple that I could pick it with a fork!"));
						PlaySound("VOICE\ENGLISH\blaze_hah.wav");
					}
				}

				if(CheckAttribute(chr,"quest.shya_posK") && chr.quest.shya_posK == "blocked")
				{
					if(IsEquipCharacterByItem(chr, "tool5"))
					{
						LAi_LocationFightDisable(&Locations[chr.location], false);
						LAi_SetFightMode(chr, true);

						LAi_QuestDelay("shya_use_saw", 1.0);
					}
					else
					{
						Logit(TranslateString("","Not a chance!"));
						PlaySound("OBJECTS\DUEL\man_attack1.wav");
					}
				}
			break;

			case "box16":
				//Log_SetStringToLog("Box16");
				//only drawer behind mast

				if(CheckAttribute(chr,"quest.shya_posJ") && chr.quest.shya_posJ == "chest")
				{
					PlaySound("INTERFACE\closet_Open.wav");
					LaunchItemsBox(&ar);

					if(CheckAttribute(chr,"quest.shya_compasses") && chr.quest.shya_compasses == "taken")
					{

					}
					else LAi_QuestDelay("shya_take_compasses", 0.1);
				}
			break;

			case "box17":
				//C open chest
				//Log_SetStringToLog("Box17");

				PlaySound("AMBIENT\JAIL\jail_door2.wav");
		 		LaunchItemsBox(&ar);

				if(CheckAttribute(chr,"quest.shya_axe") && chr.quest.shya_axe == "taken")
				{

				}
				else LAi_QuestDelay("shya_take_axe", 0.1);
			break;

			case "box18":
				//P commode: chest function
				//Log_SetStringToLog("Box9");

				if(CheckAttribute(chr,"quest.shya_beam"))
				{
					if(chr.quest.shya_beam == "left")
					{
						//open?
						if(CheckAttribute(chr,"quest.shya_box9") && chr.quest.shya_box9 == "open")
						{
							//already open
							PlaySound("INTERFACE\closet_Open.wav");
		 					LaunchItemsBox(&ar);

							if(CheckAttribute(chr,"quest.shya_saw") && chr.quest.shya_saw == "taken")
							{
								//wake up Caroline only once
							}
							else LAi_QuestDelay("shya_take_saw", 0.1);
						}
						else
						{
							if(IsEquipCharacterByItem(chr, "blade5"))
							{
								LAi_LocationFightDisable(&Locations[chr.location], false);
								LAi_SetFightMode(chr, true);

								LAi_QuestDelay("shya_use_dagger", 1.0);
							}
							else
							{
								Logit(TranslateString("","No lock - and no handle either, how do I open it?"));
								PlaySound("VOICE\ENGLISH\blaze_huh.wav");
							}
						}
					}
				}
			break;

			case "box19":
				//E blocking beam
				//Log_SetStringToLog("Box19");

				if(CheckAttribute(chr,"quest.shya_posE"))
				{
					if(chr.quest.shya_posE == "blocked")
					{
						if(IsEquipCharacterByItem(chr, "tool6"))
						{
							LAi_LocationFightDisable(&Locations[chr.location], false);
							LAi_SetFightMode(chr, true);

							ChangeCharacterAddressGroup(chr, "QC_shipyard2_JRH", "goto", "lever");

							LAi_QuestDelay("shya_use_lever", 1.0);
						}
						else
						{
							Logit(TranslateString("","This beam is too heavy, I must find something to use as a lever."));
							PlaySound("OBJECTS\DUEL\man_attack1.wav");
						}
					}
				}
			break;
		}
		return;
	}
    // <-- JRH

		float x, y, z;
		string lctr;
		ref corpse;
		GetCharacterPos(chr, &x, &y, &z);

		// PB: Treasure Quests -->
		if(chr.boxname == "treasure_box" && GetAttribute(chr, "required_item") != "-1")
		{
			if(CheckCharacterEquipByGroup(chr,BLADE_ITEM_TYPE) == chr.required_item)
			{
				if(!CheckAttribute(chr, "digging"))	chr.digging = 6-rand(sti(chr.skill.sneak)/2);
				else								chr.digging = sti(chr.digging)-1;

				if(sti(chr.digging) < 1)
				{
					LogIt(TranslateString("","You dig up a treasurechest"));
					PlaySound("AMBIENT\JAIL\jail_door2.wav");
					CloseQuestHeader("treasure");	// close the entry

					DeleteLocatorGlobal(chr.location, "box", "treasure_box");
					if(CheckAttribute(chr,"boxname")) { DeleteAttribute(chr,"boxname"); }
					Log_SetActiveAction("Nothing");
					BLI_RefreshCommandMenu();

					DeleteAttribute(chr, "required_item");
					DeleteAttribute(chr, "digging"));
					DeleteAttribute(chr, "treasureloc");

					LaunchItemsBox(&ar);
				}
				else
				{
					switch(GetAttribute(chr, "required_item"))
					{
						case "Minerspick":
							PlaySound("people\blade_kling.wav");
							LAi_tmpl_ani_PlayAnimation(chr, "attack_7", 1.0);
							CreateParticleSystemX("cannon_embers",x,y,z, 0.0, 0.0, 0.0, 0);
							break;
						case "Minersspade":
							PlaySound("people\step_sand.wav");
							LAi_tmpl_ani_PlayAnimation(chr, "Ground_look_around", 1.0);
							CreateParticleSystemX("blast_dirt",x,y,z, 0.0, 0.0, 0.0, 0);
							break;
					}

					if (AUTO_SKILL_SYSTEM) {
						AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
					} else {
						AddCharacterExp(chr, 50+Rand(100));
					}
					Logit(TranslateString("","You must dig DEEPER !"));
				}
			}
			else
			{
				switch(GetAttribute(chr, "required_item"))
				{
					case "Minerspick":
						LogIt(TranslateString("","How am I going to pry this loose? I think a pickaxe should do the trick!"));
						break;
					case "Minersspade":
						LogIt(TranslateString("","What am I going to dig with? My HANDS? I need a spade!"));
						break;
				}
			}
			return;
		}
		// PB: Treasure Quests <--

//-----------------------------------------------------------------------------------------------------------
		// ccc Nov05 Greater Oxbay
		if(Locations[locidx].id=="Greenford_M_crypt") // PB
		{
			if(CheckCharacterEquipByGroup(chr,BLADE_ITEM_TYPE) == "Minersspade")
			{
				PlaySound("people\step_sand.wav");
				LAi_tmpl_ani_PlayAnimation(chr, "Ground_look_around", 1.0);
				CreateParticleSystemX("blast_dirt",x,y,z, 0.0, 0.0, 0.0, 0); // PB: Eye Candy
				//LAi_Fade("", "");

				switch(Rand(25))
				{
					case 1:
						PlaySound("INTERFACE\took_item.wav");
						Logit(TranslateString("","Among THIS handful of earth you find a piece of mineral"));
						Logit(TranslateString("","You must dig DEEPER !"));
						GiveItem2Character(chr, "mineral"+ makeint(1 + rand(2)) );
					break;

					case 2:
						PlaySound("INTERFACE\took_item.wav");
						Logit(TranslateString("","On THIS shovelload blinks a jewel.."));
						Logit(TranslateString("","You must dig DEEPER !"));
						GiveItem2Character(chr, "jewelry"+ makeint(1 + rand(13)) );
					break;

					case 3:
						PlaySound("INTERFACE\took_item.wav");
						Logit(TranslateString("","The sword of a buried abbot"));
						Logit(TranslateString("","You must dig DEEPER !"));
						GiveItem2Character(chr, "blade25");
					break;

					case 4:
						PlaySound("INTERFACE\took_item.wav");
						Logit(TranslateString("","An artefact from the temple that once stood here"));
						Logit(TranslateString("","You must dig DEEPER !"));
						GiveItem2Character(chr, "indian"+ makeint(1 + rand(9)) );
					break;

					case 5:
						if (AUTO_SKILL_SYSTEM) {
							AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
						} else {
							AddCharacterExp(chr, 50+Rand(100));
						}
						Logit(TranslateString("","You plunge into the remains of a halfdecayed plaguevictim.."));
						// TODO: use effective value for defence?
						// or even summonSkillFromName???
						chr.chr_ai.poison = 30+rand(50-sti(chr.skill.Sneak)-sti(chr.skill.defence) );
						PlayStereoSound("ambient\tavern\man5.wav");
						PlaySound("OBJECTS\DUEL\sword_inbody1.wav");

						corpse = LAi_CreateFantomCharacterEx(false, 0, true, false, 0.0, "skel1", "man", "", "");
						LAi_SetImmortal(corpse, true);
						corpse.name = XI_ConvertString("The late");
						corpse.corpse = true;
						LAi_SetStunnedTypeNoGroup(corpse);
						LAi_group_MoveCharacter(corpse, LAI_GROUP_CORPSES);
						LAI_group_SetRelationWithAllStock(LAI_GROUP_CORPSES, LAI_GROUP_NEITRAL);
						TeleportCharacterToPos(corpse, x,y,z);
						corpse.dialog.filename = "corpse_dialog.c";
					break;

					case 6:
						if (AUTO_SKILL_SYSTEM) {
							AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
						} else {
							AddCharacterExp(chr, 50+Rand(100));
						}
						Logit(TranslateString("","Someone's buried here.. but he aint dead!!"));
						CreateParticleSystemX("ball_splash",x+1,y,z, 0.0, 0.0, 0.0, 0);
						PlayStereoSound("ambient\tavern\man5.wav");
						corpse = LAi_CreateFantomCharacterEx(false, 0, false, false, 0.0, "skel3", "man", "", "");
						GiveItem2Character(corpse, "blade5");
						EquipCharacterByItem(corpse, "blade5");
						LAi_SetCitizenType(corpse);
						LAi_group_MoveCharacter(corpse, "Ambush");
						LAi_group_SetRelation("Ambush", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY);
						LAi_group_SetRelation("Ambush", LAI_GROUP_MONSTERS, LAI_GROUP_ENEMY); // so he fights ghosts
						TeleportCharacterToPos(corpse, x+1,y,z);
						LAi_SetHP(corpse, LAi_GetCharacterHP(chr)*3,  LAi_GetCharacterHP(chr)*3);
						LAi_SetImmortal(corpse, true);
					break;

					case 7:
						if (AUTO_SKILL_SYSTEM) {
							AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
						} else {
							AddCharacterExp(chr, 50+Rand(100));
						}
						Logit(TranslateString("","A file of LIVING Maltese knights comes to exorcise their crypt"));
						Logit(TranslateString("","You might be exorcised as well.."));
						Ambush("maltese", 6, "enemy", "enemy","");
					break;

					case 8:
						if (AUTO_SKILL_SYSTEM) {
							AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
						} else {
							AddCharacterExp(chr, 50+Rand(100));
						}
						Logit(TranslateString("","The grandmaster himself checks his treasure.."));
						PlayStereoSound("VOICE\"+LanguageGetLanguage()+"\Eng_m_a_078.wav");
						corpse = LAi_CreateFantomCharacterEx(false, 3, true, false, 0.0, "priest", "man", "", "");
						GiveItem2Character(corpse, "blade25");
						EquipCharacterByItem(corpse, "blade25");
						LAi_SetCitizenType(corpse);
						LAi_group_MoveCharacter(corpse, "Ambush");
						LAi_group_SetRelation("Ambush", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY);
						LAi_group_SetRelation("Ambush", LAI_GROUP_MONSTERS, LAI_GROUP_ENEMY); // so he fights ghosts
						TeleportCharacterToPos(corpse, x+4,y,z+4);
						LAi_SetHP(corpse, LAi_GetCharacterHP(chr)*4,  LAi_GetCharacterHP(chr)*4);
						LAi_SetImmortal(corpse, false);
					break;

					case 9:
						if (AUTO_SKILL_SYSTEM) {
							AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
						} else {
							AddCharacterExp(chr, 50+Rand(100));
						}
						if(chr.equip.blade != "bladeX4") {
							PlaySound("OBJECTS\duel\sword_slide3.wav");
							Logit(TranslateString("","Your blade hits a stone and breaks.."));
							TakeItemFromCharacter(chr, BLADE_ITEM_TYPE );
							RemoveCharacterEquip(chr, BLADE_ITEM_TYPE );
							EquipCharacterByItem(chr, "bladeX4");
						} else {
							Logit(TranslateString("","You must dig DEEPER !"));
						}
					break;

					case 10:
						Logit(TranslateString("","You dig up a treasurechest"));
						PlaySound("AMBIENT\JAIL\jail_door2.wav");
						LaunchItemsBox(&ar);
					break;

					case 11:
						Logit(TranslateString("","You dig up a treasurechest"));
						PlaySound("AMBIENT\JAIL\jail_door2.wav");
						LaunchItemsBox(&ar);
					break;

					case 12:
						Logit(TranslateString("","You dig up a treasurechest"));
						PlaySound("AMBIENT\JAIL\jail_door2.wav");
						LaunchItemsBox(&ar);
					break;

					case 13:
						if (AUTO_SKILL_SYSTEM) {
							AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
						} else {
							AddCharacterExp(chr, 50+Rand(100));
						}
						Logit(TranslateString("","An  Akkelani witchdoctor. Mummified.. but spitting VENOM !"));
						CreateParticleSystemX("ball_splash",x+1,y,z, 0.0, 0.0, 0.0, 0);
						PlayStereoSound("ambient\inca temple\quickpatters.wav");
						corpse = LAi_CreateFantomCharacterEx(false, 3, true, false, 0.0, "mummy", "man", "", "");
						GiveItem2Character(corpse, "bladeX1");
						EquipCharacterByItem(corpse, "bladeX1");
						GiveItem2Character(corpse, "pistolpdart");
						EquipCharacterByItem(corpse, "pistolpdart");
						GiveItem2Character(corpse, "indian"+ makeint(1 + rand(9)) );
						LAi_SetCitizenType(corpse);
						LAi_group_MoveCharacter(corpse, "Ambush");
						LAi_group_SetRelation("Ambush", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY);
						LAi_group_SetRelation("Ambush", LAI_GROUP_MONSTERS, LAI_GROUP_ENEMY); // so he fights ghosts
						TeleportCharacterToPos(corpse, x+1,y,z);
						LAi_SetHP(corpse, LAi_GetCharacterHP(chr)*2,  LAi_GetCharacterHP(chr)*2);
						LAi_SetImmortal(corpse, false);
					break;

					if (AUTO_SKILL_SYSTEM) {
						AddCharacterExpChar(chr, "Sneak", 50+Rand(100));
					} else {
						AddCharacterExp(chr, 50+Rand(100));
					}
					Logit(TranslateString("","You must dig DEEPER !"));
				}
			}
			else
				LogIt(TranslateString("","What am I going to dig with? My HANDS? I need a spade!"));
			return;
		}

		//ccc boobytrap->
		if(Locations[locidx].type == "house" || Locations[locidx].type == "military")	// ccc Greater Oxbay
		// NK -->
		{
			for(int i = 0; i < 32; i++)
			{
				if(!CheckAttribute(&Characters[LOC_FANTOM_CHARACTERS + i], "id")) continue; //if no ID continue
				if(Characters[LOC_FANTOM_CHARACTERS + i].location == Locations[locidx].id) //if loc is correct
				{
					if(!LAi_IsDead(&Characters[LOC_FANTOM_CHARACTERS + i])) //if not dead
					{ LAi_group_SetRelation(LAI_DEFAULT_GROUP, LAI_GROUP_PLAYER, LAI_GROUP_ENEMY);
					LAi_group_SetRelation(LAI_GROUP_GUARDS, LAI_GROUP_PLAYER, LAI_GROUP_ENEMY);	// ccc Greater Oxbay
					LAi_group_SetRelation(GetCurrentCitizenGroup(), LAI_GROUP_PLAYER, LAI_GROUP_ENEMY); // ccc Dec 05 alerts houseowners
					break; } //only THEN set them hostile
				}
			}
		}
		// NK <--

		// PB: Rewritten -->
		//int lock; //JRH: moved up
		bool OpenLock = false;

		if (ownDeckStarted()) OpenLock = true; // KK
		// If you are on your own ship, all locks are open

		if(REMEMBER_OPEN && CheckAttribute(Locations[locidx],"openboxes."+atrName)) OpenLock = true;
		// If the lock has already been opened, it will stay open

		if(CheckAttribute(Locations[locidx],"jammed."+atrName))
		// If the lock is jammed, it will not open
		{
			Log_SetStringToLog(TranslateString("","This lock will not open. There seems to be a lockpick stuck in it."));
			return;
		}

		if(!OpenLock)
		// If the lock is not yet open, try to open the lock
		{
			lock = rand(100) + 3 * makeint(chr.skill.sneak) + LOCK_OPEN;
			// Chance to open the lock
			if(CheckCharacterEquipByGroup(chr, LOCKPICK_ITEM_TYPE) != "") lock = 2 * lock;
			// Having a lockpick doubles your chance of opening a lock

			if(lock + NO_MINES < 20 && !CheckAttribute(Locations[locidx],"trapboxes."+atrName))
			// Boobytrap: If the boobytrap already exploded, don't explode again
			{
				Log_SetStringToLog(TranslateString("","Boobytrapped") + "!");
				Explosion (chr, rand(20));
				if(ONE_TRAP) Locations[locidx].trapboxes.(atrName) = true;
				return;
			}
			if(lock < 33 && CheckCharacterEquipByGroup(chr, LOCKPICK_ITEM_TYPE) == "")
			// Hurt yourself: You never hurt yourself if you have a lockpick
			{
				if(chr.sex == "woman") PlaySound("OBJECTS\VOICES\DEAD\female\dead_wom4.wav");
				else PlaySound("OBJECTS\VOICES\DEAD\male\dead6.wav");
				Log_SetStringToLog(TranslateString("","Your prying knife slips from the lock... into your hand!"));

				if(AUTO_SKILL_SYSTEM)
				{
					AddPartyExpChar(chr, "Defence", 50+Rand(100));
					AddPartyExpChar(chr, "Sneak", 50+Rand(100));	// LDH added 28Dec08
				}
				else
				{
					AddCharacterExp(chr, 50+Rand(100));
				}
				LAi_ApplyCharacterDamage(chr, 10);
				if (sti(LAi_GetCharacterHP(chr)) < 11) Lai_KillCharacter(chr);
				return;
			}
			if(lock < 66)
			// Fail to open the lock
			{
				if(CheckCharacterEquipByGroup(chr, LOCKPICK_ITEM_TYPE) != "")
				{
					PlaySound("AMBIENT\JAIL\chains.wav");
					Log_SetStringToLog(TranslateString("","You failed to open the lock with your lockpick. Better try again."));
				}
				else
				{
					PlaySound("AMBIENT\JAIL\jail_door1.wav");
					Log_SetStringToLog(TranslateString("","You try to pick the lock with your knife... in vain!"));
				}
				if(AUTO_SKILL_SYSTEM)
				{
					AddPartyExpChar(chr, "Defence", 50+Rand(100));
					AddPartyExpChar(chr, "Sneak", 50+Rand(100)); 	// LDH added 28Dec08
				}
				else
				{
					AddPartyExp(chr, 50+Rand(100));
				}
				return;
			}
			if(CheckCharacterEquipByGroup(chr, LOCKPICK_ITEM_TYPE) != "" && rand(100) < 10)
			// Lockpick fails
			{
				PlaySound("AMBIENT\JAIL\sigh.wav");			// Player sighs because his lockpick failed :-P
				TakeItemFromCharacter(chr,"lockpick");		// One lockpick is taken away
				Log_SetStringToLog(TranslateString("","Your lockpick broke and got stuck in the lock!"));
				Locations[locidx].jammed.(atrName) = true;	// The lock can't be opened anymore
				if(AUTO_SKILL_SYSTEM)
				{
					AddPartyExpChar(chr, "Defence", 50+Rand(100));
					AddPartyExpChar(chr, "Sneak", 50+Rand(100));	// LDH added 28Dec08
				}
				else
				{
					AddPartyExp(chr, 50+Rand(100));
				}
				return;
			}
			OpenLock = true;
		}

		if(OpenLock)
		{
			// PB: Treasure Quests -->
			if(chr.boxname == "treasure_box")
			{	
				LogIt(TranslateString("","You dig up a treasurechest"));
				PlaySound("AMBIENT\JAIL\jail_door2.wav");
				CloseQuestHeader("treasure");	// close the entry

				DeleteLocatorGlobal(chr.location, "box", "treasure_box");
				if(CheckAttribute(chr,"boxname")) { DeleteAttribute(chr,"boxname"); }
				Log_SetActiveAction("Nothing");
				BLI_RefreshCommandMenu();

				DeleteAttribute(chr, "required_item");
				DeleteAttribute(chr, "digging"));
				DeleteAttribute(chr, "treasureloc");
			}
			// PB: Treasure Quests <--

			if(REMEMBER_OPEN) Locations[locidx].openboxes.(atrName) = true;
			LaunchItemsBox(&ar);
		}
	}
	// PB: Rewritten <--
	if(FindLocation(chr.location)!=-1 && !sti(Interfacestates.Launched))//MAXIMUS: open corpse-box -->
	{
		int tmpi = sti(locations[FindLocation(chr.location)].locators.box.(atrName).corpseIdx);
		aref rootLocs; makearef(rootLocs, locations[FindLocation(chr.location)].locators);
		if(tmpi<0)
		{
			Log_SetStringToLog(TranslateString("","NoItems"));
			DeleteLocatorGlobal(chr.location, "box", atrName);
			if(CheckAttribute(GetMainCharacter(),"boxname")) { DeleteAttribute(GetMainCharacter(),"boxname"); }
			Log_SetActiveAction("Nothing");
			BLI_RefreshCommandMenu();
			return;
		}
		ref chCorpse = GetCharacter(tmpi);
		int bCorpseMode = CORPSEMODE;
		if(CheckAttribute(chCorpse,"CORPSEMODE") && sti(chCorpse.CORPSEMODE)==4) bCorpseMode = 4;
		if(bCorpseMode<4 && !IsEntity(chCorpse))
		{
			Log_SetStringToLog(TranslateString("","NoItems"));
			DeleteLocatorGlobal(chr.location, "box", atrName);
			if(CheckAttribute(GetMainCharacter(),"boxname")) { DeleteAttribute(GetMainCharacter(),"boxname"); }
			Log_SetActiveAction("Nothing");
			BLI_RefreshCommandMenu();
			return;
		}
		aref testItems;
		string itmName = "";
		int it;
		if(CheckAttribute(chCorpse,"dialog.filename") && chCorpse.dialog.filename=="Maltese_corpse_dialog.c")
		{
			chr.forcedlg = true;
			chCorpse.lootDialog = true;
			if(bCorpseMode==4)
			{
				ref tempChar = MalteseKnight();
				DialogMain(tempChar);
				Lai_SetActorType(tempChar);
				LAi_ActorTurnToCharacter(tempChar, GetMainCharacter());
				LAi_ActorAnimation(tempChar, "Bead", "", -1);
				LAi_CharacterLogoff(chCorpse);
				CharacterExitFromLocation(chCorpse);
			}
			else { Event("dlgReady","l", tmpi); }
			DeleteLocatorGlobal(chr.location, "box", atrName);
			if(CheckAttribute(chr,"boxname")) { DeleteAttribute(chr,"boxname"); }
			Log_SetActiveAction("Nothing");
			BLI_RefreshCommandMenu();
			DeleteAttribute(chCorpse,"lootDialog");
			if(CheckAttribute(chCorpse,"CORPSEMODE")) DeleteAttribute(chCorpse,"CORPSEMODE");
		}
		else
		{
			if(!CheckAttribute(chCorpse,"Money")) chCorpse.Money = 0;
			if(CheckAttribute(chCorpse,"Items.bladeX4")) { DeleteAttribute(chCorpse,"Items.bladeX4"); }
			makearef(testItems,chCorpse.items);
			for(it=0; it<GetAttributesNum(testItems); it++)
			{
				itmName = GetAttributeName(GetAttributeN(testItems,it));
				if(GetCharacterItem(chCorpse,itmName)==0) DeleteAttribute(chCorpse,"Items."+itmName);
			}
			if(GetAttributesNum(testItems)==0 && sti(chCorpse.Money)==0) Log_SetStringToLog(TranslateString("","NoItems"));
			else
			{
				PlaySound("OBJECTS\shipcharge\sail_damage1.wav");
				bDeadExchange = true;
				deadChr = chCorpse;
				if(IsCharacterEquipByGroup(chCorpse,BLADE_ITEM_TYPE)) { RemoveCharacterEquip(chCorpse, BLADE_ITEM_TYPE); }
				if(IsCharacterEquipByGroup(chCorpse,GUN_ITEM_TYPE)) { RemoveCharacterEquip(chCorpse, GUN_ITEM_TYPE); }
				if(IsCharacterEquipByGroup(chCorpse,ARMOR_ITEM_TYPE)) { RemoveCharacterEquip(chCorpse, ARMOR_ITEM_TYPE); }
				LaunchLootingScreen();
			}
			if(CheckAttribute(&Locations[FindLoadedLocation()],"building") || bCorpseMode < 3)
			{
				if(bCorpseMode!=4)
				{
					LAi_SetImmortal(chCorpse, false);
					ChangeCharacterAddressGroup(chCorpse, "None", "", "");
					PostEvent("RemoveCorpse", 100, "i", chCorpse);
				}
			}
			if(bCorpseMode==4) { RestoreCharacter(chCorpse); }
			if(CheckAttribute(GetMainCharacter(),"boxname")) { DeleteAttribute(GetMainCharacter(),"boxname"); }
			DeleteLocatorGlobal(chr.location, "box", atrName);
			Log_SetActiveAction("Nothing");
			BLI_RefreshCommandMenu();
		}
	}//MAXIMUS: open corpse-box <--
	//MAXIMUS: makes box from corpse with hand-icon in the top-left corner <--
}

void Box_OnLoadLocation(ref _location)
{
	string locatorName;
	aref boxLocator;
	int i;
	bool isAbordageBox = false;
	if (CheckAttribute(_location, "boarding"))
	{
		if (_location.boarding == "true")
		{
			isAbordageBox = true;
		}
	}

	// private box
	for (i=1; i < MAX_HANDLED_BOXES; i++)
	{
		locatorName = "private"+i;
		if (!FindLocator(_location.id, locatorName, &boxLocator, true))
		{
			break;
		}

		if (!CheckAttribute(_location, locatorName))
		{
			_location.(locatorName) = "";
			_location.(locatorName).open = true;
		}
	}

	// simple box
	for (i=1; i < MAX_HANDLED_BOXES; i++)
	{
		locatorName = "box"+i;
		if (!FindLocator(_location.id, locatorName, &boxLocator, true))
		{
			break;
		}

		// found box
		Box_FillBox(&_location, locatorName, isAbordageBox); // NK do the code in separate function. 05-05-04

	} //for(i)

	// LDH moved from below 09May09
// KK -->
	if (HasSubStr(_location.id, "Boarding_Cabin") == true && FindLocator(_location.id, "weaponslocker", &boxLocator, true) == true) {
		Box_FillBox(&_location, "weaponslocker", isAbordageBox);
	}
// <-- KK

// added by MAXIMUS [for gunpowder barrels] -->
	if (ENABLE_AMMOMOD) {	// LDH change
	// JRH fix oct 06: ammo in GunpowderStorage (own ship) is again generated in itemsbox, some of this below is not used - no changes here
		for (i=1; i < MAX_HANDLED_BOXES; i++)
		{
			locatorName = "gunpowder_"+i;
			if (!FindLocator(_location.id, locatorName, &boxLocator, true))
			{
				break;
			}
			// found box
			string itmID = GetRandSubString("powderflask,ammopouch,pistolbullets,pistolgrapes,musketbullets,pistol13,pistol14,pistolgrenade,pistolbbuss");//JRH moved out pb ab
			int itmIdx = GetItemIndex(itmID);
			int itmQty, ShCl;
			itmQty = 1;
			ShCl = makeint(GetCharacterShipClass(GetMainCharacter()));
			switch(itmID)// MAXIMUS 21.07.2006: moved here from itemsbox interface. if we have some amount of bullets, why should we change it by each open-box procedure?
			{
				case "pistolbullets": itmQty = 300*(8 - ShCl) + rand(100); break;
				case "pistolgrapes": itmQty = 75*(8 - ShCl) + rand(75); break;
				case "musketbullets": itmQty = 15*(8 - ShCl) + rand(15); break;
			}
			string locCur = Locations[FindLocation(_location.id)].filespath.models;
			string locBoard = strcut(locCur, 0, strlen(locCur)-2);
			if(locBoard!="locations\decks\udeck") itmQty = 0;
			if(itmIdx != -1)
			{
				_location.(locatorName).items.(itmID) = itmQty;
				if(bDeckStarted)
				{
					if(locatorName=="gunpowder_1")
					{
						_location.(locatorName).items.pistolbullets = 300*(8 - ShCl) + rand(100);
						_location.(locatorName).items.pistolgrapes = 75*(8 - ShCl) + rand(75);
						_location.(locatorName).items.musketbullets = 15*(8 - ShCl) + rand(15);
					}
				}
			}
			else _location.(locatorName).items.(itmID) = 0;
		}
	}
// added by MAXIMUS [for gunpowder barrels] <--

	// Screwface : transform some locators in random box or permanent box
	// NK do via switch 05-05-04
	switch(_location.id)
	{
		case "Hispaniola_Grot": locatorName = "randitem1";_location.(locatorName).open = true;return; break; //permanent chest
		case  "Roa_Grot": locatorName = "randitem1";_location.(locatorName).open = true;return; break;
		case  "Turks_Cavern_02": locatorName = "randitem1";_location.(locatorName).open = true;return; break;
		case  "Turks_shore_ship": locatorName = "randitem1";_location.(locatorName).open = true; return; break; //Box_FillBox(&_location, locatorName, isAbordageBox); return; break; //Section to make a random chest - NK call func 05-05-04
		case  "Hispaniola_Grot3": locatorName = "randitem1"; _location.(locatorName).open = true; return;break;
		case  "Cuba_Shore_01": locatorName = "randitem1"; _location.(locatorName).open = true; return;break;
		case  "Turks_Cave_Exit_02": locatorName = "Goto4"; _location.(locatorName).open = true; return;break;
		case  "Cayman_Grot_01": locatorName = "randitem1"; _location.(locatorName).open = true; return;break;
		case  "Cayman_Grot_02": locatorName = "randitem4"; _location.(locatorName).open = true; return;break;
		case  "Guadeloupe_Lighthouse": locatorName = "randitem1"; _location.(locatorName).open = true; return;break;
		case  "Oxbay_Jungle_02": locatorName = "citizen04"; _location.(locatorName).open = true; return;break;
		case  "Dungeon 1": locatorName = "randitem1"; _location.(locatorName).open = true; return;break;
		case  "Conceicao_Grot": locatorName = "randitem1"; _location.(locatorName).open = true; return;break;
		case  "Hispaniola_shore_02": locatorName = "citizen04"; _location.(locatorName).open = true; return;break;
	}
}

// NK 05-05-04 made this separate function, not just inside Box_OnLoadLocation()
// that way ScrewFace can call it rather than duplicating the code.
void Box_FillBox(ref _location, string locatorName, bool isAbordageBox)
{
	// LDH 30Apr09
	// make your ship's chests lootable only once per day.
	// unfortunately, this makes ALL your ships' crew cabin boxes, for example, lootable only once per day.
	int SpawnTime = SPAWN_TIME;
	if (ownDeckStarted())
	{
		SpawnTime = 20;		// 20 hours, so you can loot your own ship once per day at the same time every day
		isAbordageBox = false;
	}

	bool needRespawn;
	if (!CheckAttribute(_location, (locatorName)))
	{
		needRespawn = true;
		_location.(locatorName) = Items_MakeTime(GetTime(), GetDataDay(), GetDataMonth(), GetDataYear());
	}
	else
	{
		// LDH 30Apr09
		if ((sti(_location.(locatorName)) + SpawnTime) < Items_MakeTime(GetTime(), GetDataDay(), GetDataMonth(), GetDataYear()))
		{
			needRespawn = true;
			_location.(locatorName) = Items_MakeTime(GetTime(), GetDataDay(), GetDataMonth(), GetDataYear());
		}
		else
		{
			needRespawn = false;
		}
	}

	//respawn items in box
	if (needRespawn || isAbordageBox)
	{
		//clear items in box
		if (CheckAttribute(_location, locatorName))
		{
			aref boxRef;
			makearef(boxRef, _location.(locatorName));
			if (CheckAttribute(boxRef, "items"))
			{
				aref boxItems;
				makearef(boxItems, boxRef.items);
				DeleteAttribute(boxItems,  "");
				/*for (int k=0; k<GetAttributesNum(boxItems);k++)
				{
					string boxItemName = GetAttributeName(boxItems, k);
					DeleteAttribute(boxItems, boxItemName);
				}*/

			}
		}

		//fill box with new items
		string goodItemName;
		int spawnItemsCount = OBJECTS_IN_BOX;
		ref chr = GetMainCharacter();
		spawnItemsCount = spawnItemsCount + spawnItemsCount * makefloat(GetCharacterSkill(chr,SKILL_SNEAK)) / 10.0; // NK

		if(_location.id=="Greenford_M_crypt")	spawnItemsCount = spawnItemsCount +40;	// ccc Nov05 Greater Oxbay // PB

	//JRH empty boxes -->
		if(_location.id=="Swamp_grot")spawnItemsCount = 0;
		if(_location.id=="swamp_wreck_inside")spawnItemsCount = 0;
		if(_location.id=="Loghouse")spawnItemsCount = 0;
		if(_location.id=="QC_shipyard2_JRH")spawnItemsCount = 0;
		if(_location.id=="QC_store_bedroom")spawnItemsCount = 0;
		if(_location.id=="wr_residence")spawnItemsCount = 0;
		if(_location.id=="wr_kitchen")spawnItemsCount = 0;
		if(_location.id=="wr_food_supply")spawnItemsCount = 0;
		if(_location.id=="wr_armory")spawnItemsCount = 0;
		if(_location.id=="wr_gunpowder")spawnItemsCount = 0;
		if(_location.id=="wr_shop")spawnItemsCount = 0;
		if(_location.id=="loanshark_cellar")spawnItemsCount = 0;
		if(_location.id=="wr_crew")spawnItemsCount = 0;
		if(_location.id=="wr_library")spawnItemsCount = 0;
		if(_location.id=="wr_study")spawnItemsCount = 0;
		if(_location.id=="wr_secret")spawnItemsCount = 0;
		if(_location.id=="wr_prison")spawnItemsCount = 0;
		if(_location.id=="wr_shop_office")spawnItemsCount = 0;
		if(_location.id=="wr_mother")spawnItemsCount = 0;
		if(_location.id=="Dave_Edna_room")spawnItemsCount = 0;
		if(_location.id=="Redmond_shipyard")spawnItemsCount = 0;
		if(_location.id=="wr_cannon_tower")spawnItemsCount = 0;
		if(_location.id=="wr_cavern")spawnItemsCount = 0;		//if coins etc
		if(_location.id=="wr_animists")spawnItemsCount = 0;
		if(_location.id=="wr_gall_galley")spawnItemsCount = 0;
		if(_location.id=="wr_corv_smallcabin_R")spawnItemsCount = 0;
		if(_location.id=="wr_gall_cap_inner")spawnItemsCount = 0;
		if(_location.id=="wr_corv_crew")spawnItemsCount = 0;
		if(_location.id=="wr_corv_capmd")spawnItemsCount = 0;
		if(_location.id=="wr_gall_captain")spawnItemsCount = 0;
		if(_location.id=="Defoes_cabin")spawnItemsCount = 0;
		if(_location.id=="wr_farm_booty")spawnItemsCount = 0;
		if(_location.id=="wr_farm_bedroom")spawnItemsCount = 0;
		if(_location.id=="wr_farm_servant")spawnItemsCount = 0;
		if(_location.id=="wr_farm_alchemy")spawnItemsCount = 0;
		if(_location.id=="church_wine_cellar")spawnItemsCount = 0;
		if(_location.id=="church_choir")spawnItemsCount = 0;
		if(_location.id=="wr_church_inside")spawnItemsCount = 0;
		if(_location.id=="wr_wood_tower2")spawnItemsCount = 0;
		if(_location.id=="wr_bedroom")spawnItemsCount = 0;
		if(_location.id=="stonehouse_inside")spawnItemsCount = 0;
		if(_location.id=="wr_church_attic_stairs")spawnItemsCount = 0;
	//<-- JRH

		for (int j = 0; j < spawnItemsCount; j++) {
			if (needRespawn || isAbordageBox)
			{
				string itemID;
				if (SpawnItem(chr, &itemID,isAbordageBox,makefloat(GetCharacterSkill(chr,SKILL_SNEAK)))) // NK
				{
// KK -->
					if (locatorName == "weaponslocker") {
						while (true) {
							int itemidx = GetItemIndex(itemID);
							if (itemidx != -1) {
								if (CheckAttribute(&Items[itemidx], "groupID") == true) {
									if (Items[itemidx].groupID == BLADE_ITEM_TYPE || Items[itemidx].groupID == GUN_ITEM_TYPE || Items[itemidx].groupID == ARMOR_ITEM_TYPE) break;
								}
							}
							if (SpawnItem(chr, &itemID,isAbordageBox,makefloat(GetCharacterSkill(chr,SKILL_SNEAK)))) continue;
						}
					}
// <-- KK
					if (CheckAttribute(_location, locatorName+".items."+itemID))
					{
						_location.(locatorName).items.(itemID) = sti(_location.(locatorName).items.(itemID)) + 1;
					}
					else
					{
						_location.(locatorName).items.(itemID) = 1;
					}
				}
			}
		}
	}//respawn
}

bool SpawnItem(ref _chr, ref _id, bool isAbordageBox, float luck)
{
  float rarity;
  int currentPeriod = GetCurrentPeriod();
	if(RANDITEMS_QUANTITY < 1) return false; // NK
	int i = rand(RANDITEMS_QUANTITY-1);
	int chrRank = sti(_chr.rank);
	if ( IT_RPG_STYLE ) chrRank += roundup(luck / 2);// TIH rpg_style only - add luck to this Jul25'06
	int itemRank = 0;
	aref randItem;

	if (Items_FindItem(RandItems[i].id, &randItem) == -1)
	{
		return SpawnAnotherItemChance(&_chr, &_id, isAbordageBox, luck, &randItem);
	}
	if (CheckAttribute(randItem, "minLevel"))
	{
		itemRank = sti(randItem.minLevel);
	}
	if (itemRank > chrRank)
	{
		return SpawnAnotherItemChance(&_chr, &_id, isAbordageBox, luck, &randItem);
	}
  // Sulan: weapons periods -->
  if (CheckAttribute(randItem, "firstperiod") && CheckAttribute(randItem, "lastperiod"))
	{
	  // item is not yet available
		if(currentPeriod  < sti(randItem.firstperiod)) return SpawnAnotherItemChance(&_chr, &_id, isAbordageBox, luck, &randItem);
		// item is available no more
    if(currentPeriod  > sti(randItem.lastperiod)) return SpawnAnotherItemChance(&_chr, &_id, isAbordageBox, luck, &randItem);
	}
  // <-- Sulan: weapons periods

  // Sulan: Improved rarity code -->
 	float itemProb = 0.03; // default: 3% chance for items without rarity
	if (CheckAttribute(randItem, "rare"))		itemProb = stf(randItem.rare);
	if(itemProb == 0.0) return SpawnAnotherItemChance(&_chr, &_id, isAbordageBox, luck, &randItem); // unique items
	if (isAbordageBox)
  {
    if (CheckAttribute(randItem, "skiprand"))
	  {
	    // if item should not appear at random
		  if(randItem.skiprand == true) return SpawnAnotherItemChance(&_chr, &_id, isAbordageBox, luck, &randItem);
	  }
	}
  rarity=frand(1);
  trace("trying to spawn item: "+randItem.id+" with rarity="+rarity+" itemProb="+itemProb*ModItemQtyPlayer());
  if(itemProb*ModItemQtyPlayer()<=rarity) return SpawnAnotherItemChance(&_chr, &_id, isAbordageBox, luck, &randItem);
  // <-- Sulan: Improved rarity code
	// NK -->
	_id = randItem.id; return true;
	// TIH --> fixed to prevent endless loop chance (thats bad) Aug24'06
	// forces it to no higher than .5 chance (in case someone sets it to 1.0 in IS.h !!!)
	// TIH <--
	// NK <-- return true;
}

bool SpawnAnotherItemChance(ref _chr, ref _id, bool isAbordageBox, float luck, aref randItem)
{
	int noSkipChance = RAND_ITEM_NOSKIP;
	if(RAND_ITEM_NOSKIP > 0.5) noSkipChance = 0.5;
	if(frnd() > noSkipChance && !CheckAttribute(randItem,"groupID")) { return false; }
	else { return SpawnItem(&_chr, &_id, isAbordageBox, luck); }
}

bool SpawnItemOrg(ref _chr, ref _id, bool isAbordageBox, float luck)
{
  float rarity;
  int currentPeriod = GetCurrentPeriod();
	if(RANDITEMS_QUANTITY < 1) return false; // NK
	int i = rand(RANDITEMS_QUANTITY-1);
	int chrRank = sti(_chr.rank);
	if ( IT_RPG_STYLE ) chrRank += roundup(luck / 2);// TIH rpg_style only - add luck to this Jul25'06
	int itemRank = 0;
	aref randItem;
	bool ok = true; // NK
	if (Items_FindItem(RandItems[i].id, &randItem) == -1)
	{
		ok = false; // NK - return false;
	}
	if (CheckAttribute(randItem, "minLevel"))
	{
		itemRank = sti(randItem.minLevel);
	}
	if (itemRank > chrRank)
	{
		ok = false; //NK - return false;
	}
  // Sulan: Historic Weapons -->
  if (CheckAttribute(randItem, "firstperiod") && CheckAttribute(randItem, "lastperiod"))
	{
		if(currentPeriod  < sti(randItem.firstperiod)) ok=false; // item is not yet available
		if(currentPeriod  > sti(randItem.lastperiod)) ok=false;  // item is available no more
	}
  // <-- Sulan: Historic Weapons

  // Sulan: Improved rarity code -->
 	float itemProb = 0.03; // default: 3% chance for items without rarity
	if (CheckAttribute(randItem, "rare"))		itemProb = stf(randItem.rare);
	if(itemProb == 0.0) ok = false; // unique items
	if (isAbordageBox)
  {
    if (CheckAttribute(randItem, "skiprand"))
	  {
		  if(randItem.skiprand == true) ok = false;  // if item should not appear at random
	  }
	}
  rarity=frand(1);
  if(itemProb*ModItemQtyPlayer()<=rarity) ok = false;
  // <-- Sulan: Improved rarity code

  trace("trying to spawn item: "+randItem.id+" with ok = "+ok+" rarity="+rarity+" itemProb="+itemProb*ModItemQtyPlayer());

	// NK -->
	if(ok) { _id = randItem.id; return true; }
	// TIH --> fixed to prevent endless loop chance (thats bad) Aug24'06
	// forces it to no higher than .5 chance (in case someone sets it to 1.0 in IS.h !!!)
		int noSkipChance = RAND_ITEM_NOSKIP;
	  if(RAND_ITEM_NOSKIP > 0.5) noSkipChance = 0.5;
	  if(frnd() > noSkipChance && !CheckAttribute(randItem,"groupID")) { return false; }
	  else { return SpawnItem(&_chr, &_id, isAbordageBox, luck); }
	// TIH <--
	// NK <-- return true;
}